unit resources;

interface

resourcestring
  cpClear = 'Clear report';
  cpConnect = 'Connect';
  cpData = 'Verify data values';
  cpDisconnect = 'Disconnect';
  cpExit = 'Exit';
  cpSQLScript = 'Generate SQL insert script';
  cpExportSubset = 'Export subset database';
  cpImport = 'Import database';
  cpMaster = 'GlobalDB System -- Database Verification and Maintenance Tools';
  cpMetadata = 'Compare metadata against master';
  cpReldate = 'Set database release date';
  cpReport = 'Save report';
  cpSchema = 'Verify schema conformity';
  cpSetCaptionLanguage = 'Set caption language';
  cpSummary = 'Build summary tables';
  cpVersion = 'Verify database version';
  fsComparing = 'Comparing %s against master database ...';
  fsDatabaseVersionFound = 'Database version: %s';
  fsEmptyRecord = 'Data table "%s" (%s) is an empty record';
  fsErrorsFound = 'Errors found: %d';
  fsExtrasFound = 'Extras found: %d';
  fsExtraneousRefx = 'Looking for extraneous %s records ...';
  fsForeignKeyProblem = 'Detail table "%s", field "%s", master table "%s", ' +
                        'field "%s": foreign key problem.';
  fsFoundExtraneousRefx = 'Table "%s" (%s,%s,%s) mismatches with REFNO in %s.';
  fsFoundExtraColumndoc = 'Found extra record in table "columndoc": %s,%s';
  fsFoundExtraEntities = 'Found extra record in table "entities": %s,%s';
  fsFoundExtraLinks = 'Found extra record in table "links": %s';
  fsFoundExtraTabledoc = 'Found extra record in table "tabledoc": %s';
  fsFoundGaps = 'Table "%s" (%s): there are gaps in numbering.';
  fsInvalidValues = 'Table "%s", field "%s": there are invalid values.';
  fsLookupValues = 'Table "%s", field "%s" contains values not found in "%s".';
  fsMismatchColumndoc = 'Mismatch of columndoc.%s for field "%s.%s", master: %s / target: %s';
  fsMismatchEntities = 'Mismatch of entities.%s for entity "%s", master: %s / target: %s';
  fsMismatchFieldPosition = 'Mismatch %s.%s at position %d, expected field "%s", found field "%s".';
  fsMismatchFieldSize = 'Mismatch %s.%s, expected field size "%d", found "%d".';
  fsMismatchFieldType = 'Mismatch %s.%s, expected field type "%s", found "%s".';
  fsMismatchLinks = 'Mismatch of links.%s for relationship "%s", master: %s / target: %s';
  fsMismatchSrctp = 'Table "%s" (%s) mismatches with SRCTP ("%s") in refmain.';
  fsMismatchTabledoc = 'Mismatch of tabledoc.%s for table "%s", master: %s / target: %s';
  fsMissingEntityRank = 'Missing entities.ENTITY "%s" / entities.RANK "%s" from target';
  fsMissingField = 'Field "%s" is missing from table "%s".';
  fsMissingLink = 'Relationship "%s" is missing from database.';
  fsMissingPrimaryKey = 'Table "%s" is missing index "PrimaryKey", found "%s".';
  fsMissingTable = 'Table "%s" is missing from database.';
  fsMissingTablename = 'Missing tabledoc.TABLENAME "%s" from target';
  fsMissingTablenameFieldname = 'Missing columndoc.TABLENAME "%s" / columndoc.FIELDNAME "%s" from target';
  fsNullValues = 'Table "%s", field(s) "%s": there are NULL values.';
  fsProblemFieldOrder = 'Problems with columndoc.FIELDORDER for tables "%s".';
  fsProblemFieldSize = 'Problems with columndoc.FIELDSIZE for tables "%s".';
  fsProblemKeyFields = 'Mismatch tabledoc.KEYFIELDS for table "%s", expected key fields "%s", found "%s".';
  fsRecordsAdded = 'Added %d records to %s.';
  fsRecordsAffected = 'Records affected: %d in %d tables.';
  fsRecordsExported = 'Records exported: %d.';
  fsSetReldateTo = 'Setting RELDATE to "%s" ...';
  fsSetReldateWarning = 'Value of RELDATE will be set to "%s".';
  fsTooFewFields = 'Table "%s" has too few fields.';
  fsValuesNotUnique = 'Table "%s", field(s) "%s":  value(s) not unique.';
  fsVerifyDateTime = 'GlobalDB System -- Database verification (%s)';
  htData = 'Verify data values: verifies data values of the database (primary ' +
           'key values, data values not found in corresponding lookup tables, ' +
           'problems with foreign keys, orphaned reference detail records, empty ' +
           'records, gaps in detail record numbering and extraneous reference ' +
           'detail records).';
  htExportSubset = 'Export subset database: produces a subset database from the currently ' +
                   'connected database using a file of DGNO or DEPNO values.';
  htSQLScript = 'Generate SQL insert script: generates SQL insert statements necessary to ' +
                'populate a server based database and saves the script to a file.';
  htImport = 'Import database: imports entire content of a GlobalDB database into the one ' +
             'that is currently connected.';
  htMetadata = 'Compare metadata against master: compares tables "tabledoc" and "columndoc" ' +
               'against a standard (such as the seed GlobalDB empty database).';
  htReldate = 'Set database release date: sets release date for every record in the database.';
  htSchema = 'Verify schema conformity: verifies primary key fields for each table ' +
             'defined in "tabledoc", that each field defined in table "columndoc" ' +
             'is present in the database and that its characteristics (field type, ' +
             'size and position) correspond to the GlobalDB standard.';
  htSetCaptionLanguage = 'Sets values of ECAPTION to English in tabledoc and columndoc.';
  htSummary = 'Build summary tables: builds or rebuilds the summary tables used by GQuery.';
  htVersion = 'Verify database version: looks for the occurrence of string "3.19", ' +
              '"3.20" or "3.21" in field dbversion.DBREL. This is required by GQuery.';
  msBuildSummaryTables = 'Build or rebuild summary tables?';
  msBuildingSummaryTables = 'Building and populating summary tables ...';
  msConformity = 'Verifying conformity of database schema to metadata ...';
  msCreateExportDatabaseRelationships = 'Creating relationships ...';
  msCreateExportDatabaseTablesAndFields = 'Creating tables and fields ...';
  msDatabaseVersion = 'Looking for database version ...';
  msDatabaseVersionNotFound = 'Database version string is missing from dbversion.DBREL';
  msEmptyDatabase = 'Verifying that target database for export is empty ...';
  msEmptyRecords = 'Looking for empty records ...';
  msExportDatabaseNotEmpty = 'Target database for export is not empty.  Operation cancelled.';
  msExportingSubset = 'Exporting subset of current database ...';
  msExporting = 'Exporting data to SQL script ...';
  msExportSubsetCompactDatabase = 'After this operation, you should compact the database.';
  msExportSubsetCompleted = 'Export operation completed.';
  msExportSubsetDeleteExtraRecords = 'Deleting excess records ...';
  msExportSubsetWarning1 = 'A subset database will be created by deleting from the current' + chr(10) +
                           'database all records whose values of %s are not in the key' + chr(10) +
                           'values file.' + chr(10) + chr(10) +
                           'WARNING: the deleted records cannot be recovered.  If you' + chr(10) +
                           'do not have a backup copy of this database, click Cancel' + chr(10) +
                           'now!  If you wish to proceed, click OK.';
  msExportSubsetWarning2 = 'If you really want to continue, click OK, otherwise, click Cancel!';
  msFieldOrder = 'Verifying columndoc.FIELDORDER for invalid values ...';
  msFieldSize = 'Verifying columndoc.FIELDSIZE for missing values ...';
  msFixFieldOrder = 'Cannot proceed with conformity test until columndoc.FIELDORDER problems are fixed!';
  msFixFieldSize = 'Cannot proceed with conformity test until columndoc.FIELDSIZE problems are fixed!';
  msFixKeyFields = 'Cannot proceed with conformity test until primary key problems are fixed!';
  msImporting = 'Merging source database into current database ...';
  msIntroLine1 = 'This software tool is designed to help guarantee the conformity ' +
                 'of a database to the GlobalDB System schema and that data values are valid.';
  msIntroLine2 = 'The buttons on the left make the following verifications:';
  msKeyFields = 'Verifying primary keys against tabledoc.KEYFIELDS ...';
  msKeyValuesFile = 'Getting key values for export database...';
  msKeyValuesFileError = 'Key values file is missing or not usable!';
  msLookingForGaps = 'Looking for gaps in RANK sequences ...';
  msMergeCompleted = 'Import operation completed.';
  msMODULEX = '==> As soon as possible, rename field "MODULEX" to "MODULE" in table "tabpages".';
  msOpenExportSubsetDatabase = 'Open database to be populated';
  msOpenKeyValuesFile = 'Open key values file';
  msOpenMasterDatabase = 'Open master database';
  msOpenSourceDatabase = 'Open source database';
  msOpenTargetDatabase = 'Open database';
  msOperationCancelled = 'Operation cancelled.';
  msOverlappingKeyValues = 'Cannot proceed as there are overlapping primary key values!';
  msSaveSQLScript = 'Save SQL insert script';
  msSetReldate = 'Setting RELDATE ...';
  msSettingCaptions = 'Setting ECAPTION to English ...';
  msSettingCaptionsCompleted = 'Operation completed.';
  msSummaryTablesBuilt = 'The summary tables have been (re)built.';
  msSymprefno = 'Table "symsrc", field "SYMPREFNO": there are NULL entries.';
  msVerifyForeignKeys = 'Verifying foreign keys ...';
  msVerifyLookupValues = 'Verifying lookup values ...';
  msVerifyPrimaryKeys = 'Verifying primary key values ...';
  msVerifyReferenceSource = 'Verifying reference source type ...';
  msVerifyValidValues = 'Verifying valid values ...';

implementation

end.
