unit seldb;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, DBTables;

type
  TfmSelectDB = class(TForm)
    lbAlias: TListBox;
    buSelect: TButton;
    buAbort: TButton;
    OpenDialog1: TOpenDialog;
    procedure buSelectClick(Sender: TObject);
//    procedure buAbortClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    DatabaseUDL: string;
  public
    procedure FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
    { Public declarations }
  end;

var
  fmSelectDB: TfmSelectDB;

implementation

uses dmglob1, mastform, dmglob2, resources;

{$R *.DFM}

procedure TfmSelectDB.FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
begin
  Top := ParentTop + Trunc((ParentHeight - Height)/2);
  Left := ParentLeft + Trunc((ParentWidth - Width)/2);
end;

procedure TfmSelectDB.buSelectClick(Sender: TObject);
begin
  with dmGlobalS.Database1 do
    begin
      Connected := False;
      ConnectionString := 'File Name=' + lbAlias.Items[lbAlias.ItemIndex];
      if AnsiUpperCase(Copy(lbAlias.Items[lbAlias.ItemIndex],1,6)) = 'GLOBAL'
        then DatabaseUDL := DatabaseUDL + '\' + lbAlias.Items[lbAlias.ItemIndex]
        else DatabaseUDL := OpenDialog1.FileName;
      Connected := True;
      if AnsiPos('Microsoft.Jet.OLEDB.4.0',ConnectionString) > 0 then
        fmMaster.AliasDriver := 'MSACCESS';
    end; // with
  Close;
end;

{
procedure TfmSelectDB.buAbortClick(Sender: TObject);
begin
  dmGlobalS.Database1.ConnectionString := '';
  Close;
end;
}

procedure TfmSelectDB.FormShow(Sender: TObject);
var
  d  : string;
  sr : TSearchRec;
begin
  Self.Caption := seldb_fmSelectDB;
  buSelect.Caption := seldb_buSelect;
  buAbort.Caption := seldb_buAbort;

  GetDir(0,d);
  DatabaseUDL := d;
  if FindFirst(d + '\*.udl',faAnyFile,sr) = 0 then
    begin
      if AnsiLowerCase(copy(sr.Name,1,6)) = 'global' then
        lbAlias.Items.Add(sr.Name);
      while FindNext(sr) = 0 do
        if AnsiLowerCase(copy(sr.Name,1,6)) = 'global' then
          lbAlias.Items.Add(sr.Name);
      FindClose(sr);
    end;
  lbAlias.ItemIndex := 0;
  buSelect.Enabled := lbAlias.Items.Count > 0;
  if lbAlias.Items.Count = 0 then
    begin
      with dmGlobalS.Database1 do
        begin
          Connected := False;
          if OpenDialog1.Execute then
            begin
              lbAlias.Items.Add(OpenDialog1.FileName);
              lbAlias.ItemIndex := lbAlias.Items.IndexOf(OpenDialog1.FileName);
              buSelect.Enabled := True;
            end;
        end; // with
    end;
end;

end.
