unit dmquery1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Contnrs, DB, DBClient, Variants;

type
  TdmQuery = class(TDataModule)
    dsQSummary: TDataSource;
    dsConditionTable: TDataSource;
    dsAgetsma: TDataSource;
    cdsAgetsma: TClientDataSet;
    cdsAgetsmaAGECOMBO: TStringField;
    cdsAgetsmaSTARTMA: TFloatField;
    cdsAgetsmaENDMA: TFloatField;
    cdsEntities: TClientDataSet;
    cdsEntitiesENTITY: TStringField;
    cdsEntitiesRANK: TIntegerField;
    cdsEntitiesTABLENAME: TStringField;
    cdsEntitiesTABLEGROUP: TStringField;
    cdsEntitiesEDATA: TStringField;
    cdsEntitiesECAPTION: TStringField;
    cdsColumndoc: TClientDataSet;
    cdsColumndocTABLENAME: TStringField;
    cdsColumndocFIELDNAME: TStringField;
    cdsColumndocECAPTION: TStringField;
    cdsColumndocFIELDTYPE: TStringField;
    cdsColumndocFIELDORDER: TIntegerField;
    cdsColumndocTSEARCH: TStringField;
    cdsColumndocTREPORT: TBooleanField;
    dsColumndoc: TDataSource;
    cdsTabledoc: TClientDataSet;
    cdsTabledocTABLENAME: TStringField;
    cdsTabledocECAPTION: TStringField;
    cdsTabledocTABLETYPE: TStringField;
    cdsTabledocTABLEGROUP: TStringField;
    cdsTabledocTABLEPARENT: TStringField;
    cdsTabledocKEYFIELDS: TStringField;
    cdsTabledocTABLEORDER: TIntegerField;
    cdsTabledocTSEARCH: TStringField;
    cdsTabledocRECORDCOUNT: TIntegerField;
    cdsTabledocRANKED: TBooleanField;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
    procedure dsQSummaryDataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
    AgeTables: TStringList;
    procedure LoadCaptions;
  public
    { Public declarations }
    n_selected : longint;
    cdsAgeTables: TComponentList;
    cdsSummary: TClientDataSet;
    cdsQSummary: TClientDataSet;
    { Captions for English-Spanish HTML pages }
    GQ_DESCRIPTION: string;
    GQ_DGSELECTED: string;
    GQ_DPSELECTED: string;
    GQ_DGNO: string;
    GQ_DEPNO: string;
    GQ_DPNAMES: string;
    GQ_DGNAMES: string;
    GQ_LONGLAT: string;
    GQ_COUNTRY: string;
    GQ_LOCATION: string;
    GQ_ALLNAMES: string;
    GQ_COMMODITIES: string;
    GQ_ASSOCIATEDDP: string;
    GQ_ASSOCIATEDDG: string;
    GQ_ASSOCIATEDMN: string;
    GQ_REFERENCES: string;
    GQ_PRODUCTIONDATA: string;
    GQ_RESOURCEDATA: string;
    GQ_ADDRESOURCES: string;
    GQ_ALSOCONTAINING: string;
    GQ_DISKS: string;
    GQ_EDITEDBY: string;
    GQ_EDITORS: string;
    GQ_ESTIMATEDATE: string;
    GQ_FROM: string;
    GQ_IN: string;
    GQ_ISSUE: string;
    GQ_MAPS: string;
    GQ_NONAME: string;
    GQ_PUBLICATIONCODE: string;
    GQ_RELDATE: string;
    GQ_REPORTPERIOD: string;
    GQ_SCALE: string;
    GQ_SECTION: string;
    GQ_SYMPOSIUMVOLUME: string;
    GQ_UNTIL: string;
    GQ_VOLUME: string;
    GQ_YES: string;
    { End of Captions }
    procedure AddAgeTable(s: string);
    function AgeTableExists(s: string): boolean;
    function AgeTableIndex(s: string): integer;
    procedure CPD_SummaryTable(entity: string);
    procedure DeleteAgeTable(s: string);
    procedure DeleteAgeTables;
    procedure PopulateQSummary(cdsSource: TClientDataSet);
  end;

var
  dmQuery    : TdmQuery;
  n_total    : longint;

implementation

uses dmglob1, startinf, mastform, resources;

{$R *.DFM}

procedure TdmQuery.AddAgeTable(s: string);
begin
  AgeTables.Add(s);
end;

function TdmQuery.AgeTableExists(s: string): boolean;
begin
  Result := AgeTables.IndexOf(s) >= 0;
end;

function TdmQuery.AgeTableIndex(s: string): integer;
begin
  Result := AgeTables.IndexOf(s);
end;

procedure TdmQuery.CPD_SummaryTable(entity: string);
// create, populate and display summary table
var
  tmpCursor : TCursor;
//  ExcludedFields : string;
  i : integer;
begin
  tmpCursor := Screen.Cursor;
  Screen.Cursor := crSQLWait;
  // create summary client dataset
  cdsSummary := TClientDataSet.Create(Self);
  with cdsSummary do
    begin
      FieldDefs.Add(e_key,ftInteger,0,True);
      FieldDefs.Add('COUNTRY',ftString,35,False);
      FieldDefs.Add('LOCATION',ftString,30,False);
      FieldDefs.Add('ALLNAMES',ftString,200,False);
      FieldDefs.Add('COMMODITIES',ftString,100,False);
      FieldDefs.Add('DEPCLAN',ftString,50,False);
      FieldDefs.Add('LONGDD',ftFloat,0,False);
      FieldDefs.Add('LATDD',ftFloat,0,False);
      FieldDefs.Add('DBNAME',ftString,100,False);
      FieldDefs.Add('COMPBY',ftString,200,False);
      FieldDefs.Add('RELDATE',ftString,10,False);
      IndexFieldNames := e_key;
      CreateDataSet;
    end;

  // create QSummary client dataset
  cdsQSummary := TClientDataSet.Create(Self);
  with cdsQSummary do
    begin
      for i := 0 to cdsSummary.FieldDefs.Count - 1 do
        with FieldDefs.AddFieldDef do
          begin
            Name := cdsSummary.FieldDefs.Items[i].Name;
            DataType := cdsSummary.FieldDefs.Items[i].DataType;
            Size := cdsSummary.FieldDefs.Items[i].Size;
          end;
      CreateDataSet;
    end;

  // get keyno and location from main table
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select * from ' + entity + '_summary';
      Open;
      n_total := RecordCount;
      n_selected := n_total;
      fmStartInfo.pbInfo.Min := 0;
      fmStartInfo.pbInfo.Step := 1;
      fmStartInfo.pbInfo.Max := n_total;
      fmStartInfo.Label1.Caption := dmquery1_PopulatingSummaryTable;
      fmStartInfo.Update;
    end;
  cdsSummary.Open;
  while not dmGlobalC.FindStuff.EOF do
    begin
      with cdsSummary do
        begin
          Append;
          FieldByName(e_key).Value := dmGlobalC.FindStuff.FieldByName(e_key).Value;
          FieldByName('COUNTRY').Value := dmGlobalC.FindStuff.FieldByName('COUNTRY').Value;
          FieldByName('LOCATION').Value := dmGlobalC.FindStuff.FieldByName('LOCATION').Value;
          FieldByName('ALLNAMES').Value := dmGlobalC.FindStuff.FieldByName('ALLNAMES').Value;
          FieldByName('COMMODITIES').Value := dmGlobalC.FindStuff.FieldByName('COMMODITIES').Value;
          FieldByName('DEPCLAN').Value := dmGlobalC.FindStuff.FieldByName('DEPCLAN').Value;
          FieldByName('LONGDD').Value := dmGlobalC.FindStuff.FieldByName('LONGDD').Value;
          FieldByName('LATDD').Value := dmGlobalC.FindStuff.FieldByName('LATDD').Value;
//          FieldByName('DBNAME').Value := dmGlobalC.FindStuff.FieldByName('DBNAME').Value;
          FieldByName('DBNAME').Value := mastform.dbname;
          FieldByName('COMPBY').Value := dmGlobalC.FindStuff.FieldByName('COMPBY').Value;
          FieldByName('RELDATE').Value := dmGlobalC.FindStuff.FieldByName('RELDATE').Value;
          fmStartInfo.pbInfo.StepIt;
          Post;
        end;
      dmGlobalC.FindStuff.Next;
  end;
  cdsSummary.Close;
  dmGlobalC.FindStuff.Close;

  // gather metadata
  fmStartInfo.Label1.Caption := dmquery1_GatheringMetadata;
  fmStartInfo.Update;

  // populate entities table
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select ENTITY,RANK,TABLENAME,TABLEGROUP,EDATA,ECAPTION ' +
                     'from entities';
      Open;
      cdsEntities.Open;
      cdsEntities.EmptyDataSet;
      while not EOF do
        begin
          with cdsEntities do
            begin
              Append;
              FieldByName('ENTITY').Value := dmGlobalC.FindStuff.FieldByName('ENTITY').Value;
              FieldByName('RANK').Value := dmGlobalC.FindStuff.FieldByName('RANK').Value;
              FieldByName('TABLENAME').Value := dmGlobalC.FindStuff.FieldByName('TABLENAME').Value;
              FieldByName('TABLEGROUP').Value := dmGlobalC.FindStuff.FieldByName('TABLEGROUP').Value;
              FieldByName('EDATA').Value := dmGlobalC.FindStuff.FieldByName('EDATA').Value;
              FieldByName('ECAPTION').Value := dmGlobalC.FindStuff.FieldByName('ECAPTION').Value;
              Post;
            end;
          Next;
        end;
      cdsEntities.Close;
      Close;
    end;

  // populate tabledoc table
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select tabledoc.TABLENAME,ECAPTION,TABLETYPE,TABLEGROUP,TABLEPARENT,' +
                     'KEYFIELDS,TABLEORDER,TSEARCH,ORDERED,RECORDCOUNT ' +
                     'from tabledoc inner join gq_recordcount ' +
                     'on tabledoc.TABLENAME=gq_recordcount.TABLENAME ' +
                     'where TABLETYPE <> ''Lookup''';
      Open;
      fmStartInfo.pbInfo.Min := 0;
      fmStartInfo.pbInfo.Step := 1;
      fmStartInfo.pbInfo.Max := RecordCount;
      fmStartInfo.pbInfo.Position := 0;
      cdsTabledoc.Open;
      cdsTabledoc.EmptyDataSet;
      while not EOF do
        begin
          with cdsTabledoc do
            begin
              Append;
              FieldByName('TABLENAME').Value := dmGlobalC.FindStuff.FieldByName('TABLENAME').Value;
              FieldByName('ECAPTION').Value := dmGlobalC.FindStuff.FieldByName('ECAPTION').Value;
              FieldByName('TABLETYPE').Value := dmGlobalC.FindStuff.FieldByName('TABLETYPE').Value;
              FieldByName('TABLEGROUP').Value := dmGlobalC.FindStuff.FieldByName('TABLEGROUP').Value;
              FieldByName('TABLEPARENT').Value := dmGlobalC.FindStuff.FieldByName('TABLEPARENT').Value;
              FieldByName('KEYFIELDS').Value := dmGlobalC.FindStuff.FieldByName('KEYFIELDS').Value;
              FieldByName('TABLEORDER').Value := dmGlobalC.FindStuff.FieldByName('TABLEORDER').Value;
              FieldByName('TSEARCH').Value := dmGlobalC.FindStuff.FieldByName('TSEARCH').Value;
              FieldByName('RANKED').Value := dmGlobalC.IsTrue(dmGlobalC.FindStuff.FieldByName('ORDERED').Value);
              FieldByName('RECORDCOUNT').Value := dmGlobalC.FindStuff.FieldByName('RECORDCOUNT').Value;
              Post;
            end;
          Next;
          fmStartInfo.pbInfo.StepIt;
        end;
      cdsTabledoc.Close;
      Close;
    end;

  // populate columndoc table
{
    ExcludedFields := '''DEPNO'',''DGNO'',''DPCRANK'',''DGCRANK'',''DPHRANK'',''DGHRANK'',' +
                      '''DPRRANK'',''DGRRANK'',''DPSRANK'',''DGSRANK'',''OBJRANK'',''RANK'',' +
                      '''REVWHO'',''REVDATE'',''RELDATE''';
}
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select c.TABLENAME,c.FIELDNAME,c.ECAPTION,c.FIELDTYPE,c.FIELDORDER,' +
                     'c.TSEARCH,c.TREPORT ' +
                     'from columndoc c inner join tabledoc t ' +
                     'on c.TABLENAME = t.TABLENAME ' +
                     'where t.TABLETYPE <> ''Lookup''';
      Open;
      fmStartInfo.pbInfo.Min := 0;
      fmStartInfo.pbInfo.Step := 1;
      fmStartInfo.pbInfo.Max := RecordCount;
      fmStartInfo.pbInfo.Position := 0;
      cdsColumndoc.Open;
      cdsColumndoc.EmptyDataSet;
      while not EOF do
        begin
          with cdsColumndoc do
            begin
              Append;
              FieldByName('TABLENAME').Value := dmGlobalC.FindStuff.FieldByName('TABLENAME').Value;
              FieldByName('FIELDNAME').Value := dmGlobalC.FindStuff.FieldByName('FIELDNAME').Value;
              FieldByName('ECAPTION').Value := dmGlobalC.FindStuff.FieldByName('ECAPTION').Value;
              FieldByName('FIELDTYPE').Value := dmGlobalC.FindStuff.FieldByName('FIELDTYPE').Value;
              FieldByName('FIELDORDER').Value := dmGlobalC.FindStuff.FieldByName('FIELDORDER').Value;
              FieldByName('TSEARCH').Value := dmGlobalC.FindStuff.FieldByName('TSEARCH').Value;
              FieldByName('TREPORT').Value := dmGlobalC.IsTrue(dmGlobalC.FindStuff.FieldByName('TREPORT').Value);
              Post;
            end;
          Next;
          fmStartInfo.pbInfo.StepIt;
        end;
      cdsColumndoc.Close;
      Close;
    end;

  // populate cdsQSummary
  cdsQSummary.DisableControls;
  PopulateQSummary(cdsSummary);
  LoadCaptions;
  dsQSummary.DataSet := cdsQSummary;
  cdsQSummary.EnableControls;
  Screen.Cursor := tmpCursor;
end;

procedure TdmQuery.DeleteAgeTable(s: string);
begin
  if AgeTableExists(s) then
    begin
      cdsAgeTables.Delete(AgeTableIndex(s));
      AgeTables.Delete(AgeTables.IndexOf(s));
    end;
end;

procedure TdmQuery.DeleteAgeTables;
begin
  if AgeTables.Count > 0 then
    while AgeTables.Count > 0 do
      DeleteAgeTable(AgeTables[0]);
end;

procedure TdmQuery.LoadCaptions;
begin
  GQ_DESCRIPTION := 'Description';
  GQ_DGSELECTED := 'Selected Deposit Groups Records';
  GQ_DPSELECTED := 'Selected Deposits Records';
  GQ_DGNO := 'Deposit group number';
  GQ_DEPNO := 'Deposit number';
  GQ_DPNAMES := 'Deposit name(s)';
  GQ_DGNAMES := 'Deposit group name(s)';
  GQ_LONGLAT := 'Longitude&nbsp;/&nbsp;Latitude';
  GQ_COUNTRY := 'Country';
  GQ_LOCATION := 'Location';
  GQ_ALLNAMES := 'Names';
  GQ_COMMODITIES := 'Commodities';
  GQ_ASSOCIATEDDP := 'Associated&nbsp;deposit(s)';
  GQ_ASSOCIATEDDG := 'Associated&nbsp;group(s)';
  GQ_ASSOCIATEDMN := 'Associated&nbsp;mine(s)';
  GQ_REFERENCES := 'References';
  GQ_PRODUCTIONDATA := 'Production&nbsp;data';
  GQ_RESOURCEDATA := 'Resource&nbsp;data';

  GQ_ADDRESOURCES := 'Additional&nbsp;resources';
  GQ_ALSOCONTAINING := 'Also&nbsp;containing';
  GQ_DISKS := 'disks';
  GQ_EDITEDBY := 'Edited by';
  GQ_EDITORS := 'Editor(s)';
  GQ_ESTIMATEDATE := 'Estimate&nbsp;date';
  GQ_FROM := 'from';
  GQ_IN := 'in';
  GQ_ISSUE := 'issue';
  GQ_MAPS := 'maps';
  GQ_NONAME := 'No name';
  GQ_PUBLICATIONCODE := 'Publication code';
  GQ_RELDATE := 'Release date';
  GQ_REPORTPERIOD := 'Report&nbsp;period';
  GQ_SCALE := 'Scale';
  GQ_SECTION := 'Section';
  GQ_SYMPOSIUMVOLUME := 'Symposium volume';
  GQ_UNTIL := 'until';
  GQ_VOLUME := 'Volume';
  GQ_YES := 'yes';


  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select count(*) from tabledoc where TABLENAME = ''gq_captions''';
      Open;
      if Fields[0].AsInteger > 0 then
        begin
          Close;
          CommandText := 'select * from gq_captions';
          Open;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','DESCRIPTION']),[]);
          GQ_DESCRIPTION := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['DG','SELECTED']),[]);
          GQ_DGSELECTED := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['DP','SELECTED']),[]);
          GQ_DPSELECTED := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['DG','DGNO']),[]);
          GQ_DGNO := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['DP','DEPNO']),[]);
          GQ_DEPNO := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['DG','DGNAMES']),[]);
          GQ_DGNAMES := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['DP','DPNAMES']),[]);
          GQ_DPNAMES := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','LONGLAT']),[]);
          GQ_LONGLAT := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','COUNTRY']),[]);
          GQ_COUNTRY := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','LOCATION']),[]);
          GQ_LOCATION := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','ALLNAMES']),[]);
          GQ_ALLNAMES := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','COMMODITIES']),[]);
          GQ_COMMODITIES := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','ASSOCIATEDDP']),[]);
          GQ_ASSOCIATEDDP := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','ASSOCIATEDDG']),[]);
          GQ_ASSOCIATEDDG := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','ASSOCIATEDMN']),[]);
          GQ_ASSOCIATEDMN := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','REFERENCES']),[]);
          GQ_REFERENCES := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','PRODUCTIONDATA']),[]);
          GQ_PRODUCTIONDATA := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','RESOURCEDATA']),[]);
          GQ_RESOURCEDATA := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','ADDRESOURCES']),[]);
          GQ_ADDRESOURCES := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','ALSOCONTAINING']),[]);
          GQ_ALSOCONTAINING := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','DISKS']),[]);
          GQ_DISKS := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','EDITEDBY']),[]);
          GQ_EDITEDBY := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','EDITORS']),[]);
          GQ_EDITORS := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','ESTIMATEDATE']),[]);
          GQ_ESTIMATEDATE := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','GQFROM']),[]);
          GQ_FROM := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','GQIN']),[]);
          GQ_IN := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','ISSUE']),[]);
          GQ_ISSUE := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','MAPS']),[]);
          GQ_MAPS := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','NONAME']),[]);
          GQ_NONAME := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','PUBLICATIONCODE']),[]);
          GQ_PUBLICATIONCODE := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','RELDATE']),[]);
          GQ_RELDATE := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','REPORTPERIOD']),[]);
          GQ_REPORTPERIOD := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','GQSCALE']),[]);
          GQ_SCALE := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','GQSECTION']),[]);
          GQ_SECTION := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','SYMPOSIUMVOLUME']),[]);
          GQ_SYMPOSIUMVOLUME := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','GQUNTIL']),[]);
          GQ_UNTIL := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','VOLUME']),[]);
          GQ_VOLUME := Fields[3].AsString;
          Locate('EKEY;FIELDNAME', VarArrayOf(['ALL','GQYES']),[]);
          GQ_YES := Fields[3].AsString;
        end;
      Close;
    end;
end;

procedure TdmQuery.PopulateQSummary(cdsSource: TClientDataSet);
var
  i: integer;
begin
  cdsQSummary.EmptyDataSet;
  cdsQSummary.IndexFieldNames := e_key;
  cdsSummary.Open;
  cdsSource.Open;
  cdsSource.First;
  while not cdsSource.Eof do
    begin
      if not cdsQSummary.FindKey([cdsSource.IndexFields[0].Value]) then
        begin
          cdsSummary.FindKey([cdsSource.IndexFields[0].Value]);
          cdsQSummary.Append;
          for i := 0 to cdsQSummary.FieldDefs.Count - 1 do
            cdsQSummary.Fields[i].Value := cdsSummary.Fields[i].Value;
          cdsQSummary.Post;
        end;
      cdsSource.Next;
    end;
  cdsSource.Close;
  cdsSummary.Close;
  cdsQSummary.IndexFieldNames := 'COUNTRY;ALLNAMES';
  cdsQSummary.First;
end;

procedure TdmQuery.DataModuleCreate(Sender: TObject);
begin
  AgeTables := TStringList.Create;
  cdsAgeTables := TComponentList.Create;
end;

procedure TdmQuery.DataModuleDestroy(Sender: TObject);
begin
  DeleteAgeTables;
  AgeTables.Free;
  cdsAgeTables.Free;
end;

procedure TdmQuery.dsQSummaryDataChange(Sender: TObject; Field: TField);
begin
  fmMaster.stbMaster.Panels[3].Text := IntToStr(cdsQSummary.RecNo) + ' / ' + IntToStr(n_selected);
end;

end.
