unit genhtml320;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DirectoryEdit, DB, Variants, ShellAPI, mastform,
  ComCtrls;

type
  TfmGenerateHTML320 = class(TForm)
    paTop: TPanel;
    buMainScreen: TButton;
    buGenerate: TButton;
    buReset: TButton;
    pcHTMLOutput: TPageControl;
    tsFullHTML: TTabSheet;
    tsTOCOnly: TTabSheet;
    laFullHTMLTitle: TLabel;
    edFullHTMLTitle: TEdit;
    laFullHTMLRoot: TLabel;
    deFullHTMLRoot: TDirectoryEdit;
    laFullHTMLNewDir: TLabel;
    edFullHTMLNewDir: TEdit;
    ckbFullHTMLLinkedPages: TCheckBox;
    laDescription: TLabel;
    meFullHTMLDescription: TMemo;
    laTOCOnlyTitle: TLabel;
    edTOCOnlyTitle: TEdit;
    deTOCOnlyURL: TDirectoryEdit;
    laTOCOnlyURL: TLabel;
    laTOCOnlyDestinationPath: TLabel;
    laTOCOnlyDescription: TLabel;
    meTOCOnlyDescription: TMemo;
    deTOCOnlyDestinationPath: TDirectoryEdit;
    edTOCOnlyFilename: TEdit;
    laTOCOnlyFilename: TLabel;
    ckbTableBorders: TCheckBox;
    ckbDisclaimer: TCheckBox;
    laFullHeading: TLabel;
    laFullSubHeading: TLabel;
    edFullHeading: TEdit;
    edFullSubHeading: TEdit;
    laTOCOnlyHeading: TLabel;
    edTOCOnlyHeading: TEdit;
    laTOCOnlySubHeading: TLabel;
    edTOCOnlySubHeading: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure buResetClick(Sender: TObject);
    procedure buGenerateClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    allDepLocation: TStringList;
    allDepnos: TStringList;
    allDepnames: TStringList;
    allMinenos: TStringList;
    Border: string;
    FullHTMLOutput: boolean;
    function BuildDate(estyear,estmonth,estday: integer): string;
    function BuildDateRange(stayear,stamonth,staday,endyear,endmonth,
      endday: integer): string;
    function CleanString(s: string): string;
    function FloatToStrFCustom(fv: double): string;
    procedure GenerateContributors;
    procedure GenerateCSS;
    procedure GenerateDepositGroupPage(k: string);
    procedure GenerateDepositPage(k: string;dl: string = '';
      dn: string = '';sub_page: boolean = False);
    procedure GenerateDetailPages;
    procedure GenerateTextIndex;
    function GetAdditionalResources(tn,k,rk,sep: string;entity_key: string = ''): string;
    function GetAltsig(tn,k,sep: string;entity_key: string = ''): string;
    function GetAuthors(REFNO: string): string;
    function GetCaption(tn,fn: string): string;
    function GetComment(tn,k,sep: string;entity_key: string = ''): string;
    function GetContainedResources(tn,k,rk,sep: string;entity_key: string = ''): string;
    function GetCoincidentFeature(tn,k,sep: string;entity_key: string = ''): string;
    function GetCountryRocks(tn,k,sep: string;entity_key: string = ''): string;
    procedure GetDepnos(tn,k: string;var Depnos: TStringList;
      var Deplocations: TStringList;var Depnames: TStringList;entity_key: string = '');
    function GetDepositStatus(tn,k,sep: string;entity_key: string = ''): string;
    function GetDepositType(tn,k,sep: string;entity_key: string = ''): string;
    procedure GetDgnos(tn,k: string;var Dgnos: TStringList;
      var Dglocations: TStringList;var Dgnames: TStringList;entity_key: string = '');
    function GetDimensions(tn,k,fn,l,sep: string;entity_key: string = ''): string;
    function GetExternalForm(tn,form_fn,k,fn,l,sep: string;entity_key: string = ''): string;
    function GetFarInfo(h,u,d: string): string;
    function GetGeneralShape(tn,k,sep: string;entity_key: string = ''): string;
    function GetGeologicalAge(tn,k,sep: string;entity_key: string = ''): string;
    function GetGeosig(tn,k,sep: string;entity_key: string = ''): string;
    function GetHostRocks(tn,k,sep: string;entity_key: string = ''): string;
    function GetInternalStructure(tn,k,fn,l,sep: string;entity_key: string = ''): string;
    function GetLCaption(tn: string;fn: string = ''): string;
    function GetLithology(tn,k,fn,l,sep: string;entity_key: string = ''): string;
    procedure GetMinenos(k: string;var Minenos: TStringList;var Minenames: TStringList);
    function GetMineOwner(k,sep: string): string;
    function GetMineralizationStyle(tn,k,sep: string;entity_key: string = ''): string;
    function GetMineralogy(tn,k,sep: string;entity_key: string = ''): string;
    function GetName(tn,k,sep: string;entity_key: string = ''): string;
    function GetNTS(tn,k,sep: string;entity_key: string = ''): string;
    function GetPoliticalLocation(tn,k,sep: string; entity_key: string = ''): string;
    function GetReference(refno: string): string;
    function GetRelatedIgneousRocks(tn,k,sep: string;entity_key: string = ''): string;
    function GetResourceCutoff(k,sep: string): string;
    function GetResourceGrades(k,sep: string): string;
    function GetResources(SQLString:TStringList;tn,k,sep: string;
      entity_key: string = ''): string;
    function GetResourceWeights(k,sep: string): string;
    function GetSamples(tn,k,sep: string;entity_key: string = ''): string;
    function GetSampleGrades(smpgrade_tn,k,subkey_fn,rk,sep,entity_key: string): string;
    function GetSampleWeights(smpwgt_tn,k,subkey_fn,rk,sep,entity_key: string): string;
    function GetStratigraphy(tn,k,fn,l,sep: string;entity_key: string = ''): string;
    function GetString(tn,fn,k,sep: string;entity_key: string = ''): string;
    function GetProductionGrades(k,sep: string): string;
    function GetPageSpecificationsOK(title,root,newdir,head,subhead: string;description: TStrings): boolean;
    function GetProduction(SQLString: TStringList;tn,k,sep: string): string;
    function GetProductionWeights(k,sep: string): string;
    function GetProtoliths(tn,k,fn,l,sep: string;entity_key: string = ''): string;
    function GetRadiometricAge(tn,k,sep: string;entity_key: string = ''): string;
    function GetTectonicSetting(tn,k,sep: string;entity_key: string = ''): string;
    function GetTectonicStructure(tn,k,sep: string;entity_key: string = ''): string;
    function GetDisclaimer: string;
    procedure GenerateIndexBody;
    procedure GenerateIndexPage(memo: TMemo);
    procedure GeneratePageHeader(t: string);
    procedure GenerateMinePage(k: string);
    procedure GeneratePageFooter;
    procedure GenerateReference(REFNO: string);
    procedure GenerateReferences(Refnos: TStringList);
    function GetUCaption(tn: string;fn: string = '';bold: boolean = False): string;
    function GetXlink(tn,k,sep: string;entity_key: string = ''): string;
    function SRCTP_F(REFNO: string): string;
    function SRCTP_M(REFNO: string): string;
    function SRCTP_NP(REFNO: string): string;
    function SRCTP_P(REFNO: string): string;
    function SRCTP_R(REFNO: string): string;
    function SRCTP_SA(REFNO: string): string;
    function SRCTP_SV(REFNO: string): string;
    function SRCTP_V(REFNO: string): string;
  public
    procedure FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
    procedure Initialize;
  end;

var
  fmGenerateHTML320: TfmGenerateHTML320;

implementation

uses dmglob1, dmquery1, startinf, resources;

{$R *.DFM}

resourcestring
  AR = 'class="righttop"';
  AL = 'class="lefttop"';
  PL = '<p>';
  PR = '</p>';
  SL = '<span class="all">';
  SR = '</span>';

var
  BaseURL: string;
  DestinationPath: string;
  HTMLPath: string;
  HTMLPage: TStringList;
  HTMLTitle: string;
  PageHeading: string;
  PageSubHeading: string;

procedure TfmGenerateHTML320.FormPosition(const ParentTop,ParentLeft,ParentHeight,
  ParentWidth: integer);
begin
  Top := ParentTop + Trunc((ParentHeight - Height)/2);
  Left := ParentLeft + Trunc((ParentWidth - Width)/2);
end;

function TfmGenerateHTML320.BuildDate(estyear,estmonth,estday: integer): string;
var
  s: string;
begin
  s := '';
  if (estyear > 0) and (estmonth > 0) and (estday > 0)
    then s := Format('%4.4d%s%2.2d%s%2.2d',
                     [estyear,DateSeparator,estmonth,DateSeparator,estday])
    else if (estyear > 0) and (estmonth > 0)
           then s := Format('%4.4d%s%2.2d',[estyear,DateSeparator,estmonth])
           else if (estyear > 0) then
                  s := Format('%4.4d',[estyear]);
  Result := s;
end;

function TfmGenerateHTML320.BuildDateRange(stayear,stamonth,staday,endyear,
  endmonth,endday: integer): string;
var
  m,n,s: string;
begin
  m := '';
  n := '';
  s := '';
  if (stayear > 0) and (stamonth > 0) and (staday > 0)
    then m := Format('%4.4d%s%2.2d%s%2.2d',
                     [stayear,DateSeparator,stamonth,DateSeparator,staday])
    else if (stayear > 0) and (stamonth > 0)
           then m := Format('%4.4d%s%2.2d',[stayear,DateSeparator,stamonth])
           else if (stayear > 0) then
                  m := Format('%4.4d',[stayear]);
  if m <> '' then
//    s := genhtml319_From + ' ' + m;
    s := dmQuery.GQ_FROM + ' ' + m;
  if (endyear > 0) and (endmonth > 0) and (endday > 0)
    then n := Format('%4.4d%s%2.2d%s%2.2d',
                     [endyear,DateSeparator,endmonth,DateSeparator,endday])
    else if (endyear > 0) and (endmonth > 0)
           then n := Format('%4.4d%s%2.2d',[endyear,DateSeparator,endmonth])
           else if (endyear > 0) then
                  n := Format('%4.4d',[endyear]);
  if n <> '' then
    if s <> ''
//      then s := s + ' ' + genhtml319_Until + ' ' + n
      then s := s + ' ' + dmQuery.GQ_UNTIL + ' ' + n
//      else s := genhtml319_Until + ' ' + n;
      else s := dmQuery.GQ_UNTIL + ' ' + n;
  Result := s;
end;

function TfmGenerateHTML320.CleanString(s: string): string;
begin
  while (Length(s) > 0) and (s[1] in [',','-',' ']) do
    Delete(s,1,1);
  while AnsiPos(',,',s) > 0 do
    s := StringReplace(s,',,',',',[rfReplaceAll]);
  while AnsiPos('..',s) > 0 do
    s := StringReplace(s,'..','.',[rfReplaceAll]);
  while AnsiPos(', ,',s) > 0 do
    s := StringReplace(s,', ,',',',[rfReplaceAll]);
  while AnsiPos(', .',s) > 0 do
    s := StringReplace(s,', .',',',[rfReplaceAll]);
  if Length(s) > 0 then
    while s[Length(s)] = ' ' do
      Delete(s,Length(s),1);
  if Length(s) > 0 then
    while s[Length(s)] = ',' do
      Delete(s,Length(s),1);
  Result := s;
end;

function TfmGenerateHTML320.FloatToStrFCustom(fv: double): string;
var
  i: integer;
  n: integer;
  v: double;
  sFloat: string;
  sNumber: string;
  sFraction: string;
begin
  if fv = 0
    then n := 0
    else n := Trunc(Ln(fv)/Ln(10)) + 1;
  if n < 7 then
    n := 7;
  sFloat := FloatToStrF(fv,ffGeneral,n,8);
  v := Trunc(fv);
  sNumber := FloatToStrF(v,ffNumber,n,0);
  i := AnsiPos('.',sFloat);
  if i = 0
    then sFraction := ''
    else sFraction := Copy(sFloat,i,8);
  Result := sNumber + sFraction;
end;

procedure TfmGenerateHTML320.GenerateContributors;
var
  rs: string;
  ls: string;
  s: string;
begin
  rs := ' class="righttop"';
  ls := ' class="lefttop"';
  with dmGlobalC.FindBySQL do
    begin
      CommandText := 'select DBNAME,DBAGENCY,DBREL,COMPBY,RELDATE from dbversion';
      Open;
      if not FieldByName('DBNAME').IsNull then
        begin
          HTMLPage.Add('<tr><td' + rs + '>' + GetUCaption('dbversion','DBNAME',True) + '</td>');
          HTMLPage.Add('<td' + ls + '>' + FieldByName('DBNAME').Value + '</td></tr>');
        end;
      if not FieldByName('DBAGENCY').IsNull then
        begin
          HTMLPage.Add('<tr><td' + rs + '>' + GetUCaption('dbversion','DBAGENCY',True) + '</td>');
          HTMLPage.Add('<td' + ls + '>' + FieldByName('DBAGENCY').Value + '</td></tr>');
        end;
      if not FieldByName('COMPBY').IsNull then
        begin
          HTMLPage.Add('<tr><td' + rs + '>' + GetUCaption('dbversion','COMPBY',True) + '</td>');
          HTMLPage.Add('<td' + ls + '>' + FieldByName('COMPBY').Value + '</td></tr>');
        end;
      if not FieldByName('RELDATE').IsNull then
        begin
          HTMLPage.Add('<tr><td' + rs + '>' + GetUCaption('dbversion','RELDATE',True) + '</td>');
          s := FieldByName('RELDATE').Value;
          s := Format('%s-%s-%s',[Copy(s,1,4),Copy(s,5,2),Copy(s,7,2)]);
          HTMLPage.Add('<td' + ls + '>' + s + '</td></tr>');
        end;
      Close;
      HTMLPage.Add('<tr><td' + rs + '>&nbsp;</td>');
      HTMLPage.Add('<td' + ls + '>' + '&nbsp;</td></tr>');
    end;
end;

procedure TfmGenerateHTML320.GenerateCSS;
var
  css: TStringList;
begin
  css := TStringList.Create;
  try
    css.Add('body,p,td,h2,h3,h4,.all');
    css.Add('     {background-color: white;');
    css.Add('      font-family: Arial,Helvetica,sans-serif;');
    css.Add('      font-size: small;');
    css.Add('      font-weight: normal;}');
    css.Add('h2   {font-size: medium;');
    css.Add('      font-weight: bold;}');
    css.Add('h4   {font-size: x-small;}');
    css.Add('b    {font-weight: bold;}');
    css.Add('table');
    css.Add('     {vertical-align: text-top;}');
    css.Add('table.tcentered');
    css.Add('     {margin-left: auto;');
    css.Add('      margin-right: auto;}');
    css.Add('.centered');
    css.Add('     {text-align: center;}');
    css.Add('.lefttop');
    css.Add('     {text-align: left;');
    css.Add('      vertical-align: text-top;}');
    css.Add('.righttop');
    css.Add('     {text-align: right;');
    css.Add('      vertical-align: text-top;}');
    css.Add('.underlined');
    css.Add('     {text-decoration: underline;}');
    if FullHTMLOutput
      then css.SaveToFile(HTMLPath + 'gquery.css')
      else css.SaveToFile(DestinationPath + 'gquery.css');
  finally
    css.Free;
  end;
end;

procedure TfmGenerateHTML320.GenerateDepositGroupPage(k: string);
var
  deptyp_s: string;
  depstatus_s: string;
  s: string;
//  FieldNames: TStringList;
  SQLString: TStringList;
  Depnos: TStringList;
  Deplocations: TStringList;
  Depnames: TStringList;
  Refnos: TStringList;
  i: integer;
begin
{
  Names                           dgname          done
  Country/Province                dgctry          done
  Commodities                     dgcom           done
  Mineralogy                      dgmnrlgy        done
  Country Rocks                   dgctryrx        done
  Host Rocks                      dghostrx        done
  Geological Age                  dgagets         done
  References                      dgref           done
  Metallic Signature              dgmetsig        done
  Mineralization Style            dgminstl        done
  Coincident Feature              dgcfeat         done
  Alteration Signature            dgaltsig        done
  Related Igneous  Rocks          dgignrx         done
  Tectonic Structure              dgtstruc        done
  Host Names                      dghostnm        done
  Radiometric Age                 dgradage        done
  Deposit Type                    dgdeptyp        done
  Deposit Group Status            dgstatus        done
  Tectonic Setting                dgtecset        done
  General Shape                   dgshape         done
  Comments                        dgcomment       done
  Links to other databases        dgxlink         done
  NTS map data                    dgnts           done
  Digitization data               dgdigitized
  Geophysical-chemical signature  dggeosig        done
  Samples                         dgsample        done
}
  Refnos := TStringList.Create;
  Refnos.Sorted := True;
  try
    with dmQuery.cdsQSummary do
      begin
        HTMLPage.Add('<table border="1" cellspacing="2" cellpadding="2" class="tcentered">');
        HTMLPage.Add('<tr><td class="centered"><b>' + dmQuery.GQ_DGNO + '</b></td>');
        HTMLPage.Add('<td class="centered"><b>' + dmQuery.GQ_COUNTRY + '</b></td>');
        HTMLPage.Add('<td class="centered"><b>' + dmQuery.GQ_LOCATION + '</b></td>');
        HTMLPage.Add('<td class="centered"><b>' + dmQuery.GQ_ALLNAMES + '</b></td>');
        HTMLPage.Add('<td class="centered"><b>' + dmQuery.GQ_COMMODITIES + '</b></td></tr>');

        Locate(e_key,k,[]);
        HTMLPage.Add('<tr><td class="centered">' + IntToStr(Fields[0].Value) + '</td>');
        if not Fields[1].IsNull
          then s := Fields[1].Value
          else s := '&nbsp;';
          HTMLPage.Add('<td>' + s + '</td>');
        if not Fields[2].IsNull
          then s := Fields[2].Value
          else s := '&nbsp;';
          HTMLPage.Add('<td>' + s + '</td>');
        if not Fields[3].IsNull
          then s := Fields[3].Value
          else s := '&nbsp;';
          HTMLPage.Add('<td>' + s + '</td>');
        if not Fields[4].IsNull
          then s := Fields[4].Value
          else s := '&nbsp;';
          HTMLPage.Add('<td>' + s + '</td>');
        HTMLPage.Add('</tr></table>');
      end;

    HTMLPage.Add('<div class="lefttop">&nbsp;</div>');

    HTMLPage.Add('<table border=' + Border + ' cellspacing="2" cellpadding= "2">');
    GenerateContributors;
    HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_DGNAMES + ':</b></td>');
    HTMLPage.Add('<td ' + AL + '>' + GetName('dgname',k,'; ') + '</td></tr>');
    deptyp_s := GetDepositType('dgdeptyp',k,'<br />');
    depstatus_s := GetDepositStatus('dgstatus',k,'<br />');
    s := GetPoliticalLocation('dgctry',k,'<br />','DGNO');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgctry') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetNTS('dgnts',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgnts') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    with dmGlobalC.FindBySQL do
      begin
        Close;
        CommandText := 'select DEPCLAN,GEOLPROV,GSUBPROV,GDISTRICT,OBJLOC ' +
                       'from dggeol where DGNO = ' + k;
        Open;
        if not FieldByName('DEPCLAN').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dggeol','DEPCLAN') +
                         '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('DEPCLAN').Value +
                         '</td></tr>');
          end;
        if deptyp_s <> '' then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgdeptyp') + '</td>');
            HTMLPage.Add('<td ' + AL + '>' + deptyp_s + '</td></tr>');
          end;
        if depstatus_s <> '' then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgstatus') + '</td>');
            HTMLPage.Add('<td ' + AL + '>' + depstatus_s + '</td></tr>');
          end;
        if not FieldByName('GEOLPROV').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dggeol','GEOLPROV') + '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('GEOLPROV').Value +
                         '</td></tr>');
          end;
        if not FieldByName('GSUBPROV').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dggeol','GSUBPROV') + '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('GSUBPROV').Value +
                         '</td></tr>');
          end;
        if not FieldByName('GDISTRICT').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dggeol','GDISTRICT') + '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('GDISTRICT').Value +
                         '</td></tr>');
          end;
        if not FieldByName('OBJLOC').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dggeol','OBJLOC') + '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('OBJLOC').Value +
                         '</td></tr>');
          end;
        Close;
      end;
    s := GetString('dgcom','COMMODITY',k,'; ');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgcom') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetMineralizationStyle('dgminstl',k,'; '); // tab 10
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgminstl') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetGeologicalAge('dgagets',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgagets') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetTectonicSetting('dgtecset',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgtecset') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetCoincidentFeature('dgcfeat',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgcfeat') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetTectonicStructure('dgtstruc',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgtstruc') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetHostRocks('dghostrx',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dghostrx') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetString('dghostnm','HOSTNAME',k,'; ');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dghostnm') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetRelatedIgneousRocks('dgignrx',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgignrx') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetCountryRocks('dgctryrx',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgctryrx') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetString('dgmetsig','METSIG',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgmetsig') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetAltsig('dgaltsig',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgaltsig') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetMineralogy('dgmnrlgy',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgmnrlgy') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetRadiometricAge('dgradage',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgradage') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetGeneralShape('dgshape',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgshape') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetComment('dgcomment',k,'<br /><br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgcomment') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetXlink('dgxlink',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgxlink') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetGeosig('dggeosig',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dggeosig') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetSamples('dgsample',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dgsample') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;

    with dmGlobalC.FindBySQL do
      begin
        Close;
        CommandText := 'select REFNO from dgref where DGNO = ' + k + ' order by REFNO';
        Open;
        while not EOF do
          begin
            Refnos.Add(IntToStr(FieldByName('REFNO').Value));
            Next;
          end;
        Close;
      end;
    if Refnos.Count > 0 then
      begin
        HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_REFERENCES + ':</b></td>');
        HTMLPage.Add('<td>');
        GenerateReferences(Refnos);
        HTMLPage.Add('</td></tr>');
      end;

    SQLString := TStringList.Create;
    try
      SQLString.Add('select d.PRODNO,d.PROPORTION,p.STAYEAR,p.STAMONTH,p.STADAY,');
      SQLString.Add('p.ENDYEAR,p.ENDMONTH,p.ENDDAY,p.TONNAGE,p.TONUNITS,p.PRODUCT,');
      SQLString.Add('p.NOTRECMD,p.YEARSUM,p.REFNO');
      SQLString.Add('from proddg d inner join prodmain p');
      SQLString.Add('on d.PRODNO = p.PRODNO');
      SQLString.Add('where d.DGNO = ' + k);
      SQLString.Add('order by p.ENDYEAR desc,p.ENDMONTH desc,p.ENDDAY desc');
      s := GetProduction(SQLString,'proddg',k,'<br />');
      if s <> '' then
        begin
          HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_PRODUCTIONDATA + ':</b></td>');
          HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
        end;

      SQLString.Clear;
      SQLString.Add('select d.RESNO,d.PROPORTION,r.ESTYEAR,r.ESTMONTH,r.ESTDAY,');
      SQLString.Add('r.COMPONENT,r.TONNAGE,r.TONUNITS,r.PRODUCT,r.RESPROD,');
      SQLString.Add('r.NOTRECMD,r.RESCAT,r.REFNO');
      SQLString.Add('from resdg d inner join resmain r');
      SQLString.Add('on d.RESNO = r.RESNO');
      SQLString.Add('where (d.DGNO = ' + k + ') and ');
      if fmMaster.AliasDriver <> 'MSACCESS'
        then SQLString.Add('  not ((r.CONTAINED = ''T'') or (r.ADDEDTO = ''T''))')
        else SQLString.Add('  not (r.CONTAINED or r.ADDEDTO)');
//      SQLString.Add('order by r.ESTYEAR desc, r.ESTMONTH desc, r.ESTDAY desc');
      SQLString.Add('order by d.RESNO');
      s := GetResources(SQLString,'resdg',k,'<br />');
      if s <> '' then
        begin
          HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_RESOURCEDATA + ':</b></td>');
          if ckbDisclaimer.Checked
            then HTMLPage.Add('<td ' + AL + '>' + GetDisclaimer + '<br />' + s + '</td></tr>')
            else HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
        end;
    finally
      SQLString.Free;
    end;

    Depnos := TStringList.Create;
    Deplocations := TStringList.Create;
    Depnames := TStringList.Create;
    try
      GetDepnos('dpdg',k,Depnos,Deplocations,Depnames);
      if Depnos.Count > 0 then
        begin
          s := '';
          for i := 0 to Depnos.Count - 1 do
            begin
              if s <> '' then
                s := s + ', ';
              if ckbFullHTMLLinkedPages.Checked
                then s := s + Depnames[i] + ' (<a href="dp' + Depnos[i] +
                          '.html">' + Depnos[i] + '</a>)'
                else s := s + Depnames[i] + ' (' + Depnos[i] + ')';
              if allDepnos.IndexOf(Depnos[i]) < 0 then
                begin
                  allDepnos.Add(Depnos[i]);
                  allDepLocation.Add(Deplocations[i]);
                  allDepnames.Add(Depnames[i]);
                end;
            end;
          HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_ASSOCIATEDDP + ':</b></td>');
          HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
        end;
    finally
      Depnos.Free;
      Deplocations.Free;
      Depnames.Free;
    end;

    HTMLPage.Add('</table>');
  finally
    Refnos.Free;
  end;
end;

procedure TfmGenerateHTML320.GenerateDepositPage(k: string;dl: string = '';
  dn: string = '';sub_page: boolean = False);
var
  deptyp_s: string;
  depstatus_s: string;
  s: string;
//  FieldNames: TStringList;
  SQLString: TStringList;
  Dgnos: TStringList;
  Dglocations: TStringList;
  Dgnames: TStringList;
  Minenos: TStringList;
  Minenames: TStringList;
  Refnos: TStringList;
  i: integer;
  ek: string;
begin
{
  Names                           dpname          done
  Country/Province                dpctry          done
  Commodities                     dpcom           done
  Mineralogy                      dpmnrlgy        done
  Country Rocks                   dpctryrx        done
  Host Rocks                      dphostrx        done
  Geological Age                  dpagets         done
  References                      dpref           done
  Metallic Signature              dpmetsig        done
  Mineralization Style            dpminstl        done
  Coincident Feature              dpcfeat         done
  Alteration Signature            dpaltsig        done
  Related Igneous Rocks           dpignrx         done
  Tectonic Structure              dptstruc        done
  Radiometric Age                 dpradage        done
  Deposit Type                    dpdeptyp        done
  Deposit Status                  dpstatus        done
  Tectonic Setting                dptecset        done
  General Shape                   dpshape         done
  Comments                        dpcomment       done
  Links to other databases        dpxlink         done
  NTS map data                    dpnts           done
  Digitization data               dpdigitized
  Geophysical-chemical signature  dpgeosig        done
  Samples                         dpsample        done
}
  Refnos := TStringList.Create;
  Refnos.Sorted := True;
  try
    if not sub_page then
      begin
        ek := '';
        with dmQuery.cdsQSummary do
          begin
            HTMLPage.Add('<table border="1" cellspacing="2" cellpadding="2" class="tcentered">');
            HTMLPage.Add('<tr><td class="centered"><b>' + dmQuery.GQ_DEPNO + '</b></td>');
            HTMLPage.Add('<td class="centered"><b>' + dmQuery.GQ_COUNTRY + '</b></td>');
            HTMLPage.Add('<td class="centered"><b>' + dmQuery.GQ_LOCATION + '</b></td>');
            HTMLPage.Add('<td class="centered"><b>' + dmQuery.GQ_ALLNAMES + '</b></td>');
            HTMLPage.Add('<td class="centered"><b>' + dmQuery.GQ_COMMODITIES + '</b></td></tr>');

            Locate(e_key,k,[]);
            HTMLPage.Add('<tr><td class="centered">' + IntToStr(Fields[0].Value) + '</td>');
            if not Fields[1].IsNull
              then s := Fields[1].Value
              else s := '&nbsp;';
              HTMLPage.Add('<td>' + s + '</td>');
            if not Fields[2].IsNull
              then s := Fields[2].Value
              else s := '&nbsp;';
              HTMLPage.Add('<td>' + s + '</td>');
            if not Fields[3].IsNull
              then s := Fields[3].Value
              else s := '&nbsp;';
              HTMLPage.Add('<td>' + s + '</td>');
            if not Fields[4].IsNull
              then s := Fields[4].Value
              else s := '&nbsp;';
              HTMLPage.Add('<td>' + s + '</td>');
            HTMLPage.Add('</tr></table>');
          end;
      end;

    HTMLPage.Add('<div class="lefttop">&nbsp;</div>');

    HTMLPage.Add('<table border=' + Border + ' cellspacing="2" cellpadding= "2">');
    GenerateContributors;
    ek := 'DEPNO';
    HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_DPNAMES + ':</b></td>');
    HTMLPage.Add('<td ' + AL + '>' + GetName('dpname',k,'; ',ek) + '</td></tr>');
    if sub_page then
      if dl <> '' then
        begin
          HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_LONGLAT + ':</b></td>');
          HTMLPage.Add('<td ' + AL + '>' + dl + '</td></tr>');
        end;
    deptyp_s := GetDepositType('dpdeptyp',k,'<br />',ek);
    depstatus_s := GetDepositStatus('dpstatus',k,'<br />',ek);
    s := GetPoliticalLocation('dpctry',k,'<br />','DEPNO'); // tab 02
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpctry') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetNTS('dpnts',k,'<br />',ek);
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpnts') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    with dmGlobalC.FindBySQL do
      begin
        Close;
        CommandText := 'select DEPCLAN,GEOLPROV,GSUBPROV,GDISTRICT,OBJLOC ' +
                       'from dpgeol where DEPNO = ' + k;
        Open;
        if not FieldByName('DEPCLAN').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpgeol','DEPCLAN') + '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('DEPCLAN').Value + '</td></tr>');
          end;
        if deptyp_s <> '' then // tab 16
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpdeptyp') + '</td>');
            HTMLPage.Add('<td ' + AL + '>' + deptyp_s + '</td></tr>');
          end;
        if depstatus_s <> '' then // tab 17
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpstatus') + '</td>');
            HTMLPage.Add('<td ' + AL + '>' + depstatus_s + '</td></tr>');
          end;
        if not FieldByName('GEOLPROV').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpgeol','GEOLPROV') +
                         '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('GEOLPROV').Value +
                         '</td></tr>');
          end;
        if not FieldByName('GSUBPROV').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpgeol','GSUBPROV') +
                         '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('GSUBPROV').Value +
                         '</td></tr>');
          end;
        if not FieldByName('GDISTRICT').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpgeol','GDISTRICT') +
                         '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('GDISTRICT').Value +
                         '</td></tr>');
          end;
        if not FieldByName('OBJLOC').IsNull then
          begin
            HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpgeol','OBJLOC') +
                         '</td>');
            HTMLPage.Add('<td ' + AL + '>' + FieldByName('OBJLOC').Value + '</td></tr>');
          end;
        Close;
      end;
    s := GetString('dpcom','COMMODITY',k,'; ',ek); // tab 03
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpcom') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetMineralizationStyle('dpminstl',k,'; ',ek); // tab 10
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpminstl') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetGeologicalAge('dpagets',k,'<br />',ek); // tab 07
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpagets') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetTectonicSetting('dptecset',k,'<br />',ek); // tab 18
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dptecset') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetCoincidentFeature('dpcfeat',k,'<br />',ek); // tab 11
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpcfeat') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetTectonicStructure('dptstruc',k,'<br />',ek); // tab 14
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dptstruc') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetHostRocks('dphostrx',k,'<br />',ek); // tab 06
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dphostrx') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetRelatedIgneousRocks('dpignrx',k,'<br />',ek); // tab 13
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpignrx') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetCountryRocks('dpctryrx',k,'<br />',ek); // tab 05
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpctryrx') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetString('dpmetsig','METSIG',k,'<br />',ek); // tab 09
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpmetsig') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetAltsig('dpaltsig',k,'<br />',ek); // tab 12
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpaltsig') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetMineralogy('dpmnrlgy',k,'<br />',ek); // tab 04
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpmnrlgy') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetRadiometricAge('dpradage',k,'<br />',ek); // 15
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpradage') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetGeneralShape('dpshape',k,'<br />',ek); // tab 19
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpshape') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetComment('dpcomment',k,'<br /><br />',ek);
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpcomment') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetXlink('dpxlink',k,'<br />',ek);
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpxlink') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
{
    s := GetNTS('dpnts',k,'<br />',ek);
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpnts') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
}
    s := GetGeosig('dpgeosig',k,'<br />',ek);
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpgeosig') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
    s := GetSamples('dpsample',k,'<br />',ek);
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('dpsample') + '</td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;

    with dmGlobalC.FindBySQL do // tab 08
      begin
        Close;
        CommandText := 'select REFNO from dpref where DEPNO = ' + k + ' order by REFNO';
        Open;
        while not EOF do
          begin
            Refnos.Add(IntToStr(FieldByName('REFNO').Value));
            Next;
          end;
        Close;
      end;
    if Refnos.Count > 0 then
      begin
        HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_REFERENCES + ':</b></td>');
        HTMLPage.Add('<td>');
        GenerateReferences(Refnos);
        HTMLPage.Add('</td></tr>');
      end;

    SQLString := TStringList.Create;
    try
      SQLString.Add('select d.PRODNO,d.PROPORTION,p.STAYEAR,p.STAMONTH,p.STADAY,');
      SQLString.Add('p.ENDYEAR,p.ENDMONTH,p.ENDDAY,p.TONNAGE,p.TONUNITS,p.PRODUCT,');
      SQLString.Add('p.NOTRECMD,p.YEARSUM,p.REFNO');
      SQLString.Add('from proddp d inner join prodmain p');
      SQLString.Add('on d.PRODNO = p.PRODNO');
      SQLString.Add('where d.DEPNO = ' + k);
      SQLString.Add('order by p.ENDYEAR desc,p.ENDMONTH desc,p.ENDDAY desc');
      s := GetProduction(SQLString,'proddp',k,'<br />');
      if s <> '' then
        begin
          HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_PRODUCTIONDATA + ':</b></td>');
          HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
        end;

      SQLString.Clear;
      SQLString.Add('select d.RESNO,d.PROPORTION,r.ESTYEAR,r.ESTMONTH,r.ESTDAY,');
      SQLString.Add('r.COMPONENT,r.TONNAGE,r.TONUNITS,r.PRODUCT,r.RESPROD,');
      SQLString.Add('r.NOTRECMD,r.RESCAT,r.REFNO');
      SQLString.Add('from resdp d inner join resmain r');
      SQLString.Add('on d.RESNO = r.RESNO');
      SQLString.Add('where (d.DEPNO = ' + k + ') and ');
      if fmMaster.AliasDriver <> 'MSACCESS'
        then SQLString.Add('  not ((r.CONTAINED = ''T'') or (r.ADDEDTO = ''T''))')
        else SQLString.Add('  not (r.CONTAINED or r.ADDEDTO)');
//      SQLString.Add('order by r.ESTYEAR desc, r.ESTMONTH desc, r.ESTDAY desc');
      SQLString.Add('order by d.RESNO');
      s := GetResources(SQLString,'resdp',k,'<br />',ek);
      if s <> '' then
        begin
          HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_RESOURCEDATA + ':</b></td>');
          if ckbDisclaimer.Checked
            then HTMLPage.Add('<td ' + AL + '>' + GetDisclaimer + '<br />' + s + '</td></tr>')
            else HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
        end;
    finally
      SQLString.Free;
    end;

    Minenos := TStringList.Create;
    Minenames := TStringList.Create;
    try
      GetMinenos(k,Minenos,Minenames);
      if Minenos.Count > 0 then
        begin
          s := '';
          for i := 0 to Minenos.Count - 1 do
            begin
              if s <> '' then
                s := s + ', ';
              if ckbFullHTMLLinkedPages.Checked
                then s := s + Minenames[i] + ' (<a href="mn' + Minenos[i] +
                          '.html">' + Minenos[i] + '</a>)'
                else s := s + Minenames[i] + ' (' + Minenos[i] + ')';
              if allMinenos.IndexOf(Minenos[i]) < 0 then
                allMinenos.Add(Minenos[i]);
            end;
          HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_ASSOCIATEDMN + ':</b></td>');
          HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
        end;
    finally
      Minenos.Free;
      Minenames.Free;
    end;

    if not sub_page then
      begin
        Dgnos := TStringList.Create;
        Dglocations := TStringList.Create;
        Dgnames := TStringList.Create;
        try
          GetDgnos('dpdg',k,Dgnos,Dglocations,Dgnames);
          if Dgnos.Count > 0 then
            begin
              s := '';
              for i := 0 to Dgnos.Count - 1 do
                begin
                  if s <> '' then
                    s := s + ', ';
                  s := s + Dgnames[i] + ' (' + Dgnos[i] + ')';
                end;
              HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_ASSOCIATEDDG + ':</b></td>');
              HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
            end;
        finally
          Dgnos.Free;
          Dglocations.Free;
          Dgnames.Free;
        end;
      end;

    HTMLPage.Add('</table>');
  finally
    Refnos.Free;
  end;
end;

procedure TfmGenerateHTML320.GenerateDetailPages;
var
  i: integer;
  k: string;
begin
  if entity = 'DP'
    then fmStartInfo.Label1.Caption := genhtml319_GeneratingDepositPages
    else fmStartInfo.Label1.Caption := genhtml319_GeneratingDepositGroupPages;
  fmStartInfo.pbInfo.Min := 0;
  fmStartInfo.pbInfo.Step := 1;
  with dmQuery.cdsQSummary do
    begin
      First;
      fmStartInfo.pbInfo.Max := RecordCount;
      fmStartInfo.Show;
      fmStartInfo.Update;
      while not EOF do
        begin
          HTMLPage.Clear;
          GeneratePageHeader(edFullHTMLTitle.Text);
          k := IntToStr(Fields[0].Value);
          if entity = 'DP'
            then GenerateDepositPage(k)
            else GenerateDepositGroupPage(k);
          HTMLPage.Add('<hr />');
          GeneratePageFooter;
          HTMLPage.SaveToFile(HTMLPath + AnsiLowerCase(entity) + k + '.html');
          fmStartInfo.pbInfo.StepIt;
          Next;
        end;
      fmStartInfo.Hide;
    end;
  if not ckbFullHTMLLinkedPages.Checked then
    Exit;
  if allDepnos.Count > 0 then
    if MessageDlg(Format(genhtml319_GenerateLinkedDepositsInfo,[allDepnos.Count]),
                  mtConfirmation,[mbYes,mbNo],0) = mrYes then
      begin
        fmGenerateHTML320.Update;
        fmStartInfo.Label1.Caption := genhtml319_GeneratingLinkedDepositPages;
        fmStartInfo.pbInfo.Min := 0;
        fmStartInfo.pbInfo.Step := 1;
        fmStartInfo.pbInfo.Max := allDepnos.Count;
        fmStartInfo.Show;
        fmStartInfo.Update;
        for i := 0 to allDepnos.Count - 1 do
          begin
            HTMLPage.Clear;
            GeneratePageHeader(edFullHTMLTitle.Text);
            k := allDepnos[i];
            GenerateDepositPage(k,allDepLocation[i],allDepnames[i],True);
            HTMLPage.Add('<hr />');
            GeneratePageFooter;
            HTMLPage.SaveToFile(HTMLPath + 'dp' + k + '.html');
            fmStartInfo.pbInfo.StepIt;
          end;
        allDepnos.Clear;
        fmStartInfo.Hide;
      end;
  if allMinenos.Count > 0 then
    if MessageDlg(Format(genhtml319_GenerateLinkedMinesInfo,[allMinenos.Count]),
                  mtConfirmation,[mbYes,mbNo],0) = mrYes then
      begin
        fmGenerateHTML320.Update;
        fmStartInfo.Label1.Caption := genhtml319GeneratingLinkedMinePages;
        fmStartInfo.pbInfo.Min := 0;
        fmStartInfo.pbInfo.Step := 1;
        fmStartInfo.pbInfo.Max := allMinenos.Count;
        fmStartInfo.Show;
        fmStartInfo.Update;
        for i := 0 to allMinenos.Count - 1 do
          begin
            HTMLPage.Clear;
            GeneratePageHeader(edFullHTMLTitle.Text);
            k := allMinenos[i];
            GenerateMinePage(k);
            HTMLPage.Add('<hr />');
            GeneratePageFooter;
            HTMLPage.SaveToFile(HTMLPath + 'mn' + k + '.html');
            fmStartInfo.pbInfo.StepIt;
          end;
        allMinenos.Clear;
        fmStartInfo.Hide;
      end;
end;

procedure TfmGenerateHTML320.GenerateTextIndex;
var
  ASCII_line : string;
  TextIndex: TStringList;
  url: string;
begin
  fmStartInfo.Label1.Caption := genhtml319_GeneratingTextIndex;
  fmStartInfo.pbInfo.Min := 0;
  fmStartInfo.pbInfo.Step := 1;
  fmStartInfo.pbInfo.Position := 0;
  fmStartInfo.Show;
  fmStartInfo.Update;

  TextIndex := TStringList.Create;
  try
    ASCII_line := e_key + #9 + 'LONGITUDE' + #9 + 'LATITUDE' + #9 + 'COUNTRY' + #9 +
                  'LOCATION' + #9 + 'ALLNAMES' + #9 + 'COMMODITIES' + #9 + 'DEPCLAN' +
                  #9 + 'DBNAME' + #9 + 'COMPBY' + #9 + 'RELDATE' + #9 + 'URL' + #9 + 'TITLE';
    TextIndex.Add(ASCII_line);
    with dmQuery.cdsQSummary do
      begin
        fmStartInfo.pbInfo.Max := RecordCount;
        fmStartInfo.pbInfo.Position := 0;
        DisableControls;
        First;
        while not EOF do
          begin
            ASCII_line := IntToStr(FieldByName(e_key).Value);
            if FieldByName('LONGDD').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + Format('%10.6f',[FieldByName('LONGDD').AsFloat]);
            if FieldByName('LATDD').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + Format('%9.6f',[FieldByName('LATDD').AsFloat]);
            if FieldByName('COUNTRY').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + FieldByName('COUNTRY').Value;
            if FieldByName('LOCATION').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + FieldByName('LOCATION').Value;
            if FieldByName('ALLNAMES').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + FieldByName('ALLNAMES').Value;
            if FieldByName('COMMODITIES').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + FieldByName('COMMODITIES').Value;
            if FieldByName('DEPCLAN').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + FieldByName('DEPCLAN').Value;
            if FieldByName('DBNAME').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + FieldByName('DBNAME').Value;
            if FieldByName('COMPBY').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + FieldByName('COMPBY').Value;
            if FieldByName('RELDATE').IsNull
              then ASCII_line := ASCII_line + #9
              else ASCII_line := ASCII_line + #9 + FieldByName('RELDATE').Value;
            if (BaseURL = '') or (AnsiLowerCase(Copy(BaseURL,1,7)) = 'file://')
              then url := Format('%s%s%d.html',[HTMLPath,AnsiLowerCase(entity),FieldByName(e_key).AsInteger])
              else url := Format('%s%s%d.html',[BaseURL,AnsiLowerCase(entity),FieldByName(e_key).AsInteger]);
            ASCII_line := ASCII_line + #9 + url;
            ASCII_line := ASCII_line + #9 + HTMLTitle;
            TextIndex.Add(ASCII_line);
            if FullHTMLOutput
              then TextIndex.SaveToFile(HTMLPath + 'index.txt')
              else TextIndex.SaveToFile(DestinationPath + edTOCOnlyFilename.Text + '.txt');
            Next;
            fmStartInfo.pbInfo.StepIt;
            fmStartInfo.Update;
          end;
        fmStartInfo.Hide;
        First;
        EnableControls;
      end;
  finally
    TextIndex.Free;
  end;
end;

function TfmGenerateHTML320.GetAdditionalResources(tn,k,rk,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, rk: key value of current resource, sep: separator
var
  proportion: string;
  estyear: integer;
  estmonth: integer;
  estday: integer;
  component: string;
  tonnage: string;
  tonunits: string;
  product: string;
  resprod: string;
  notrecmd: string;
  rescat: string;
  refno: string;
  resourcedate: string;
  resourcegrades: string;
  resourcecutoff: string;
  resourceweights: string;
  details: string;
  s: string;
  empty: boolean;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindSubRes do
    begin
      Close;
      CommandText := 'select d.RESNO,d.PROPORTION,' +
                     'r.ESTYEAR,r.ESTMONTH,r.ESTDAY,r.COMPONENT,' +
                     'r.TONNAGE,r.TONUNITS,r.PRODUCT,r.RESPROD,' +
                     'r.NOTRECMD,r.RESCAT,r.REFNO ' +
                     'from (' + tn + ' d inner join resadded2 i' +
                     '  on d.RESNO = i.RESNO) inner join resmain r' +
                     '  on i.RESNO = r.RESNO ' +
                     'where (d.' + entity_key + ' = ' + k + ') and ' +
                     '  (i.RESNOMAIN = ' + rk + ') ' +
                     'order by d.RESNO';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep + sep;
          proportion := '';
          component := '';
          tonnage := '';
          tonunits := '';
          product := '';
          resprod := '';
          notrecmd := '';
          rescat := '';
          refno := '';
          empty := True;
          if not FieldByName('ESTYEAR').IsNull
            then estyear := FieldByName('ESTYEAR').Value
            else estyear := 0;
          if not FieldByName('ESTMONTH').IsNull
            then estmonth := FieldByName('ESTMONTH').Value
            else estmonth := 0;
          if not FieldByName('ESTDAY').IsNull
            then estday := FieldByName('ESTDAY').Value
            else estday := 0;
          resourcedate := BuildDate(estyear,estmonth,estday);
          if resourcedate <> '' then
            begin
//              resourcedate := '<span class="underlined">' + genhtml319_EstimateDate + '</span>: ' + resourcedate;
              resourcedate := '<span class="underlined">' + dmQuery.GQ_ESTIMATEDATE + '</span>: ' + resourcedate;
              empty := False;
            end;
          if not FieldByName('COMPONENT').IsNull then
            if not empty
              then component := '; ' + GetUCaption('resmain','COMPONENT') +
                             ' ' + FieldByName('COMPONENT').Value
              else
                begin
                  component := GetUCaption('resmain','COMPONENT') + ' ' +
                             FieldByName('COMPONENT').Value;
                  empty := False;
                end;
          if not FieldByName('TONNAGE').IsNull then
            if not empty
              then tonnage := '; ' + FloatToStrFCustom(FieldByName('TONNAGE').AsFloat)
              else
                begin
                  tonnage := FloatToStrFCustom(FieldByName('TONNAGE').AsFloat);
                  empty := False;
                end;
          if not FieldByName('TONUNITS').IsNull then
            if not empty
              then tonunits := ' ' + FieldByName('TONUNITS').Value
              else
                begin
                  tonunits := FieldByName('TONUNITS').Value;
                  empty := False;
                end;
          if not FieldByName('PRODUCT').IsNull then
            if not empty
              then product := ' ' + FieldByName('PRODUCT').Value
              else
                begin
                  product := FieldByName('PRODUCT').Value;
                  empty := False;
                end;
          if not FieldByName('RESPROD').IsNull then
            if dmGlobalC.IsTrue(FieldByName('RESPROD').Value)
//              then resprod := genhtml319_Yes
              then resprod := dmQuery.GQ_YES
              else resprod := genhtml319_No;
          if not FieldByName('RESPROD').IsNull then
            if not empty
              then resprod := '; ' + GetUCaption('resmain','RESPROD') + ' ' + resprod
              else
                begin
                  resprod := GetUCaption('resmain','RESPROD') + ' ' + resprod;
                  empty := False;
                end;
          if not FieldByName('NOTRECMD').IsNull then
//            if dmGlobalC.IsTrue(FieldByName('NOTRECMD').Value)
            if not dmGlobalC.IsTrue(FieldByName('NOTRECMD').Value)
              then notrecmd := genhtml319_No
//              else notrecmd := genhtml319_Yes;
              else notrecmd := dmQuery.GQ_YES;
          if not FieldByName('NOTRECMD').IsNull then
            if not empty
              then notrecmd := '; ' + GetUCaption('resmain','NOTRECMD') + ' ' + notrecmd
              else
                begin
                  notrecmd := GetUCaption('resmain','NOTRECMD') + ' ' + notrecmd;
                  empty := False;
                end;
          if not FieldByName('RESCAT').IsNull then
            if not empty
              then rescat := '; ' + GetUCaption('resmain','RESCAT') +
                             ' ' + FieldByName('RESCAT').Value
              else rescat := GetUCaption('resmain','RESCAT') + ' ' +
                             FieldByName('RESCAT').Value;

          s := s + SL + resourcedate + component + tonnage + tonunits +
               product + resprod + notrecmd + rescat + SR;

          resourcegrades := GetResourceGrades(IntToStr(FieldByName('RESNO').AsInteger),sep);
          resourcecutoff := GetResourceCutoff(IntToStr(FieldByName('RESNO').AsInteger),sep);
          resourceweights := GetResourceWeights(IntToStr(FieldByName('RESNO').AsInteger),sep);
          if (resourcegrades + resourcecutoff + resourceweights) <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              if resourcegrades <> '' then
                begin
                  details := details + '<tr><td ' + AR + '>' +
                             GetUCaption('resgrade') +  '</td>';
                  details := details + '<td ' + AL + '>' + resourcegrades + '</td></tr>';
                end;
              if resourcecutoff <> '' then
                begin
                  details := details + '<tr><td ' + AR + '>' + GetUCaption('rescut') +
                             '</td>';
                  details := details + '<td ' + AL + '>' + resourcecutoff + '</td></tr>';
                end;
              if resourceweights <> '' then
                if (tonnage = '') or (resourcegrades = '') then
                  begin
                    details := details + '<tr><td ' + AR + '>' + GetUCaption('reswgt') +
                               '</td>';
                    details := details + '<td ' + AL + '>' + resourceweights +
                               '</td></tr>';
                  end;
              details := details + '</table>';
              s := s + details;
            end;
          if not FieldByName('REFNO').IsNull then
           if (resourcegrades + resourcecutoff + resourceweights) <> ''
             then s := s + SL + GetUCaption('resmain','REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR
             else s := s + sep + SL + GetUCaption('resmain','REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR;
          if not FieldByName('PROPORTION').IsNull then
            proportion := GetUCaption(tn,'PROPORTION') + ' ' +
                          Format('%5.1f%s',[FieldByName('PROPORTION').AsFloat,'%']);
          s := s + sep + SL + proportion + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetAltsig(tn,k,sep: string;entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  altcat: string;
  altsig: string;
  whatalt: string;
  component: string;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select ALTCAT,ALTSIG,WHATALT,COMPONENT from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          altcat := '';
          altsig := '';
          whatalt := '';
          component := '';
          if not FieldByName('ALTCAT').IsNull then
            altcat := FieldByName('ALTCAT').Value;
          if not FieldByName('ALTSIG').IsNull then
            if altcat <> ''
              then altsig := ': ' + FieldByName('ALTSIG').Value
              else altsig := FieldByName('ALTSIG').Value;
          if not FieldByName('WHATALT').IsNull then
            if (altcat + altsig) <> ''
              then whatalt := '; ' + GetUCaption(tn,'WHATALT') +
                              ' ' + FieldByName('WHATALT').Value
              else whatalt := GetUCaption(tn,'WHATALT') + ' ' +
                              FieldByName('WHATALT').Value;
          if not FieldByName('COMPONENT').IsNull then
            if (altcat + altsig + whatalt) <> ''
              then component := '; ' + GetUCaption(tn,'COMPONENT') +
                                ' ' + FieldByName('COMPONENT').Value
              else component := GetUCaption(tn,'COMPONENT') + ' ' +
                                FieldByName('COMPONENT').Value;
          s := s + SL + altcat + altsig + whatalt + component + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetAuthors(REFNO: string): string;
var
  s: string;
begin
  with dmGlobalC.FindAuthors do
    begin
      Close;
      CommandText := 'select LASTNAME,FIRSTNAME from authors ' +
                     'where REFNO = ' + REFNO + ' ' +
                     'order by RANK';
      s := '';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + '; ';
          if not FieldByName('LASTNAME').IsNull then
            s := s + FieldByName('LASTNAME').Value;
          if not FieldByName('FIRSTNAME').IsNull then
            s := s + ', ' + FieldByName('FIRSTNAME').Value;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetCaption(tn,fn: string): string;
begin
  Result := '';
  if fn <> ''
    then with dmQuery.cdsColumndoc do
      begin
        Open;
        Locate('TABLENAME;FIELDNAME',VarArrayOf([tn,fn]),[]);
        Open;
        if not (EOF or FieldByName('ECAPTION').IsNull)
          then Result := FieldByName('ECAPTION').AsString
          else Result := fn;
        Close;
      end
    else with dmQuery.cdsTabledoc do
      begin
        Open;
        Locate('TABLENAME',tn,[]);
        Open;
        if not (EOF or FieldByName('ECAPTION').IsNull)
          then Result := FieldByName('ECAPTION').AsString
          else Result := tn;
        Close;
      end;
end;

function TfmGenerateHTML320.GetComment(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s,t: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select APPLIESTO,COMMENTS from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          t := '';
          if not FieldByName('APPLIESTO').IsNull then
            t := t + '(' + GetUCaption(tn,'APPLIESTO') + ' ' +
                 FieldByName('APPLIESTO').Value + ') ';
          if not FieldByName('COMMENTS').IsNull then
            t := t + FieldByName('COMMENTS').Value;
          if t <> '' then
            s := s + SL + t + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetContainedResources(tn,k,rk,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, rk: key value of current resource, sep: separator
var
  proportion: string;
  estyear: integer;
  estmonth: integer;
  estday: integer;
  component: string;
  tonnage: string;
  tonunits: string;
  product: string;
  resprod: string;
  notrecmd: string;
  rescat: string;
  refno: string;
  resourcedate: string;
  resourcegrades: string;
  resourcecutoff: string;
  resourceweights: string;
  details: string;
  s: string;
  empty: boolean;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindSubRes do
    begin
      Close;
      CommandText := 'select d.RESNO,d.PROPORTION,' +
                     'r.ESTYEAR,r.ESTMONTH,r.ESTDAY,r.COMPONENT,' +
                     'r.TONNAGE,r.TONUNITS,r.PRODUCT,r.RESPROD,' +
                     'r.NOTRECMD,r.RESCAT,r.REFNO ' +
                     'from (' + tn + ' d inner join resinres i' +
                     '  on d.RESNO = i.RESNO) inner join resmain r' +
                     '  on i.RESNO = r.RESNO ' +
                     'where (d.' + entity_key + ' = ' + k + ') and ' +
                     '  (i.LGRESNO = ' + rk + ') ' +
                     'order by d.RESNO';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep + sep;
          proportion := '';
          component := '';
          tonnage := '';
          tonunits := '';
          product := '';
          resprod := '';
          notrecmd := '';
          rescat := '';
          refno := '';
          empty := True;
          if not FieldByName('ESTYEAR').IsNull
            then estyear := FieldByName('ESTYEAR').Value
            else estyear := 0;
          if not FieldByName('ESTMONTH').IsNull
            then estmonth := FieldByName('ESTMONTH').Value
            else estmonth := 0;
          if not FieldByName('ESTDAY').IsNull
            then estday := FieldByName('ESTDAY').Value
            else estday := 0;
          resourcedate := BuildDate(estyear,estmonth,estday);
          if resourcedate <> '' then
            begin
              resourcedate := '<span class="underlined">' + dmQuery.GQ_ESTIMATEDATE + '</span>: ' + resourcedate;
              empty := False;
            end;
          if not FieldByName('COMPONENT').IsNull then
            if not empty
              then component := '; ' + GetUCaption('resmain','COMPONENT') +
                             ' ' + FieldByName('COMPONENT').Value
              else
                begin
                  component := GetUCaption('resmain','COMPONENT') + ' ' +
                             FieldByName('COMPONENT').Value;
                  empty := False;
                end;
          if not FieldByName('TONNAGE').IsNull then
            if not empty
              then tonnage := '; ' + FloatToStrFCustom(FieldByName('TONNAGE').AsFloat)
              else
                begin
                  tonnage := FloatToStrFCustom(FieldByName('TONNAGE').AsFloat);
                  empty := False;
                end;
          if not FieldByName('TONUNITS').IsNull then
            if not empty
              then tonunits := ' ' + FieldByName('TONUNITS').Value
              else
                begin
                  tonunits := FieldByName('TONUNITS').Value;
                  empty := False;
                end;
          if not FieldByName('PRODUCT').IsNull then
            if not empty
              then product := ' ' + FieldByName('PRODUCT').Value
              else
                begin
                  product := FieldByName('PRODUCT').Value;
                  empty := False;
                end;
          if not FieldByName('RESPROD').IsNull then
            if dmGlobalC.IsTrue(FieldByName('RESPROD').Value)
              then resprod := dmQuery.GQ_YES
              else resprod := genhtml319_No;
          if not FieldByName('RESPROD').IsNull then
            if not empty
              then resprod := '; ' + GetUCaption('resmain','RESPROD') + ' ' + resprod
              else
                begin
                  resprod := GetUCaption('resmain','RESPROD') + ' ' + resprod;
                  empty := False;
                end;
          if not FieldByName('NOTRECMD').IsNull then
//            if dmGlobalC.IsTrue(FieldByName('NOTRECMD').Value)
            if not dmGlobalC.IsTrue(FieldByName('NOTRECMD').Value)
              then notrecmd := genhtml319_No
              else notrecmd := dmQuery.GQ_YES;
          if not FieldByName('NOTRECMD').IsNull then
            if not empty
              then notrecmd := '; ' + GetUCaption('resmain','NOTRECMD') + ' ' + notrecmd
              else
                begin
                  notrecmd := GetUCaption('resmain','NOTRECMD') + ' ' + notrecmd;
                  empty := False;
                end;
          if not FieldByName('RESCAT').IsNull then
            if not empty
              then rescat := '; ' + GetUCaption('resmain','RESCAT') +
                             ' ' + FieldByName('RESCAT').Value
              else rescat := GetUCaption('resmain','RESCAT') + ' ' +
                             FieldByName('RESCAT').Value;

          s := s + SL + resourcedate + component + tonnage + tonunits +
               product + resprod + notrecmd + rescat + SR;

          resourcegrades := GetResourceGrades(IntToStr(FieldByName('RESNO').AsInteger),sep);
          resourcecutoff := GetResourceCutoff(IntToStr(FieldByName('RESNO').AsInteger),sep);
          resourceweights := GetResourceWeights(IntToStr(FieldByName('RESNO').AsInteger),sep);
          if (resourcegrades + resourcecutoff + resourceweights) <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              if resourcegrades <> '' then
                begin
                  details := details + '<tr><td ' + AR + '>' +
                             GetUCaption('resgrade') + '</td>';
                  details := details + '<td ' + AL + '>' + resourcegrades + '</td></tr>';
                end;
              if resourcecutoff <> '' then
                begin
                  details := details + '<tr><td ' + AR + '>' +
                             GetUCaption('rescut') + '</td>';
                  details := details + '<td ' + AL + '>' + resourcecutoff + '</td></tr>';
                end;
              if resourceweights <> '' then
                if (tonnage = '') or (resourcegrades = '') then
                  begin
                    details := details + '<tr><td ' + AR + '>' +
                               GetUCaption('reswgt') + '</td>';
                    details := details + '<td ' + AL + '>' + resourceweights + '</td></tr>';
                  end;
              details := details + '</table>';
              s := s + details;
            end;

          if not FieldByName('REFNO').IsNull then
           if (resourcegrades + resourcecutoff + resourceweights) <> ''
             then s := s + SL + GetUCaption('resmain','REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR
             else s := s + sep + SL + GetUCaption('resmain','REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR;
          if not FieldByName('PROPORTION').IsNull then
            proportion := GetUCaption(tn,'PROPORTION') + ' ' +
                          Format('%5.1f%s',[FieldByName('PROPORTION').AsFloat,'%']);
          s := s + sep + SL + proportion + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetCoincidentFeature(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s,t: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select CFEAT,CFTQUL,CFTNAM from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          t := '';
          if not FieldByName('CFEAT').IsNull then
            t := t + FieldByName('CFEAT').Value;
          if not FieldByName('CFTQUL').IsNull then
            t := t + ' (' + FieldByName('CFTQUL').Value + ')';
          if not FieldByName('CFTNAM').IsNull then
            if t <> ''
              then t := t + '; ' + GetUCaption(tn,'CFTNAM') + ' ' + FieldByName('CFTNAM').Value
              else t := t + GetUCaption(tn,'CFTNAM') + ' ' + FieldByName('CFTNAM').Value;
          if t <> '' then
            s := s + SL + t + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetCountryRocks(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  ctryrock: string;
  ctryrqul: string;
  ctryrnam: string;
  metgrade: string;
  protoliths: string;
  protoliths_tn: string;
  lithology: string;
  lithology_tn: string;
  subkey_fn: string;
  s: string;
  details: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select RANK,CTRYROCK,CTRYRQUL,CTRYRNAM,METGRADE from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          ctryrock := '';
          ctryrqul := '';
          ctryrnam := '';
          metgrade := '';
          if not FieldByName('CTRYROCK').IsNull then
            ctryrock := FieldByName('CTRYROCK').Value;
          if not FieldByName('CTRYRQUL').IsNull then
            if (ctryrock) <> ''
              then ctryrqul := '; (' + FieldByName('CTRYRQUL').Value + ')'
              else ctryrqul := '(' + FieldByName('CTRYRQUL').Value + ')';
          if not FieldByName('CTRYRNAM').IsNull then
            if (ctryrock + ctryrqul) <> ''
              then ctryrnam := '; ' + GetUCaption(tn,'CTRYRNAM') + ' ' + FieldByName('CTRYRNAM').Value
              else ctryrnam := GetUCaption(tn,'CTRYRNAM') + ' ' + FieldByName('CTRYRNAM').Value;
          if not FieldByName('METGRADE').IsNull then
            if (ctryrock + ctryrqul + ctryrnam) <> ''
              then metgrade := '; ' + GetUCaption(tn,'METGRADE') +
                              ' ' + FieldByName('METGRADE').Value
              else metgrade := GetUCaption(tn,'METGRADE') + ' ' +
                               FieldByName('METGRADE').Value;
          s := s + SL + '(' + IntToStr(FieldByName('RANK').AsInteger) + ') ' + ctryrock + ctryrqul + ctryrnam + metgrade + SR;
          if tn = 'dgctryrx'
            then
              begin
                protoliths_tn := 'dgcproto';
                lithology_tn := 'dgclith';
                subkey_fn := 'DGCRANK';
              end
            else
              begin
                protoliths_tn := 'dpcproto';
                lithology_tn := 'dpclith';
                subkey_fn := 'DPCRANK';
              end;
          details := '';
          protoliths := GetProtoliths(protoliths_tn,k,subkey_fn,
                        IntToStr(FieldByName('RANK').Value),sep,entity_key);
          lithology := GetLithology(lithology_tn,k,subkey_fn,
                       IntToStr(FieldByName('RANK').Value),sep,entity_key);
          if (protoliths + lithology) <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              if protoliths <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(protoliths_tn) + '</td>' +
                           '<td ' + AL + '>' + protoliths + '</td></tr>';
              if lithology <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(lithology_tn) + '</td>' +
                           '<td ' + AL + '>' + lithology + '</td></tr>';
              details := details + '</table>';
            end;
          s := s + details;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

procedure TfmGenerateHTML320.GetDepnos(tn,k: string;var Depnos: TStringList;
  var Deplocations: TStringList;var Depnames: TStringList;entity_key: string = '');
begin
  if entity_key = '' then
    entity_key := e_key;
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select d.DEPNO,m.DEPNAME,l.LONGDD,l.LATDD ' +
                     'from (' + tn + ' d left outer join dpname m ' +
                     'on d.DEPNO = m.DEPNO) left outer join dpgeol l ' +
                     'on d.DEPNO = l.DEPNO ' +
                     'where (d.' + entity_key + ' = ' + k + ') and ' +
                     '  (m.RANK = 1) ' +
                     'order by d.DEPNO';
      Open;
      while not EOF do
        begin
          if not FieldByName('DEPNO').IsNull then
            begin
              Depnos.Add(IntToStr(FieldByName('DEPNO').Value));
              if not FieldByName('LONGDD').IsNull
                then DepLocations.Add(Format('%9.5f / %9.5f',[FieldByName('LONGDD').AsFloat,
                                      FieldByName('LATDD').AsFloat]))
                else DepLocations.Add(genhtml320_NoLocation);
              if not FieldByName('DEPNAME').IsNull
                then Depnames.Add(FieldByName('DEPNAME').Value)
                else Depnames.Add(dmQuery.GQ_NONAME);
            end;
          Next;
        end;
      Close;
    end;
end;

function TfmGenerateHTML320.GetDepositStatus(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  depstat: string;
  estsize: string;
  comments: string;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      if tn = 'dgstatus'
        then CommandText := 'select DGSTAT as DEPSTAT,ESTSIZE,COMMENTS from ' + tn + ' '
        else CommandText := 'select DEPSTAT,ESTSIZE,COMMENTS from ' + tn + ' ';
      CommandText := CommandText + 'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          depstat := '';
          estsize := '';
          comments := '';
          if not FieldByName('DEPSTAT').IsNull then
            depstat := FieldByName('DEPSTAT').Value;
          if not FieldByName('ESTSIZE').IsNull then
            if depstat <> ''
              then estsize := '; ' + GetUCaption(tn,'ESTSIZE') +
                              ' ' + FieldByName('ESTSIZE').Value
              else estsize := GetUCaption(tn,'ESTSIZE') + ' ' +
                              FieldByName('ESTSIZE').Value;
          if not FieldByName('COMMENTS').IsNull then
            if (depstat + estsize) <> ''
              then comments := '; ' + GetUCaption(tn,'COMMENTS') +
                               ' ' + FieldByName('COMMENTS').Value
              else comments := GetUCaption(tn,'COMMENTS') + ' ' +
                               FieldByName('COMMENTS').Value;
          s := s + SL + depstat + estsize + comments + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetDepositType(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  deptype: string;
  comments: string;
  refno: string;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select DEPTYPE,COMMENTS,REFNO from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          deptype := '';
          comments := '';
          refno := '';
          if not FieldByName('DEPTYPE').IsNull then
            deptype := FieldByName('DEPTYPE').Value;
          if not FieldByName('COMMENTS').IsNull then
            if deptype <> ''
              then comments := '; ' + FieldByName('COMMENTS').Value
              else comments := FieldByName('COMMENTS').Value;
          s := s + SL + deptype + comments;
          if not FieldByName('REFNO').IsNull
            then if (deptype + comments) <> ''
                   then s := s + '; ' + GetUCaption(tn,'REFNO') + ' ' +
                             GetReference(IntToStr(FieldByName('REFNO').Value)) + SR
                   else s := s + GetUCaption(tn,'REFNO') + ' ' +
                             GetReference(IntToStr(FieldByName('REFNO').Value)) + SR
            else s := s + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

procedure TfmGenerateHTML320.GetDgnos(tn,k: string;var Dgnos: TStringList;
  var Dglocations: TStringList;var Dgnames: TStringList;entity_key: string = '');
begin
  if entity_key = '' then
    entity_key := e_key;
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select d.DGNO,m.DGNAME,l.LONGDD,l.LATDD ' +
                     'from (' + tn + ' d left outer join dgname m ' +
                     'on d.DGNO = m.DGNO) left outer join dggeol l ' +
                     'on d.DGNO = l.DGNO ' +
                     'where (d.' + entity_key + ' = ' + k + ') and ' +
                     '  (m.RANK = 1) ' +
                     'order by d.DGNO';
      Open;
      while not EOF do
        begin
          if not FieldByName('DGNO').IsNull then
            begin
              Dgnos.Add(IntToStr(FieldByName('DGNO').Value));
              if not FieldByName('LONGDD').IsNull
                then DgLocations.Add(Format('%9.5f / %9.5f',[FieldByName('LONGDD').AsFloat,
                                      FieldByName('LATDD').AsFloat]))
                else DgLocations.Add(genhtml320_NoLocation);
              if not FieldByName('DGNAME').IsNull
                then Dgnames.Add(FieldByName('DGNAME').Value)
                else Dgnames.Add(dmQuery.GQ_NONAME);
            end;
          Next;
        end;
      Close;
    end;
end;

function TfmGenerateHTML320.GetDimensions(tn,k,fn,l,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, fn: fieldname (second key field), k2: key value, sep: separator
var
  dimcat: string;
  dimension: string;
  dimunits: string;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select DIMCAT,DIMENSION,DIMUNITS from ' + tn + ' ' +
                     Format('where (%s = %s) and (%s = %s) order by RANK',[entity_key,k,fn,l]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          dimcat := '';
          dimension := '';
          dimunits := '';
          if not FieldByName('DIMENSION').IsNull then
            begin
              if not FieldByName('DIMCAT').IsNull then
                dimcat := FieldByName('DIMCAT').Value + ': ';
              dimension := FloatToStrFCustom(FieldByName('DIMENSION').AsFloat);
              if not FieldByName('DIMUNITS').IsNull then
                dimunits := ' ' + FieldByName('DIMUNITS').Value;
              s := s + dimcat + dimension + dimunits;
            end;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetExternalForm(tn,form_fn,k,fn,l,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, fn: fieldname (second key field), k2: key value, sep: separator
var
  form: string;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select ' + form_fn + ' from ' + tn + ' ' +
                     Format('where (%s = %s) and (%s = %s) order by RANK',[entity_key,k,fn,l]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          form := '';
          if not FieldByName(form_fn).IsNull then
            form := FieldByName(form_fn).Value;
          s := s + form;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetFarInfo(h,u,d: string): string;
var

  s: string;
begin
  Result := '';
  if h <> '' then
    s := h;
  if u <> '' then
    s := s + ' ' + u;
  if d <> '' then
    s := s + ' ' + d;
  s := CleanString(s);
  if s <> '' then
    Result := ' (' + s + ')';
end;

function TfmGenerateHTML320.GetGeneralShape(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  dshape: string;
  component: string;
  dimensions: string;
  dimensions_tn: string;
  subkey_fn: string;
  s: string;
  details: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select RANK,DSHAPE,COMPONENT from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          dshape := '';
          component := '';
          if not FieldByName('DSHAPE').IsNull then
            dshape := FieldByName('DSHAPE').Value;
          if not FieldByName('COMPONENT').IsNull then
            if dshape <> ''
              then component := '; ' + GetUCaption(tn,'COMPONENT') +
                              ' ' + FieldByName('COMPONENT').Value
              else component := GetUCaption(tn,'COMPONENT') + ' ' +
                                FieldByName('COMPONENT').Value;
          s := s + SL + dshape + component + SR;
          if tn = 'dgshape'
            then
              begin
                dimensions_tn := 'dgsdim';
                subkey_fn := 'DGSRANK';
              end
            else
              begin
                dimensions_tn := 'dpsdim';
                subkey_fn := 'DPSRANK';
              end;
          details := '';
          dimensions := GetDimensions(dimensions_tn,k,subkey_fn,
                        IntToStr(FieldByName('RANK').Value),sep,entity_key);
          if dimensions <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              if dimensions <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(dimensions_tn) + '</td>' +
                           '<td ' + AL + '>' + dimensions + '</td></tr>';
              details := details + '</table>';
            end;
          s := s + details;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetGeologicalAge(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s: string;
  from_s: string;
  to_s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select STARTAGE,STARTQU,ENDAGE,ENDQU,CTRYHOST from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          from_s := '';
          if not FieldByName('STARTAGE').IsNull then
            begin
              if not FieldByName('STARTQU').IsNull then
                from_s := FieldbyName('STARTQU').Value;
              from_s := from_s + ' ' + FieldByName('STARTAGE').Value;
            end;
          to_s := '';
          if not FieldByName('ENDAGE').IsNull then
            begin
              if not FieldByName('ENDQU').IsNull then
                to_s := FieldbyName('ENDQU').Value;
              to_s := to_s + ' ' + FieldByName('ENDAGE').Value;
            end;
          if from_s = to_s
            then s := s + from_s
            else s := s + from_s + ' - ' + to_s;
          if not FieldByName('CTRYHOST').IsNull then
            s := s + ' (' + FieldByName('CTRYHOST').Value + ')';
          Next;
        end;
      Close;
    end;
  if s <> '' then
    while s[1] = ' ' do
      Delete(s,1,1);
  Result := s;
end;

function TfmGenerateHTML320.GetGeosig(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s,t: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select SIGTYPE,RESPONSE from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          t := '';
          if not FieldByName('SIGTYPE').IsNull then
            t := t + GetUCaption(tn,'SIGTYPE') + ' ' + FieldByName('SIGTYPE').Value;
          if not FieldByName('RESPONSE').IsNull then
            t := t + '; ' + GetUCaption(tn,'RESPONSE') + ' ' + FieldByName('RESPONSE').Value;
          if t <> '' then
            s := s + SL + t + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetHostRocks(tn,k,sep: string;entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  hostrock: string;
  hostcat: string;
  hostrqul: string;
  hseries: string;
  hdepset: string;
  metgrade: string;
  component: string;
  externalform: string;
  externalform_tn: string;
  protoliths: string;
  protoliths_tn: string;
  internalstructure: string;
  internalstructure_tn: string;
  lithology: string;
  lithology_tn: string;
  stratigraphy: string;
  stratigraphy_tn: string;
  subkey_fn: string;
  s: string;
  details: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select RANK,HOSTROCK,HOSTCAT,HOSTRQUL,HSERIES,' +
                     'HDEPSET,METGRADE,COMPONENT from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          hostrock := '';
          hostcat := '';
          hostrqul := '';
          hseries := '';
          hdepset := '';
          metgrade := '';
          component := '';
          if not FieldByName('HOSTCAT').IsNull then
            hostcat := FieldByName('HOSTCAT').Value;
          if not FieldByName('HOSTROCK').IsNull then
            if hostcat <> ''
              then hostrock := '; ' + FieldByName('HOSTROCK').Value
              else hostrock := FieldByName('HOSTROCK').Value;
          if not FieldByName('HOSTRQUL').IsNull then
            if (hostcat + hostrock) <> ''
              then hostrqul := ' (' + FieldByName('HOSTRQUL').Value + ')'
              else hostrqul := '(' + FieldByName('HOSTRQUL').Value + ')';
          if not FieldByName('HSERIES').IsNull then
            if (hostcat + hostrock + hostrqul) <> ''
              then hseries := '; ' + GetUCaption(tn,'HSERIES') +
                              ' ' + FieldByName('HSERIES').Value
              else hseries := GetUCaption(tn,'HSERIES') + ' ' +
                              FieldByName('HSERIES').Value;
          if not FieldByName('HDEPSET').IsNull then
            if (hostcat + hostrock + hostrqul + hseries) <> ''
              then hdepset := '; ' + GetUCaption(tn,'HDEPSET') + ' ' +
                              FieldByName('HDEPSET').Value
              else hdepset := GetUCaption(tn,'HDEPSET') + ' ' +
                              FieldByName('HDEPSET').Value;
          if not FieldByName('METGRADE').IsNull then
            if (hostcat + hostrock + hostrqul + hseries + hdepset) <> ''
              then metgrade := '; ' + GetUCaption(tn,'METGRADE') +
                               ' ' + FieldByName('METGRADE').Value
              else metgrade := GetUCaption(tn,'METGRADE') + ' ' +
                               FieldByName('METGRADE').Value;
          if not FieldByName('COMPONENT').IsNull then
            if (hostcat + hostrock + hostrqul + hseries + hdepset + metgrade) <> ''
              then component := '; ' + GetUCaption(tn,'COMPONENT') +
                                ' ' + FieldByName('COMPONENT').Value
              else component := GetUCaption(tn,'COMPONENT') + ' ' +
                                FieldByName('COMPONENT').Value;

          s := s + SL + '(' + IntToStr(FieldByName('RANK').AsInteger) + ') ' + hostcat +
               hostrock + hostrqul + hseries + hdepset + metgrade + component + SR;

          if tn = 'dghostrx'
            then
              begin
                externalform_tn := 'dghform';
                protoliths_tn := 'dghproto';
                internalstructure_tn := 'dghstruc';
                lithology_tn := 'dghlith';
                stratigraphy_tn := 'dghstrat';
                subkey_fn := 'DGHRANK';
              end
            else
              begin
                externalform_tn := 'dphform';
                protoliths_tn := 'dphproto';
                internalstructure_tn := 'dphstruc';
                lithology_tn := 'dphlith';
                stratigraphy_tn := 'dphstrat';
                subkey_fn := 'DPHRANK';
              end;
          details := '';
          externalform := GetExternalForm(externalform_tn,'HFORM',k,subkey_fn,
                          IntToStr(FieldByName('RANK').Value),sep,entity_key);
          protoliths := GetProtoliths(protoliths_tn,k,subkey_fn,
                        IntToStr(FieldByName('RANK').Value),sep,entity_key);
          internalstructure := GetInternalStructure(internalstructure_tn,k,subkey_fn,
                          IntToStr(FieldByName('RANK').Value),sep,entity_key);
          lithology := GetLithology(lithology_tn,k,subkey_fn,
                       IntToStr(FieldByName('RANK').Value),sep,entity_key);
          stratigraphy := GetStratigraphy(stratigraphy_tn,k,subkey_fn,
                       IntToStr(FieldByName('RANK').Value),sep,entity_key);
          if (externalform + protoliths + internalstructure + lithology + stratigraphy) <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              if externalform <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(externalform_tn) + '</td>' +
                           '<td ' + AL + '>' + externalform + '</td></tr>';
              if protoliths <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(protoliths_tn) + '</td>' +
                           '<td ' + AL + '>' + protoliths + '</td></tr>';
              if internalstructure <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(internalstructure_tn) + '</td>' +
                           '<td ' + AL + '>' + internalstructure + '</td></tr>';
              if lithology <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(lithology_tn) + '</td>' +
                           '<td ' + AL + '>' + lithology + '</td></tr>';
              if stratigraphy <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(stratigraphy_tn) + '</td>' +
                           '<td ' + AL + '>' + stratigraphy + '</td></tr>';
              details := details + '</table>';
            end;
          s := s + details;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetInternalStructure(tn,k,fn,l,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, fn: fieldname (second key field), k2: key value, sep: separator
var
  hstruc: string;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select HSTRUC from ' + tn + ' ' +
                     Format('where (%s = %s) and (%s = %s) order by RANK',[entity_key,k,fn,l]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          hstruc := '';
          if not FieldByName('HSTRUC').IsNull then
            hstruc := FieldByName('HSTRUC').Value;
          s := s + hstruc;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetLCaption(tn: string;fn: string = ''): string;
var
  s: string;
  ts: string;
begin
  s := GetCaption(tn,fn);
  ts := AnsiLowerCase(Copy(s,1,1)) + Copy(s,2,Length(s));
  ts := StringReplace(ts,' ','&nbsp;',[rfReplaceAll]);
  if (fn = '') or
     (fn = 'DEPCLAN') or
     (fn = 'GEOLPROV') or
     (fn = 'GSUBPROV') or
     (fn = 'GDISTRICT') or
     (fn = 'OBJLOC')
    then Result := '<b>' + ts + ':</b>'
    else Result := '<span class="underlined">' + ts + '</span>:';
end;

function TfmGenerateHTML320.GetLithology(tn,k,fn,l,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, fn: fieldname (second key field), k2: key value, sep: separator
var
  lithcomp: string;
  lithqual: string;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select LITHCOMP,LITHQUAL from ' + tn + ' ' +
                     Format('where (%s = %s) and (%s = %s) order by RANK',[entity_key,k,fn,l]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          lithcomp := '';
          lithqual := '';
          if not FieldByName('LITHCOMP').IsNull then
            lithcomp := FieldByName('LITHCOMP').Value;
          if not FieldByName('LITHQUAL').IsNull then
            if lithcomp <> ''
              then lithqual := ' (' + FieldByName('LITHQUAL').Value + ')'
              else lithqual := '(' + FieldByName('LITHQUAL').Value + ')';
          s := s + lithcomp + lithqual;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

procedure TfmGenerateHTML320.GetMinenos(k: string;var Minenos: TStringList;
  var Minenames: TStringList);
begin
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select d.MINENO,m.MINENAME ' +
                     'from dpmine d left outer join mine m ' +
                     'on d.MINENO = m.MINENO ' +
                     'where d.DEPNO = ' + k + ' ' +
                     'order by d.MINENO';
      Open;
      while not EOF do
        begin
          if not FieldByName('MINENO').IsNull then
            begin
              Minenos.Add(IntToStr(FieldByName('MINENO').Value));
              if not FieldByName('MINENAME').IsNull
                then Minenames.Add(FieldByName('MINENAME').Value)
                else Minenames.Add(dmQuery.GQ_NONAME);
            end;
          Next;
        end;
      Close;
    end;
end;

function TfmGenerateHTML320.GetMineOwner(k,sep: string): string;
// k: key value, sep: separator
var
  mineowner: string;
  percent: string;
  s: string;
begin
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select OWNER,SHAREPCT from mineowner ' +
                     'where MINENO = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          mineowner := '';
          percent := '';
          if not FieldByName('OWNER').IsNull then
            mineowner := FieldByName('OWNER').Value;
          if not FieldByName('SHAREPCT').IsNull then
            if mineowner <> '' then
              percent := ' (' + IntToStr(FieldByName('SHAREPCT').Value) + '%)';
          s := s + mineowner + percent;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetMineralizationStyle(tn,k,sep: string;entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s,t: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select MINSTYL,COMPONENT from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          t := '';
          if not FieldByName('MINSTYL').IsNull then
            t := t + FieldByName('MINSTYL').Value;
          if not FieldByName('COMPONENT').IsNull then
            t := t + ' (' + FieldByName('COMPONENT').Value + ')';
          if t <> '' then
            s := s + SL + t + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetMineralogy(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  PreviousCategory: string;
  category: string;
  mineral: string;
  component: string;
  s,t: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select CATEGORY,MINERAL,COMPONENT from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by CATEGORY,RANK';
      Open;
      PreviousCategory := '';
      s := '';
      t := '';
      while not EOF do
        begin
          if FieldByName('CATEGORY').IsNull
            then category := ''
            else category := FieldByname('CATEGORY').Value;
          if FieldByName('MINERAL').IsNull
            then mineral := ''
            else mineral := FieldByName('MINERAL').Value;
          if FieldByName('COMPONENT').IsNull
            then component := ''
            else component := FieldByName('COMPONENT').Value;
          if (category + component) = PreviousCategory
            then
              if mineral <> ''
                then if t = ''
                       then t := mineral
                       else t := t + ', ' + mineral
                else
            else
              begin
                if t <> ''
                  then s := s + t + sep
                  else if s <> '' then
                         s := s + sep;
                if (category <> '') and (component <> '') then
                  t := '(' + category + ' / ' + component + '): ' + mineral
                else
                if (category <> '') and (component = '') then
                  t := '(' + category + '): ' + mineral
                else
                if (category = '') and (component <> '') then
                  t := '(' + ' / ' + component + '): ' + mineral
                else t := mineral;
                PreviousCategory := category + component;
              end;
          Next;
        end;
      Close;
    end;
  if t <> '' then
    s := s + t;
  Result := s;
end;

function TfmGenerateHTML320.GetPoliticalLocation(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  country: string;
  provstate: string;
  subprov: string;
  nearcity: string;
  farinfo: string;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select COUNTRY,PROVSTATE,SUBPROV,NEARCITY,HOWFAR,FARUNITS,DIRFROM ' +
                     'from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          country := '';
          provstate := '';
          subprov := '';
          nearcity := '';
          if not FieldByName('COUNTRY').IsNull then
            country := FieldByName('COUNTRY').Value;
          if not FieldByName('PROVSTATE').IsNull then
            if country <> ''
              then provstate := '; ' + GetUCaption(tn,'PROVSTATE') +
                                ' ' + FieldByName('PROVSTATE').Value
              else provstate := GetUCaption(tn,'PROVSTATE') + ' ' +
                                FieldByName('PROVSTATE').Value;
          if not FieldByName('SUBPROV').IsNull then
            if (country + provstate) <> ''
              then subprov := '; ' + GetUCaption(tn,'SUBPROV') +
                              ' ' + FieldByName('SUBPROV').Value
              else subprov := GetUCaption(tn,'SUBPROV') + ' ' +
                              FieldByName('SUBPROV').Value;
          if not FieldByName('NEARCITY').IsNull then
            if (country + provstate + subprov) <> ''
              then nearcity := '; ' + GetUCaption(tn,'NEARCITY') +
                               ' ' + FieldByName('NEARCITY').Value
              else nearcity := GetUCaption(tn,'NEARCITY') + ' ' +
                               FieldByName('NEARCITY').Value;
          if FieldByName('HOWFAR').IsNull
            then farinfo := ''
            else farinfo := GetFarInfo(FloatToStrFCustom(FieldByName('HOWFAR').AsFloat),
                                       FieldByName('FARUNITS').AsString,
                                       FieldByName('DIRFROM').AsString);
          s := s + SL + country + provstate + subprov + nearcity + farinfo + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetReference(refno: string): string;
var
  authors_s: string;
  pubyear_s: string;
  title_s: string;
  citation_s: string;
  s: string;
begin
  s := '';
  pubyear_s := '';
  title_s := '';
  citation_s := '';
  with dmGlobalC.FindRef do
    begin
      Close;
      CommandText := 'select REFNO,TITLE,PUBYEAR,SRCTP ' +
                     'from refmain ' +
                     'where REFNO = ' + refno;
      Open;
      if not EOF then
        begin
          if not FieldByName('PUBYEAR').IsNull then
            pubyear_s := IntToStr(FieldByName('PUBYEAR').Value);
          authors_s := GetAuthors(REFNO);
          if FieldByName('SRCTP').Value = 'SV' then
            authors_s := authors_s + ' (Editor(s))';
          if pubyear_s <> '' then
            authors_s := authors_s + ', ' + pubyear_s;
          if not FieldByName('TITLE').IsNull then
            title_s := FieldByName('TITLE').Value;
          if not FieldByName('SRCTP').IsNull then
            begin
              if FieldByName('SRCTP').Value = 'F' then
                citation_s := SRCTP_F(REFNO);
              if FieldByName('SRCTP').Value = 'M' then
                citation_s := SRCTP_M(REFNO);
              if FieldByName('SRCTP').Value = 'NP' then
                citation_s := SRCTP_NP(REFNO);
              if FieldByName('SRCTP').Value = 'P' then
                citation_s := SRCTP_P(REFNO);
              if FieldByName('SRCTP').Value = 'R' then
                citation_s := SRCTP_R(REFNO);
              if FieldByName('SRCTP').Value = 'SA' then
                citation_s := SRCTP_SA(REFNO);
              if FieldByName('SRCTP').Value = 'SV' then
                citation_s := SRCTP_SV(REFNO);
              if FieldByName('SRCTP').Value = 'V' then
                citation_s := SRCTP_V(REFNO);
            end;
        end;
      Close;
    end;
  if authors_s <> '' then
    s := s + authors_s;
  if title_s <> '' then
    if s = ''
      then s := s + title_s
      else s := s + ': ' + title_s;
  if citation_s <> '' then
    if s = ''
      then s := s + citation_s
      else s := s + '; ' + citation_s;
  Result := s;
end;

function TfmGenerateHTML320.GetRelatedIgneousRocks(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  rigneous: string;
  igncat: string;
  rignrqul: string;
  rignrnam: string;
  mseries: string;
  mdepset: string;
  component: string;
  lithology: string;
  lithology_tn: string;
  externalform: string;
  externalform_tn: string;
  subkey_fn: string;
  s: string;
  details: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select RANK,RIGNEOUS,IGNCAT,RIGNRQUL,RIGNRNAM,MSERIES,MDEPSET,COMPONENT from ' +
                     tn + ' ' + 'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          rigneous := '';
          igncat := '';
          rignrqul := '';
          rignrnam := '';
          mseries := '';
          mdepset := '';
          component := '';
          if not FieldByName('IGNCAT').IsNull then
            igncat := FieldByName('IGNCAT').Value;
          if not FieldByName('RIGNEOUS').IsNull then
            if igncat <> ''
              then rigneous := '; ' + FieldByName('RIGNEOUS').Value
              else rigneous := FieldByName('RIGNEOUS').Value;
          if not FieldByName('RIGNRQUL').IsNull then
            if (igncat + rigneous) <> ''
              then rignrqul := ' (' + FieldByName('RIGNRQUL').Value + ')'
              else rignrqul := '(' + FieldByName('RIGNRQUL').Value + ')';
          if not FieldByName('RIGNRNAM').IsNull then
            if (igncat + rigneous + rignrqul) <> ''
              then rignrnam := '; ' + GetUCaption(tn,'RIGHRNAM') + ' ' + FieldByName('RIGNRNAM').Value
              else rignrnam := GetUCaption(tn,'RIGHRNAM') + ' ' + FieldByName('RIGNRNAM').Value;
          if not FieldByName('MSERIES').IsNull then
            if (igncat + rigneous + rignrqul + rignrnam) <> ''
              then mseries := '; ' + GetUCaption(tn,'MSERIES') +
                              ' ' + FieldByName('MSERIES').Value
              else mseries := GetUCaption(tn,'MSERIES') + ' ' +
                              FieldByName('MSERIES').Value;
          if not FieldByName('MDEPSET').IsNull then
            if (igncat + rigneous + rignrqul + rignrnam + mseries) <> ''
              then mdepset := '; ' + GetUCaption(tn,'MDEPSET') + ' ' +
                              FieldByName('MDEPSET').Value
              else mdepset := GetUCaption(tn,'MDEPSET') + ' ' +
                              FieldByName('MDEPSET').Value;
          if not FieldByName('COMPONENT').IsNull then
            if (igncat + rigneous + rignrqul + rignrnam + mseries + mdepset) <> ''
              then component := '; ' + GetUCaption(tn,'COMPONENT') +
                                ' ' + FieldByName('COMPONENT').Value
              else component := GetUCaption(tn,'COMPONENT') + ' ' +
                                FieldByName('COMPONENT').Value;

          s := s + SL + '(' + IntToStr(FieldByName('RANK').AsInteger) + ') ' + igncat +
               rigneous + rignrqul + rignrnam + mseries + mdepset + component + SR;

          if tn = 'dgignrx'
            then
              begin
                lithology_tn := 'dgrlith';
                externalform_tn := 'dgrform';
                subkey_fn := 'DGRRANK';
              end
            else
              begin
                lithology_tn := 'dprlith';
                externalform_tn := 'dprform';
                subkey_fn := 'DPRRANK';
              end;
          details := '';
          lithology := GetLithology(lithology_tn,k,subkey_fn,
                       IntToStr(FieldByName('RANK').Value),sep,entity_key);
          externalform := GetExternalForm(externalform_tn,'RFORM',k,subkey_fn,
                          IntToStr(FieldByName('RANK').Value),sep,entity_key);
          if (lithology + externalform) <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              if lithology <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(lithology_tn) + '</td>' +
                           '<td ' + AL + '>' + lithology + '</td></tr>';
              if externalform <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(externalform_tn) + '</td>' +
                           '<td ' + AL + '>' + externalform + '</td></tr>';
              details := details + '</table>';
            end;
          s := s + details;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetResourceCutoff(k,sep: string): string;
// k: key value, sep: separator
var
  commodity: string;
  gradvalue: string;
  grdunits: string;
  s: string;
begin
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select COMMODITY,GRADVALUE,GRDUNITS from rescut ' +
                     Format('where RESNO = %s order by RANK',[k]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          commodity := '';
          gradvalue := '';
          grdunits := '';
          if not FieldByName('COMMODITY').IsNull then
            commodity := FieldByName('COMMODITY').Value;
          if not FieldByName('GRADVALUE').IsNull then
            if commodity <> ''
              then gradvalue := ': ' + FloatToStrFCustom(FieldByName('GRADVALUE').AsFloat)
              else gradvalue := FloatToStrFCustom(FieldByName('GRADVALUE').AsFloat);
          if not FieldByName('GRDUNITS').IsNull then
            if (commodity + gradvalue) <> ''
              then grdunits := ' ' + FieldByName('GRDUNITS').Value
              else grdunits := FieldByName('GRDUNITS').Value;
          s := s + commodity + gradvalue + grdunits;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetResourceGrades(k,sep: string): string;
// k: key value, sep: separator
var
  commodity: string;
  gradvalue: string;
  grdunits: string;
  s: string;
begin
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select COMMODITY,GRADVALUE,GRDUNITS from resgrade ' +
                     Format('where RESNO = %s order by RANK',[k]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          commodity := '';
          gradvalue := '';
          grdunits := '';
          if not FieldByName('COMMODITY').IsNull then
            commodity := FieldByName('COMMODITY').Value;
          if not FieldByName('GRADVALUE').IsNull then
            if commodity <> ''
              then gradvalue := ': ' + FloatToStrFCustom(FieldByName('GRADVALUE').AsFloat)
              else gradvalue := FloatToStrFCustom(FieldByName('GRADVALUE').AsFloat);
          if not FieldByName('GRDUNITS').IsNull then
            if (commodity + gradvalue) <> ''
              then grdunits := ' ' + FieldByName('GRDUNITS').Value
              else grdunits := FieldByName('GRDUNITS').Value;
          s := s + commodity + gradvalue + grdunits;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetResources(SQLString:TStringList;tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  proportion: string;
  estyear: integer;
  estmonth: integer;
  estday: integer;
  component: string;
  tonnage: string;
  tonunits: string;
  product: string;
  resprod: string;
  notrecmd: string;
  rescat: string;
  refno: string;
  resourcedate: string;
  resourcegrades: string;
  resourcecutoff: string;
  resourceweights: string;
  containedresources: string;
  additionalresources: string;
  details: string;
  s: string;
  empty: boolean;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := SQLString.Text;
      StringReplace(CommandText,#13 + #10,' ',[rfReplaceAll]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep + sep + sep;
          proportion := '';
          component := '';
          tonnage := '';
          tonunits := '';
          product := '';
          resprod := '';
          notrecmd := '';
          rescat := '';
          refno := '';
          empty := True;
          if not FieldByName('ESTYEAR').IsNull
            then estyear := FieldByName('ESTYEAR').Value
            else estyear := 0;
          if not FieldByName('ESTMONTH').IsNull
            then estmonth := FieldByName('ESTMONTH').Value
            else estmonth := 0;
          if not FieldByName('ESTDAY').IsNull
            then estday := FieldByName('ESTDAY').Value
            else estday := 0;
          resourcedate := BuildDate(estyear,estmonth,estday);
          if resourcedate <> '' then
            begin
              resourcedate := '<span class="underlined">' + dmQuery.GQ_ESTIMATEDATE + '</span>: ' + resourcedate;
              empty := False;
            end;
          if not FieldByName('COMPONENT').IsNull then
            if not empty
              then component := '; ' + GetUCaption('resmain','COMPONENT') +
                             ' ' + FieldByName('COMPONENT').Value
              else
                begin
                  component := GetUCaption('resmain','COMPONENT') + ' ' +
                             FieldByName('COMPONENT').Value;
                  empty := False;
                end;
          if not FieldByName('TONNAGE').IsNull then
            if not empty
              then tonnage := '; ' + FloatToStrFCustom(FieldByName('TONNAGE').AsFloat)
              else
                begin
                  tonnage := FloatToStrFCustom(FieldByName('TONNAGE').AsFloat);
                  empty := False;
                end;
          if not FieldByName('TONUNITS').IsNull then
            if not empty
              then tonunits := ' ' + FieldByName('TONUNITS').Value
              else
                begin
                  tonunits := FieldByName('TONUNITS').Value;
                  empty := False;
                end;
          if not FieldByName('PRODUCT').IsNull then
            if not empty
              then product := ' ' + FieldByName('PRODUCT').Value
              else
                begin
                  product := FieldByName('PRODUCT').Value;
                  empty := False;
                end;
          if not FieldByName('RESPROD').IsNull then
            if dmGlobalC.IsTrue(FieldByName('RESPROD').Value)
              then resprod := dmQuery.GQ_YES
              else resprod := genhtml319_No;
          if not FieldByName('RESPROD').IsNull then
            if not empty
              then resprod := '; ' + GetUCaption('resmain','RESPROD') + ' ' + resprod
              else
                begin
                  resprod := GetUCaption('resmain','RESPROD') + ' ' + resprod;
                  empty := False;
                end;
          if not FieldByName('NOTRECMD').IsNull then
//            if dmGlobalC.IsTrue(FieldByName('NOTRECMD').Value)
            if not dmGlobalC.IsTrue(FieldByName('NOTRECMD').Value)
              then notrecmd := genhtml319_No
              else notrecmd := dmQuery.GQ_YES;
          if not FieldByName('NOTRECMD').IsNull then
            if not empty
              then notrecmd := '; ' + GetUCaption('resmain','NOTRECMD') + ' ' + notrecmd
              else
                begin
                  notrecmd := GetUCaption('resmain','NOTRECMD') + ' ' + notrecmd;
                  empty := False;
                end;
          if not FieldByName('RESCAT').IsNull then
            if not empty
              then rescat := '; ' + GetUCaption('resmain','RESCAT') +
                             ' ' + FieldByName('RESCAT').Value
              else rescat := GetUCaption('resmain','RESCAT') + ' ' +
                             FieldByName('RESCAT').Value;

          s := s + SL + resourcedate + component + tonnage + tonunits +
               product + resprod + notrecmd + rescat + SR;

          resourcegrades := GetResourceGrades(IntToStr(FieldByName('RESNO').AsInteger),sep);
          resourcecutoff := GetResourceCutoff(IntToStr(FieldByName('RESNO').AsInteger),sep);
          resourceweights := GetResourceWeights(IntToStr(FieldByName('RESNO').AsInteger),sep);
          if (resourcegrades + resourcecutoff + resourceweights) <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              if resourcegrades <> '' then
                begin
                  details := details + '<tr><td ' + AR + '>' +
                             GetUCaption('resgrade') + '</td>';
                  details := details + '<td ' + AL + '>' + resourcegrades + '</td></tr>';
                end;
              if resourcecutoff <> '' then
                begin
                  details := details + '<tr><td ' + AR + '>' +
                             GetUCaption('rescut') + '</td>';
                  details := details + '<td ' + AL + '>' + resourcecutoff + '</td></tr>';
                end;
              if resourceweights <> '' then
                begin
                  if (tonnage = '') or (resourcegrades = '')
                    then details := details + '<tr><td ' + AR + '>' +
                                    GetUCaption('reswgt') + '</td>'
                    else details := details + '<tr><td ' + AR + '>' +
                                    GetLCaption('reswgt') + '</td>';
                  details := details + '<td ' + AL + '>' + resourceweights +
                             '</td></tr>';
                end;
              details := details + '</table>';
              s := s + details;
            end;

          if tn = 'resmine'
            then containedresources := GetContainedResources(tn,k,
                   IntToStr(FieldByName('RESNO').AsInteger),sep,'MINENO')
            else containedresources := GetContainedResources(tn,k,
                   IntToStr(FieldByName('RESNO').AsInteger),sep,entity_key);
          if containedresources <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              details := details + '<tr><td ' + AR + '>' + dmQuery.GQ_ALSOCONTAINING + '</td>';
              details := details + '<td ' + AL + '>' + containedresources + '</td></tr>';
              details := details + '</table>';
              s := s + details;
            end;
          if tn = 'resmine'
            then additionalresources := GetAdditionalResources(tn,k,
                   IntToStr(FieldByName('RESNO').AsInteger),sep,'MINENO')
            else additionalresources := GetAdditionalResources(tn,k,
                   IntToStr(FieldByName('RESNO').AsInteger),sep,entity_key);
          if additionalresources <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              details := details + '<tr><td ' + AR + '>' + dmQuery.GQ_ADDRESOURCES + '</td>';
              details := details + '<td ' + AL + '>' + additionalresources + '</td></tr>';
              details := details + '</table>';
              s := s + details;
            end;
          if not FieldByName('REFNO').IsNull then
           if (resourcegrades + resourcecutoff + resourceweights +
               containedresources + additionalresources) <> ''
             then s := s + SL + GetUCaption('resmain','REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR
             else s := s + sep + SL + GetUCaption('resmain','REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR;
          if not FieldByName('PROPORTION').IsNull then
            proportion := GetUCaption(tn,'PROPORTION') + ' ' +
                          Format('%5.1f%s',[FieldByName('PROPORTION').AsFloat,'%']);
          s := s + sep + SL + proportion + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetResourceWeights(k,sep: string): string;
// k: key value, sep: separator
var
  commodity: string;
  wgtvalue: string;
  wgtunits: string;
  s: string;
begin
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select COMMODITY,WGTVALUE,WGTUNITS from reswgt ' +
                     Format('where RESNO = %s order by RANK',[k]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          commodity := '';
          wgtvalue := '';
          wgtunits := '';
          if not FieldByName('COMMODITY').IsNull then
            commodity := FieldByName('COMMODITY').Value;
          if not FieldByName('WGTVALUE').IsNull then
            if commodity <> ''
              then wgtvalue := ': ' + FloatToStrFCustom(FieldByName('WGTVALUE').AsFloat)
              else wgtvalue := FloatToStrFCustom(FieldByName('WGTVALUE').AsFloat);
          if not FieldByName('WGTUNITS').IsNull then
            if (commodity + wgtvalue) <> ''
              then wgtunits := ' ' + FieldByName('WGTUNITS').Value
              else wgtunits := FieldByName('WGTUNITS').Value;
          s := s + commodity + wgtvalue + wgtunits;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetSamples(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  samptype: string;
  sampwgt: string;
  sampsize: string;
  sampdesc: string;
  sampass: string;
  sampxlink: string;
  sampxsrc: string;
  smpgrade_tn: string;
  smpwgt_tn: string;
  subkey_fn: string;
  grades: string;
  weights: string;
  s: string;
  details: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select RANK,SAMPTYPE,SAMPWGT,WGTUNITS,SAMPSIZE,SAMPDESC, ' +
                     'SAMPASS,SAMPXLINK,SAMPXSRC,REFNO from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          samptype := '';
          sampwgt := '';
          sampsize := '';
          sampdesc := '';
          sampass := '';
          sampxlink := '';
          sampxsrc := '';
          if not FieldByName('SAMPTYPE').IsNull then
            samptype := GetUCaption(tn,'SAMPTYPE') + ' ' +
                        FieldByName('SAMPTYPE').AsString;
          if not ((FieldByName('SAMPWGT').IsNull) or (FieldByName('SAMPWGT').AsFloat = 0.0)) then
            if (samptype) <> ''
              then sampwgt := '; ' + GetUCaption(tn,'SAMPWGT') + ' ' +
                              FieldByName('SAMPWGT').AsString
              else sampwgt := GetUCaption(tn,'SAMPWGT') + ' ' +
                              FieldByName('SAMPWGT').AsString;
          if not FieldByName('WGTUNITS').IsNull then
            sampwgt := sampwgt + ' ' + FieldByName('WGTUNITS').AsString;
          if not FieldByName('SAMPSIZE').IsNull then
            if (samptype + sampwgt) <> ''
              then sampsize := '; ' + GetUCaption(tn,'SAMPSIZE') + ' ' +
                               FieldByName('SAMPSIZE').AsString
              else sampsize := GetUCaption(tn,'SAMPSIZE') + ' ' +
                               FieldByName('SAMPSIZE').AsString;
          if not FieldByName('SAMPDESC').IsNull then
            if (samptype + sampwgt + sampsize) <> ''
              then sampdesc := '; ' + GetUCaption(tn,'SAMPDESC') + ' ' +
                               FieldByName('SAMPDESC').AsString
              else sampdesc := GetUCaption(tn,'SAMPDESC') + ' ' +
                               FieldByName('SAMPDESC').AsString;
          if not FieldByName('SAMPASS').IsNull then
            if (samptype + sampwgt + sampsize + sampdesc) <> ''
              then sampass := '; ' + GetUCaption(tn,'SAMPASS') + ' ' +
                              FieldByName('SAMPASS').AsString
              else sampass := GetUCaption(tn,'SAMPASS') + ' ' +
                              FieldByName('SAMPASS').AsString;
          if not FieldByName('SAMPXLINK').IsNull then
            if (samptype + sampwgt + sampsize + sampdesc + sampass) <> ''
              then sampxlink := '; ' + GetUCaption(tn,'SAMPXLINK') + ' ' +
                                FieldByName('SAMPXLINK').AsString
              else sampxlink := GetUCaption(tn,'SAMPXLINK') + ' ' +
                                FieldByName('SAMPXLINK').AsString;
          if not FieldByName('SAMPXSRC').IsNull then
            if (samptype + sampwgt + sampsize + sampdesc + sampass + sampxlink) <> ''
              then sampxsrc := '; ' + GetUCaption(tn,'SAMPXSRC') + ' ' +
                               FieldByName('SAMPXSRC').AsString
              else sampxsrc := GetUCaption(tn,'SAMPXSRC') + ' ' +
                               FieldByName('SAMPXSRC').AsString;
          s := s + SL + '(' + IntToStr(FieldByName('RANK').AsInteger) + ') ' + samptype +
               sampwgt + sampsize + sampdesc + sampass + sampxlink + sampxsrc + SR;
          if tn = 'dgsample'
            then
              begin
                smpgrade_tn := 'dgsmpgrade';
                smpwgt_tn := 'dgsmpwgt';
                subkey_fn := 'DGSRANK';
              end
            else
              begin
                smpgrade_tn := 'dpsmpgrade';
                smpwgt_tn := 'dpsmpwgt';
                subkey_fn := 'DPSRANK';
              end;
          details := '';
          grades := GetSampleGrades(smpgrade_tn,k,subkey_fn,
                        IntToStr(FieldByName('RANK').Value),sep,entity_key);
          weights := GetSampleWeights(smpwgt_tn,k,subkey_fn,
                       IntToStr(FieldByName('RANK').Value),sep,entity_key);
          if (grades + weights) <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              if grades <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(smpgrade_tn) + '</td>' +
                           '<td ' + AL + '>' + grades + '</td></tr>';
              if weights <> '' then
                details := details + '<tr><td ' + AR + '>' +
                           GetUCaption(smpwgt_tn) + '</td>' +
                           '<td ' + AL + '>' + weights + '</td></tr>';
              details := details + '</table>';
            end;
          s := s + details;
          if not ((FieldByName('REFNO').IsNull) or (FieldByName('REFNO').AsInteger = 0)) then
           if (grades + weights) <> ''
             then s := s + SL + GetUCaption(tn,'REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR
             else s := s + sep + SL + GetUCaption(tn,'REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetSampleGrades(smpgrade_tn,k,subkey_fn,rk,sep,entity_key: string): string;
// k: key value, sep: separator
var
  commodity: string;
  gradvalue: string;
  grdunits: string;
  anmethod: string;
  s: string;
begin
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := Format('select COMMODITY,GRADVALUE,GRDUNITS,ANMETHOD from %s ' +
                            'where (%s = %s) and (%s = %s) order by RANK',
                            [smpgrade_tn,entity_key,k,subkey_fn,rk]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          commodity := '';
          gradvalue := '';
          grdunits := '';
          anmethod := '';
          if not FieldByName('COMMODITY').IsNull then
            commodity := FieldByName('COMMODITY').AsString;
          if not FieldByName('GRADVALUE').IsNull then
            if commodity <> ''
              then gradvalue := ': ' + FloatToStrFCustom(FieldByName('GRADVALUE').AsFloat)
              else gradvalue := FloatToStrFCustom(FieldByName('GRADVALUE').AsFloat);
          if not FieldByName('GRDUNITS').IsNull then
            if (commodity + gradvalue) <> ''
              then grdunits := ' ' + FieldByName('GRDUNITS').AsString
              else grdunits := FieldByName('GRDUNITS').AsString;
          if not FieldByName('ANMETHOD').IsNull then
            if (commodity + gradvalue + grdunits) <> ''
              then anmethod := ' (' + FieldByName('ANMETHOD').AsString + ')'
              else anmethod := '(' + FieldByName('ANMETHOD').AsString + ')';
          s := s + commodity + gradvalue + grdunits + anmethod;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetSampleWeights(smpwgt_tn,k,subkey_fn,rk,sep,entity_key: string): string;
// k: key value, sep: separator
var
  commodity: string;
  wgtvalue: string;
  wgtunits: string;
  anmethod: string;
  s: string;
begin
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := Format('select COMMODITY,WGTVALUE,WGTUNITS,ANMETHOD from %s ' +
                            'where (%s = %s) and (%s = %s) order by RANK',
                            [smpwgt_tn,entity_key,k,subkey_fn,rk]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          commodity := '';
          wgtvalue := '';
          wgtunits := '';
          anmethod := '';
          if not FieldByName('COMMODITY').IsNull then
            commodity := FieldByName('COMMODITY').AsString;
          if not FieldByName('WGTVALUE').IsNull then
            if commodity <> ''
              then wgtvalue := ': ' + FloatToStrFCustom(FieldByName('WGTVALUE').AsFloat)
              else wgtvalue := FloatToStrFCustom(FieldByName('WGTVALUE').AsFloat);
          if not FieldByName('WGTUNITS').IsNull then
            if (commodity + wgtvalue) <> ''
              then wgtunits := ' ' + FieldByName('WGTUNITS').AsString
              else wgtunits := FieldByName('WGTUNITS').AsString;
          if not FieldByName('ANMETHOD').IsNull then
            if (commodity + wgtvalue + wgtunits) <> ''
              then anmethod := ' (' + FieldByName('ANMETHOD').AsString + ')'
              else anmethod := '(' + FieldByName('ANMETHOD').AsString + ')';
          s := s + commodity + wgtvalue + wgtunits + anmethod;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetStratigraphy(tn,k,fn,l,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, fn: fieldname (second key field), k2: key value, sep: separator
var
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select HOSTRNAM,STRATLEVEL from ' + tn + ' ' +
                     Format('where (%s = %s) and (%s = %s) order by RANK',[entity_key,k,fn,l]);
      Open;
      while not EOF do
        begin
          if not FieldByName('HOSTRNAM').IsNull then
            begin
              if s = ''
                then s := FieldByName('HOSTRNAM').Value
                else s := s + ', ' + FieldByName('HOSTRNAM').Value;
              if not FieldByName('STRATLEVEL').IsNull then
                s := s + ' ' + FieldByName('STRATLEVEL').AsString;
            end;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetString(tn,fn,k,sep: string;entity_key: string = ''): string;
// tn: tablename, fn: fieldname, k: key value, sep: separator
var
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText :=  'select ' + fn + ' from ' + tn + ' ' +
                      'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if not FieldByName(fn).IsNull then
            begin
              if s <> '' then
                s := s + sep;
              s := s + FieldByName(fn).Value;
            end;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetProductionGrades(k,sep: string): string;
// k: key value, sep: separator
var
  commodity: string;
  gradvalue: string;
  grdunits: string;
  s: string;
begin
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select COMMODITY,GRADVALUE,GRDUNITS from prodgrad ' +
                     Format('where PRODNO = %s order by RANK',[k]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          commodity := '';
          gradvalue := '';
          grdunits := '';
          if not FieldByName('COMMODITY').IsNull then
            commodity := FieldByName('COMMODITY').Value;
          if not FieldByName('GRADVALUE').IsNull then
            if commodity <> ''
              then gradvalue := ': ' + FloatToStrFCustom(FieldByName('GRADVALUE').AsFloat)
              else gradvalue := FloatToStrFCustom(FieldByName('GRADVALUE').AsFloat);
          if not FieldByName('GRDUNITS').IsNull then
            if (commodity + gradvalue) <> ''
              then grdunits := ' ' + FieldByName('GRDUNITS').Value
              else grdunits := FieldByName('GRDUNITS').Value;
          s := s + commodity + gradvalue + grdunits;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetName(tn,k,sep: string;entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s,t: string;
  fn: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  if entity_key = 'DEPNO'
    then fn := 'DEPNAME'
    else fn := 'DGNAME';
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select ' + fn + ',NAMETYPE from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          t := '';
          if not FieldByName(fn).IsNull then
            t := t + FieldByName(fn).Value;
          if not FieldByName('NAMETYPE').IsNull then
            t := t + ' (' + FieldByName('NAMETYPE').Value + ')';
          if t <> '' then
            s := s + SL + t + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetNTS(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s,t: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select MAPID,NTSNAME from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          t := '';
          if not FieldByName('MAPID').IsNull then
            t := t + FieldByName('MAPID').Value;
          if not FieldByName('NTSNAME').IsNull then
            t := t + ' (' + FieldByName('NTSNAME').Value + ')';
          if t <> '' then
            s := s + SL + t + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetPageSpecificationsOK(title,root,newdir,head,subhead: string;
  description: TStrings): boolean;
var
  i: integer;
  s: string;
begin
  Result := True;
  if title = ''
    then
      begin
        MessageDlg(genhtml319_YouMustEnterATitle,mtError,[mbOK],0);
        Result := False;
        Exit;
      end
    else HTMLTitle := title;
  if newdir = '' then
    begin
      MessageDlg(genhtml319_YouMustEnterAValidDirectoryName,mtError,[mbOK],0);
      Result := False;
      Exit;
    end;
  if head = ''
    then
      begin
        MessageDlg(genhtml320_YouMustEnterAValidHeading,mtError,[mbOK],0);
        Result := False;
        Exit;
      end
    else PageHeading := AnsiUpperCase(head);
  if subhead = ''
    then
      begin
        MessageDlg(genhtml320_YouMustEnterAValidSubHeading,mtError,[mbOK],0);
        Result := False;
        Exit;
      end
    else PageSubHeading := subhead;
  if description.Count = 0 then
    if MessageDlg(genhtml319_YouDidNotEnterDescription,mtWarning,[mbYes,mbNo],0) = mrNo then
      begin
        Result := False;
        Exit;
      end;
  s := '';
  HTMLPath := root;
  if FullHTMLOutput
    then
      begin
        s := AnsiLowerCase(newdir);
        i := Length(s);
        while i > 0 do
          begin
            if not (s[i] in ['a'..'z','_','0'..'9']) then
              Delete(s,i,1);
            dec(i);
          end;
        if (s = '') or (s[1] = '0') then
          begin
            MessageDlg(genhtml319_YouMustEnterAValidDirectoryName,mtError,[mbOK],0);
            Result := False;
            Exit;
          end;
        if HTMLPath[Length(HTMLPath)] <> '\' then
          HTMLPath := HTMLPath + '\';
        HTMLPath := HTMLPath + s;
        if DirectoryExists(HTMLPath)
          then
            begin
              MessageDlg(genhtml319_DirectoryAlreadyExists,mtError,[mbOK],0);
              Result := False;
              Exit;
            end
          else MkDir(HTMLPath);
        DestinationPath := HTMLPath + '\';
      end
    else
      begin
        DestinationPath := newdir;
        if newdir[Length(newdir)] <> '\' then
          DestinationPath := DestinationPath + '\';
      end;
  if HTMLPath[Length(HTMLPath)] <> '\' then
    HTMLPath := HTMLPath + '\';
  if FullHTMLOutput
    then BaseURL := ''
    else
      begin
        if AnsiLowerCase(Copy(root,1,7)) = 'http://'
          then BaseURL := root
          else
            begin
              BaseURL := StringReplace(root,'\','/',[rfReplaceAll]);
              BaseURL := StringReplace(BaseURL,':','|',[]);
              BaseURL := 'file:///' + BaseURL;
            end;
        if BaseURL[Length(BaseURL)] <> '/' then
          BaseURL := BaseURL + '/';
      end;
end;

function TfmGenerateHTML320.GetProduction(SQLString: TStringList;tn,k,sep: string): string;
// tn: tablename, k: key value, sep: separator
var
  proportion: string;
  stayear: integer;
  stamonth: integer;
  staday: integer;
  endyear: integer;
  endmonth: integer;
  endday: integer;
  tonnage: string;
  tonunits: string;
  product: string;
  notrecmd: string;
  yearsum: string;
  refno: string;
  productiondates: string;
  productiongrades: string;
  productionweights: string;
  details: string;
  s: string;
  empty: boolean;
begin
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := SQLString.Text;
      StringReplace(CommandText,#13 + #10,' ',[rfReplaceAll]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep + sep + sep;
          proportion := '';
          productiondates := '';
          tonnage := '';
          tonunits := '';
          product := '';
          notrecmd := '';
          yearsum := '';
          refno := '';
          empty := True;
          if not FieldByName('STAYEAR').IsNull
            then stayear := FieldByName('STAYEAR').Value
            else stayear := 0;
          if not FieldByName('STAMONTH').IsNull
            then stamonth := FieldByName('STAMONTH').Value
            else stamonth := 0;
          if not FieldByName('STADAY').IsNull
            then staday := FieldByName('STADAY').Value
            else staday := 0;
          if not FieldByName('ENDYEAR').IsNull
            then endyear := FieldByName('ENDYEAR').Value
            else endyear := 0;
          if not FieldByName('ENDMONTH').IsNull
            then endmonth := FieldByName('ENDMONTH').Value
            else endmonth := 0;
          if not FieldByName('ENDDAY').IsNull
            then endday := FieldByName('ENDDAY').Value
            else endday := 0;
          productiondates := BuildDateRange(stayear,stamonth,staday,endyear,
                                            endmonth,endday);
          if productiondates <> '' then
            begin
              productiondates := '<span class="underlined">' + dmQuery.GQ_REPORTPERIOD + '</span>: ' + productiondates;
              empty := False;
            end;
          if not FieldByName('TONNAGE').IsNull then
            if not empty
              then tonnage := '; ' + FloatToStrFCustom(FieldByName('TONNAGE').AsFloat)
              else
                begin
                  tonnage := FloatToStrFCustom(FieldByName('TONNAGE').AsFloat);
                  empty := False;
                end;
          if not FieldByName('TONUNITS').IsNull then
            if not empty
              then tonunits := ' ' + FieldByName('TONUNITS').Value
              else
                begin
                  tonunits := FieldByName('TONUNITS').Value;
                  empty := False;
                end;
          if not FieldByName('PRODUCT').IsNull then
            if not empty
              then product := ' ' + FieldByName('PRODUCT').Value
              else
                begin
                  product := FieldByName('PRODUCT').Value;
                  empty := False;
                end;
          if not FieldByName('NOTRECMD').IsNull then
//            if dmGlobalC.IsTrue(FieldByName('NOTRECMD').Value)
            if not dmGlobalC.IsTrue(FieldByName('NOTRECMD').Value)
              then notrecmd := genhtml319_No
              else notrecmd := dmQuery.GQ_YES;
          if not FieldByName('NOTRECMD').IsNull then
            if not empty
              then notrecmd := '; ' + GetUCaption('prodmain','NOTRECMD') + ' ' + notrecmd
              else
                begin
                  notrecmd := GetUCaption('prodmain','NOTRECMD') + ' ' + notrecmd;
                  empty := False;
                end;
          if not FieldByName('YEARSUM').IsNull then
            if not empty
              then yearsum := '; ' + GetUCaption('prodmain','YEARSUM') +
                              ' ' + FieldByName('YEARSUM').Value
              else yearsum := GetUCaption('prodmain','YEARSUM') + ' ' +
                              FieldByName('YEARSUM').Value;

          s := s + SL + productiondates + tonnage + tonunits +
               product + notrecmd + yearsum + SR;

          productiongrades := GetProductionGrades(IntToStr(FieldByName('PRODNO').AsInteger),
                                                  sep);
          productionweights := GetProductionWeights(IntToStr(FieldByName('PRODNO').AsInteger),
                                                    sep);
          if (productiongrades + productionweights) <> '' then
            begin
              details := '<table border=' + Border + ' cellspacing="2" cellpadding= "2">';
              if productiongrades <> '' then
                begin
                  details := details + '<tr><td ' + AR + '>' +
                             GetUCaption('prodgrad') + '</td>';
                  details := details + '<td ' + AL + '>' + productiongrades +
                             '</td></tr>';
                end;
              if productionweights <> '' then
                begin
                  if (tonnage = '') or (productiongrades = '')
                    then details := details + '<tr><td ' + AR + '>' +
                                    GetUCaption('prodwgt') + '</td>'
                    else details := details + '<tr><td ' + AR + '>' +
                                    GetLCaption('prodwgt') + '</td>';
                  details := details + '<td ' + AL + '>' + productionweights +
                             '</td></tr>';
                end;
              details := details + '</table>';
            end;
          s := s + details;

          if not FieldByName('REFNO').IsNull then
           if (productiongrades + productionweights) <> ''
             then s := s + SL + GetUCaption('prodmain','REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR
             else s := s + sep + SL + GetUCaption('prodmain','REFNO') + ' ' +
                       GetReference(IntToStr(FieldByName('REFNO').Value)) + SR;
          if not FieldByName('PROPORTION').IsNull then
              proportion := GetUCaption(tn,'PROPORTION') + ' ' +
                            Format('%5.1f%s',[FieldByName('PROPORTION').AsFloat,'%']);
          s := s + SL + sep + proportion + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetProductionWeights(k,sep: string): string;
// k: key value, sep: separator
var
  commodity: string;
  wgtvalue: string;
  wgtunits: string;
  s: string;
begin
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select COMMODITY,WGTVALUE,WGTUNITS from prodwgt ' +
                     Format('where PRODNO = %s order by RANK',[k]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          commodity := '';
          wgtvalue := '';
          wgtunits := '';
          if not FieldByName('COMMODITY').IsNull then
            commodity := FieldByName('COMMODITY').Value;
          if not FieldByName('WGTVALUE').IsNull then
            if commodity <> ''
              then wgtvalue := ': ' + FloatToStrFCustom(FieldByName('WGTVALUE').AsFloat)
              else wgtvalue := FloatToStrFCustom(FieldByName('WGTVALUE').AsFloat);
          if not FieldByName('WGTUNITS').IsNull then
            if (commodity + wgtvalue) <> ''
              then wgtunits := ' ' + FieldByName('WGTUNITS').Value
              else wgtunits := FieldByName('WGTUNITS').Value;
          s := s + commodity + wgtvalue + wgtunits;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetProtoliths(tn,k,fn,l,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, fn: fieldname (second key field), k2: key value, sep: separator
var
  protolth: string;
  protoqul: string;
  protonam: string;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindSub do
    begin
      Close;
      CommandText := 'select PROTOLTH,PROTOQUL,PROTONAM from ' + tn + ' ' +
                     Format('where (%s = %s) and (%s = %s) order by RANK',[entity_key,k,fn,l]);
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          protolth := '';
          protoqul := '';
          protonam := '';
          if not FieldByName('PROTOLTH').IsNull then
            protolth := FieldByName('PROTOLTH').Value;
          if not FieldByName('PROTONAM').IsNull then
            if protolth <> ''
              then protonam := '; ' + GetUCaption(tn,'PROTONAM') + ' ' + FieldByName('PROTONAM').Value
              else protonam := GetUCaption(tn,'PROTONAM') + ' ' + FieldByName('PROTONAM').Value;
          if not FieldByName('PROTOQUL').IsNull then
            if (protonam + protolth) <> ''
              then protoqul := ' (' + FieldByName('PROTOQUL').Value + ')'
              else protoqul := '(' + FieldByName('PROTOQUL').Value + ')';
          s := s + protolth + protoqul + protonam;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetRadiometricAge(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  objdated: string;
  objrank: string;
  agema: string;
  pluserr: string;
  minuserr: string;
  method: string;
  concentrat: string;
  sourcerock: string;
  namedated: string;
  whatdated: string;
  interpcom: string;
  refno: string;
  empty: boolean;
  s: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select OBJDATED,OBJRANK,AGEMA,PLUSERR,MINUSERR,METHOD,' +
                     'CONCENTRAT,SOURCEROCK,NAMEDATED,WHATDATED,INTERPCOM,REFNO ' +
                     'from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep + sep;
          objdated := '';
          objrank := '';
          agema := '';
          pluserr := '';
          minuserr := '';
          method := '';
          concentrat := '';
          sourcerock := '';
          namedated := '';
          whatdated := '';
          interpcom := '';
          refno := '';
          empty := True;
          if not FieldByName('OBJDATED').IsNull then
            begin
              objdated := GetUCaption(tn,'OBJDATED') + ' ' +
                          FieldByName('OBJDATED').Value;
              empty := False;
            end;
          if not FieldByName('OBJRANK').IsNull then
            if not empty
              then objrank := '(' + IntToStr(FieldByName('OBJRANK').Value) + ')';
          if not FieldByName('AGEMA').IsNull then
            if not empty
              then agema := '; ' + GetUCaption(tn,'AGEMA') +
                            ' ' + FloatToStrFCustom(FieldByName('AGEMA').Value)
              else
                begin
                  agema := GetUCaption(tn,'AGEMA') +
                           ' ' + FloatToStrFCustom(FieldByName('AGEMA').Value);
                  empty := False;
                end;
          if not FieldByName('PLUSERR').IsNull then
            if not empty
              then pluserr := '; +' + FloatToStrFCustom(FieldByName('PLUSERR').Value)
              else
                begin
                  pluserr := '+' + FloatToStrFCustom(FieldByName('PLUSERR').Value);
                  empty := False;
                end;
          if not FieldByName('MINUSERR').IsNull then
            if not empty
              then minuserr := '; -' + FloatToStrFCustom(FieldByName('MINUSERR').Value)
              else
                begin
                  minuserr := '-' + FloatToStrFCustom(FieldByName('MINUSERR').Value);
                  empty := False;
                end;
          if not FieldByName('METHOD').IsNull then
            if not empty
              then method := '; ' + GetUCaption(tn,'METHOD') +
                             ' ' + FieldByName('METHOD').Value
              else
                begin
                  method := GetUCaption(tn,'METHOD') + ' ' +
                            FieldByName('METHOD').Value;
                  empty := False;
                end;
          if not FieldByName('CONCENTRAT').IsNull then
            if not empty
              then concentrat := '; ' + GetUCaption(tn,'CONCENTRAT') +
                                 ' ' + FieldByName('CONCENTRAT').Value
              else
                begin
                  concentrat := GetUCaption(tn,'CONCENTRAT') + ' ' +
                                FieldByName('CONCENTRAT').Value;
                  empty := False;
                end;
          if not FieldByName('SOURCEROCK').IsNull then
            if not empty
              then sourcerock := '; ' + GetUCaption(tn,'SOURCEROCK') +
                                 ' ' + FieldByName('SOURCEROCK').Value
              else
                begin
                  sourcerock := GetUCaption(tn,'SOURCEROCK') + ' ' +
                                FieldByName('SOURCEROCK').Value;
                  empty := False;
                end;
          if not FieldByName('NAMEDATED').IsNull then
            if not empty
              then namedated := '; ' + GetUCaption(tn,'NAMEDATED') + ' ' + FieldByName('NAMEDATED').Value
              else
                begin
                  namedated := GetUCaption(tn,'NAMEDATED') + ' ' + FieldByName('NAMEDATED').Value;
                  empty := False;
                end;
          if not FieldByName('WHATDATED').IsNull then
            if not empty
              then whatdated := '; ' + GetUCaption(tn,'WHATDATED') +
                                ' ' + FieldByName('WHATDATED').Value
              else
                begin
                  whatdated := GetUCaption(tn,'WHATDATED') + ' ' +
                               FieldByName('WHATDATED').Value;
                  empty := False;
                end;
          if not FieldByName('INTERPCOM').IsNull then
            if not empty
              then interpcom := '; ' + GetUCaption(tn,'INTERPCOM') +
                                ' ' + FieldByName('INTERPCOM').Value
              else
                begin
                  interpcom := GetUCaption(tn,'INTERPCOM') + ' ' +
                               FieldByName('INTERPCOM').Value;
                  empty := False;
                end;
          s := s + objdated + objrank + agema + pluserr + minuserr +
               method + concentrat + sourcerock + namedated + whatdated +
               interpcom;
          if not FieldByName('REFNO').IsNull then
            if not empty
              then s := s + '; ' + GetUCaption(tn,'REFNO') +
                        ' ' + GetReference(IntToStr(FieldByName('REFNO').Value))
              else s := s + GetUCaption(tn,'REFNO') + ' ' +
                        GetReference(IntToStr(FieldByName('REFNO').Value));
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetTectonicSetting(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s,t: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select SETTINGOF,REALM,DFREGIME,TECTOBJ,TECQUAL,TECTNAME from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          t := '';
          if not FieldByName('REALM').IsNull then
            t := t + FieldByName('REALM').Value;
          if not FieldByName('TECTOBJ').IsNull then
            if t <> ''
              then t := t + ' ' + FieldByName('TECTOBJ').Value
              else t := t + FieldByName('TECTOBJ').Value;
          if not FieldByName('TECQUAL').IsNull then
            t := t + '-' + FieldByName('TECQUAL').Value;
          if not FieldByName('DFREGIME').IsNull then
            if t <> ''
              then t := t + '; ' + FieldByName('DFREGIME').Value
              else t := t + FieldByName('DFREGIME').Value;
          if not FieldByName('TECTNAME').IsNull then
            if t <> ''
              then t := t + '; ' + GetUCaption(tn,'TECTNAME') + ' ' + FieldByName('TECTNAME').Value
              else t := t +  GetUCaption(tn,'TECTNAME') + ' ' + FieldByName('TECTNAME').Value;
          if not FieldByName('SETTINGOF').IsNull then
            t := t + ' (' + FieldByName('SETTINGOF').Value + ')';
          if t <> '' then
            s := s + SL + t + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetTectonicStructure(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s,t: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select TSTRUC,TSTRCQUL,TSTRCNAM from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          t := '';
          if not FieldByName('TSTRUC').IsNull then
            t := t + FieldByName('TSTRUC').Value;
          if not FieldByName('TSTRCQUL').IsNull then
            t := t + ' (' + FieldByName('TSTRCQUL').Value + ')';
          if not FieldByName('TSTRCNAM').IsNull then
            t := t + ' ' + GetUCaption(tn,'TSTRCNAM') + ' ' + FieldByName('TSTRCNAM').Value;
          if t <> '' then
            s := s + SL + t + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.GetDisclaimer: string;
begin
  Result := '<table border="1" cellpadding="5">' +
            '<tr><td>' + genhtml319_DISCLAIMER + '</td></tr></table>';
end;

procedure TfmGenerateHTML320.GenerateIndexBody;
{
var
  FieldNames: TStringList;
}
begin
  with HTMLPage do
    begin
      with dmQuery.cdsQSummary do
        begin
          fmStartInfo.pbInfo.Max := RecordCount;
          if entity = 'DP'
            then Add('<div class="centered"><h2>' + dmQuery.GQ_DPSELECTED + '</h2></div>')
            else Add('<div class="centered"><h2>' + dmQuery.GQ_DGSELECTED + '</h2></div>');
          Add('<table border="1" cellspacing="2" cellpadding="2" class="tcentered">');
          if entity = 'DP'
            then Add('<tr><td class="centered"><b>' + dmQuery.GQ_DEPNO + '</b></td>')
            else Add('<tr><td class="centered"><b>' + dmQuery.GQ_DGNO + '</b></td>');
          Add('<td class="centered"><b>' + dmQuery.GQ_COUNTRY + '</b></td>');
          Add('<td class="centered"><b>' + dmQuery.GQ_LOCATION + '</b></td>');
          Add('<td class="centered"><b>' + dmQuery.GQ_ALLNAMES + '</b></td>');
          Add('<td class="centered"><b>' + dmQuery.GQ_COMMODITIES + '</b></td></tr>');

          DisableControls;
          First;
          while not EOF do
            begin
              Add('<tr><td class="centered"><a name="' + AnsiLowerCase(entity) +
                  IntToStr(Fields[0].Value) + '" href="' + AnsiLowerCase(entity) +
                  IntToStr(Fields[0].Value) + '.html">' +
                  IntToStr(Fields[0].Value) + '</a></td>');
              if Fields[1].IsNull
                then Add('<td>&nbsp;</td>')
                else Add('<td>' + Fields[1].Value + '</td>');
              if Fields[2].IsNull
                then Add('<td>&nbsp;</td>')
                else Add('<td>' + Fields[2].Value + '</td>');
              if Fields[3].IsNull
                then Add('<td>&nbsp;</td>')
                else Add('<td>' + Fields[3].Value + '</td>');
              if Fields[4].IsNull
                then Add('<td>&nbsp;</td>')
                else Add('<td>' + Fields[4].Value + '</td>');
              Add('</tr>');
              Next;
              fmStartInfo.pbInfo.StepIt;
              fmStartInfo.Update;
            end;
          EnableControls;
        end;
      Add('</table>');
    end;
end;

procedure TfmGenerateHTML320.GenerateIndexPage(memo: TMemo);
var
  i: integer;
  s: string;
  rs: string;
  ls: string;
  ts: TStringList;
begin
  fmStartInfo.Label1.Caption := genhtml319_GeneratingIndexPage;
  fmStartInfo.pbInfo.Min := 0;
  fmStartInfo.pbInfo.Step := 1;
  fmStartInfo.pbInfo.Position := 0;
  fmStartInfo.Show;
  fmStartInfo.Update;

  HTMLPage.Clear;
  GeneratePageHeader(HTMLTitle);
  with HTMLPage do
    begin
      rs := ' class="righttop"';
      ls := ' class="lefttop"';
      Add('<table border="0" cellpadding="2" cellspacing="2">');
      GenerateContributors;
      if memo.Lines.Count > 0 then
        begin
          ts := TStringList.Create;
          try
            ts.AddStrings(memo.Lines);
            Add('<tr><td' + rs + '><b>' + dmQuery.GQ_DESCRIPTION + '</b></td>');
            s := ts.Strings[0];
            s := '<td' + ls + '>' + s;
            ts.Delete(0);
            ts.Insert(0,s);
            i := ts.Count - 1;
            s := ts.Strings[i];
            s := s + '</td></tr>';
            ts.Delete(i);
            ts.Add(s);
            AddStrings(ts);
          finally
            ts.Free;
          end;
        end;
      Add('</table>');
      Add('<hr />');
      GenerateIndexBody;
      GeneratePageFooter;
      if FullHTMLOutput
        then SaveToFile(HTMLPath + 'index.html')
        else SaveToFile(deTOCOnlyDestinationPath.Text + '\' + edTOCOnlyFileName.Text + '.html');
    end;
  fmStartInfo.Hide;
  GenerateTextIndex;
end;

procedure TfmGenerateHTML320.GeneratePageHeader(t: string);
begin
  with HTMLPage do
    begin
      Add('<!DOCTYPE html');
      Add('PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"');
      Add('"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">');
      Add('<html xmlns="http://www.w3.org/1999/xhtml">');
      Add('<head>');
      Add('<meta http-equiv="Content-Type" content="text/html; charset=windows-1252" />');
      Add('<link rel="stylesheet" href="./gquery.css" type="text/css" />');
      Add('<title>' + t + '</title>');
      if BaseURL <> '' then
        Add('<base href="' + BaseURL + '" />');
      Add('</head><body>');
      Add('<div class="centered">');
      Add('<h2>' + PageHeading + '<br />');
      Add(PageSubHeading + '</h2>');
      Add('</div>');
      Add('<hr />');
    end;
end;

procedure TfmGenerateHTML320.GenerateMinePage(k: string);
var
  s: string;
  SQLString: TStringList;
  stayear: integer;
  stamonth: integer;
  staday: integer;
  endyear: integer;
  endmonth: integer;
  endday: integer;
  productiondates: string;
  refno: string;
  Refnos: TStringList;
begin
  with dmGlobalC.FindSubRes do
    begin
      Close;
      CommandText := 'select MINENAME,STAYEAR,STAMONTH,STADAY,ENDYEAR,ENDMONTH,ENDDAY,REFNO ' +
                     'from mine where MINENO = ' + k;
      Open;
      HTMLPage.Add('<table border=' + Border + ' cellspacing="2" cellpadding= "2">');
      GenerateContributors;
      if not FieldByName('MINENAME').IsNull then
        begin
          HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('mine','MINENAME',True) + '</td>');
          HTMLPage.Add('<td ' + AL + '>' + FieldByName('MINENAME').Value +
                       '</td></tr>');
        end;
      if not FieldByName('STAYEAR').IsNull
        then stayear := FieldByName('STAYEAR').Value
        else stayear := 0;
      if not FieldByName('STAMONTH').IsNull
        then stamonth := FieldByName('STAMONTH').Value
        else stamonth := 0;
      if not FieldByName('STADAY').IsNull
        then staday := FieldByName('STADAY').Value
        else staday := 0;
      if not FieldByName('ENDYEAR').IsNull
        then endyear := FieldByName('ENDYEAR').Value
        else endyear := 0;
      if not FieldByName('ENDMONTH').IsNull
        then endmonth := FieldByName('ENDMONTH').Value
        else endmonth := 0;
      if not FieldByName('ENDDAY').IsNull
        then endday := FieldByName('ENDDAY').Value
        else endday := 0;
      productiondates := BuildDateRange(stayear,stamonth,staday,endyear,
                                        endmonth,endday);
      if productiondates <> '' then
        productiondates := '<span class="underlined">' + dmQuery.GQ_REPORTPERIOD + '</span>: ' + productiondates;
      if not FieldByName('REFNO').IsNull
        then refno := IntToStr(FieldByName('REFNO').Value)
        else refno := '';
    end;

  s := GetString('mineoper','OPERATOR',k,'<br />','MINENO');
  if s <> '' then
    begin
      HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('mineoper') + '</td>');
      HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
    end;
  s := GetMineOwner(k,'<br />');
  if s <> '' then
    begin
      HTMLPage.Add('<tr><td ' + AR + '>' + GetUCaption('mineowner') + '</td>');
      HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
    end;
  if refno <> '' then
    begin
      Refnos := TStringList.Create;
      try
        Refnos.Add(refno);
        HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_REFERENCES + ':</b></td>');
        HTMLPage.Add('<td>');
        GenerateReferences(Refnos);
        HTMLPage.Add('</td></tr>');
      finally
        Refnos.Free;
      end;
    end;

  SQLString := TStringList.Create;
  try
    SQLString.Add('select d.PRODNO,d.PROPORTION,p.STAYEAR,p.STAMONTH,p.STADAY,');
    SQLString.Add('p.ENDYEAR,p.ENDMONTH,p.ENDDAY,p.TONNAGE,p.TONUNITS,p.PRODUCT,');
    SQLString.Add('p.NOTRECMD,p.YEARSUM,p.REFNO');
    SQLString.Add('from prodmine d inner join prodmain p');
    SQLString.Add('on d.PRODNO = p.PRODNO');
    SQLString.Add('where d.MINENO = ' + k);
    SQLString.Add('order by p.ENDYEAR desc,p.ENDMONTH desc,p.ENDDAY desc');
    s := GetProduction(SQLString,'prodmine',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_PRODUCTIONDATA + ':</b></td>');
        HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;

    SQLString.Clear;
    SQLString.Add('select d.RESNO,d.PROPORTION,r.ESTYEAR,r.ESTMONTH,r.ESTDAY,');
    SQLString.Add('r.COMPONENT,r.TONNAGE,r.TONUNITS,r.PRODUCT,r.RESPROD,');
    SQLString.Add('r.NOTRECMD,r.RESCAT,r.REFNO');
    SQLString.Add('from resmine d inner join resmain r');
    SQLString.Add('on d.RESNO = r.RESNO');
    SQLString.Add('where (d.MINENO = ' + k + ') and ');
    if fmMaster.AliasDriver <> 'MSACCESS'
      then SQLString.Add('  not ((r.CONTAINED = ''T'') or (r.ADDEDTO = ''T''))')
      else SQLString.Add('  not (r.CONTAINED or r.ADDEDTO)');
//    SQLString.Add('order by r.ESTYEAR desc, r.ESTMONTH desc, r.ESTDAY desc');
    SQLString.Add('order by d.RESNO');
    s := GetResources(SQLString,'resmine',k,'<br />');
    if s <> '' then
      begin
        HTMLPage.Add('<tr><td ' + AR + '><b>' + dmQuery.GQ_RESOURCEDATA + ':</b></td>');
        if ckbDisclaimer.Checked
          then HTMLPage.Add('<td ' + AL + '>' + GetDisclaimer + '<br />' + s + '</td></tr>')
          else HTMLPage.Add('<td ' + AL + '>' + s + '</td></tr>');
      end;
  finally
    SQLString.Free;
  end;
  HTMLPage.Add('</table>');
end;

procedure TfmGenerateHTML320.GeneratePageFooter;
begin
  HTMLPage.Add('<div class="centered"><h4>Generated ' + DateTimeToStr(Now) + ' with ' +
               fmMaster.laVersion.Caption + '<br />' +
               'GlobalDB System, Geological Survey of Canada, Natural Resources Canada</h4></div>');
  HTMLPage.Add('</body></html>');
end;

procedure TfmGenerateHTML320.GenerateReference(REFNO: string);
var
  authors_s: string;
  h: string;
  pubyear_s: string;
  title_s: string;
  citation_s: string;
begin
  with dmGlobalC.FindBySQL do
    begin
      if not FieldByName('PUBYEAR').IsNull
        then pubyear_s := IntToStr(FieldByName('PUBYEAR').Value)
        else pubyear_s := '';
      authors_s := GetAuthors(REFNO);
      if FieldByName('SRCTP').Value = 'SV' then
        authors_s := authors_s + ' ' + dmQuery.GQ_EDITORS + ')';
      if pubyear_s <> '' then
        authors_s := authors_s + ', ' + pubyear_s;
      if not FieldByName('TITLE').IsNull
        then title_s := FieldByName('TITLE').Value
        else title_s := '';
      HTMLPage.Add('<table border=' + Border + ' cellspacing="0" cellpadding="0">');
      if authors_s <> ''
        then h := h + '<tr><td>' + authors_s + '</td></tr>'
        else h := h + '<tr><td>' + '&nbsp;' + '</td></tr>';
      HTMLPage.Add(h);
      if title_s <> '' then
        HTMLPage.Add('<tr><td>' + title_s + '</td></tr>');
      if FieldByName('SRCTP').IsNull then
        begin
          HTMLPage.Add('</table>');
          HTMLPage.Add('<br />');
          Exit;
        end;
      if FieldByName('SRCTP').Value = 'F' then
        begin
          citation_s := SRCTP_F(REFNO);
          if citation_s <> '' then
            HTMLPage.Add('<tr><td class="lefttop">' + citation_s + '</td></tr>');
          HTMLPage.Add('</table>');
          HTMLPage.Add('<br />');
          Exit;
        end;
      if FieldByName('SRCTP').Value = 'M' then
        begin
          citation_s := SRCTP_M(REFNO);
          if citation_s <> '' then
            HTMLPage.Add('<tr><td class="lefttop">' + citation_s + '</td></tr>');
          HTMLPage.Add('</table>');
          HTMLPage.Add('<br />');
          Exit;
        end;
      if FieldByName('SRCTP').Value = 'NP' then
        begin
          citation_s := SRCTP_NP(REFNO);
          if citation_s <> '' then
            HTMLPage.Add('<tr><td class="lefttop">' + citation_s + '</td></tr>');
          HTMLPage.Add('</table>');
          HTMLPage.Add('<br />');
          Exit;
        end;
      if FieldByName('SRCTP').Value = 'P' then
        begin
          citation_s := SRCTP_P(REFNO);
          if citation_s <> '' then
            HTMLPage.Add('<tr><td class="lefttop">' + citation_s + '</td></tr>');
          HTMLPage.Add('</table>');
          HTMLPage.Add('<br />');
          Exit;
        end;
      if FieldByName('SRCTP').Value = 'R' then
        begin
          citation_s := SRCTP_R(REFNO);
          if citation_s <> '' then
            HTMLPage.Add('<tr><td class="lefttop">' + citation_s + '</td></tr>');
          HTMLPage.Add('</table>');
          HTMLPage.Add('<br />');
          Exit;
        end;
      if FieldByName('SRCTP').Value = 'SA' then
        begin
          citation_s := SRCTP_SA(REFNO);
          if citation_s <> '' then
            HTMLPage.Add('<tr><td class="lefttop">' + citation_s + '</td></tr>');
          HTMLPage.Add('</table>');
          HTMLPage.Add('<br />');
          Exit;
        end;
      if FieldByName('SRCTP').Value = 'SV' then
        begin
          citation_s := SRCTP_SV(REFNO);
          if citation_s <> '' then
            HTMLPage.Add('<tr><td class="lefttop">' + citation_s + '</td></tr>');
          HTMLPage.Add('</table>');
          HTMLPage.Add('<br />');
          Exit;
        end;
      if FieldByName('SRCTP').Value = 'V' then
        begin
          citation_s := SRCTP_V(REFNO);
          if citation_s <> '' then
            HTMLPage.Add('<tr><td class="lefttop">' + citation_s + '</td></tr>');
          HTMLPage.Add('</table>');
          HTMLPage.Add('<br />');
          Exit;
        end;
    end;
end;

procedure TfmGenerateHTML320.GenerateReferences(Refnos: TStringList);
begin
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select REFNO,MIN(RANK) from authors ' +
                     'where REFNO in (' + Refnos.CommaText + ') ' +
                     'group by REFNO ' +
                     'having MIN(RANK) > 1';
      Open;
      if not EOF then
        ShowMessage(Format(genhtml319_AuthorsMinimumRANKGreaterOne,[FieldByName('REFNO').Value]));
      Close;
      CommandText := 'select r.REFNO,a.LASTNAME,a.FIRSTNAME,r.TITLE,r.PUBYEAR,r.SRCTP ' +
                     'from authors a inner join refmain r ' +
                     'on a.REFNO = r.REFNO ' +
                     'where (r.REFNO in (' + Refnos.CommaText + ')) and (a.RANK = 1) ' +
//                     'order by a.LASTNAME,a.FIRSTNAME,r.PUBYEAR desc';
                     'order by a.LASTNAME,a.FIRSTNAME,r.PUBYEAR';
      Open;
      while not EOF do
        begin
          GenerateReference(IntToStr(FieldByName('REFNO').Value));
          Next;
        end;
      Close;
    end;
end;

procedure TfmGenerateHTML320.Initialize;
begin
  edFullHTMLTitle.Text := '';
  deFullHTMLRoot.Text := ExtractFilePath(ParamStr(0));
  edFullHTMLNewDir.Text := '';
  meFullHTMLDescription.Clear;
  edTOCOnlyTitle.Text := '';
  if AnsiLowerCase(Copy(deTOCOnlyURL.Text,1,7)) <> 'http://' then
    deTOCOnlyURL.Text := ExtractFilePath(ParamStr(0));
  deTOCOnlyDestinationPath.Text := ExtractFilePath(ParamStr(0));
  edTOCOnlyFilename.Text := '';
  meTOCOnlyDescription.Clear;
end;

function TfmGenerateHTML320.GetUCaption(tn: string;fn: string = '';bold: boolean = False): string;
var
  s: string;
  ts: string;
begin
  s := GetCaption(tn,fn);
  ts := AnsiUpperCase(Copy(s,1,1)) + Copy(s,2,Length(s));
  ts := StringReplace(ts,' ','&nbsp;',[rfReplaceAll]);
  if bold or
     (fn = '') or
     (fn = 'DEPCLAN') or
     (fn = 'GEOLPROV') or
     (fn = 'GSUBPROV') or
     (fn = 'GDISTRICT') or
     (fn = 'OBJLOC')
    then Result := '<b>' + ts + ':</b>'
    else Result := '<span class="underlined">' + ts + '</span>:';
end;

function TfmGenerateHTML320.GetXlink(tn,k,sep: string;
  entity_key: string = ''): string;
// tn: tablename, k: key value, sep: separator
var
  s,t: string;
begin
  if entity_key = '' then
    entity_key := e_key;
  s := '';
  with dmGlobalC.FindBySQL do
    begin
      Close;
      CommandText := 'select DBCODE,DBKEYVALUE from ' + tn + ' ' +
                     'where ' + entity_key + ' = ' + k + ' order by RANK';
      Open;
      while not EOF do
        begin
          if s <> '' then
            s := s + sep;
          t := '';
          if not FieldByName('DBCODE').IsNull then
            t := t + FieldByName('DBCODE').Value;
          if not FieldByName('DBKEYVALUE').IsNull then
            if t <> ''
              then t := t + '; ' + GetUCaption(tn,'DBKEYVALUE') + ' ' +
                        FieldByName('DBKEYVALUE').Value
              else t := t + GetUCaption(tn,'DBKEYVALUE') + ' ' +
                        FieldByName('DBKEYVALUE').Value;
          if t <> '' then
            s := s + SL + t + SR;
          Next;
        end;
      Close;
    end;
  Result := s;
end;

function TfmGenerateHTML320.SRCTP_F(REFNO: string): string;
var
  orgorpub_s: string;
  s: string;
begin
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select ORGORPUB,SERIESNO,MEDIUM from filsrc ' +
                     'where REFNO = ' + REFNO;
      Open;
      s := '';
      if not EOF then
        begin
          if not FieldByName('ORGORPUB').IsNull
            then orgorpub_s := FieldByName('ORGORPUB').Value
            else orgorpub_s := '';
          if FieldByName('SERIESNO').IsNull
            then if FieldByName('MEDIUM').IsNull
                   then s := orgorpub_s
                   else s := orgorpub_s + ', ' + FieldByName('MEDIUM').Value
            else if FieldByName('MEDIUM').IsNull
                   then s := orgorpub_s + ', ' + FieldByName('SERIESNO').Value
                   else s := orgorpub_s + ', ' + FieldByName('SERIESNO').Value + ', ' +
                             FieldByName('MEDIUM').Value;
        end;
      Close;
    end;
  Result := CleanString(s);
end;

function TfmGenerateHTML320.SRCTP_M(REFNO: string): string;
var
  org_s: string;
  s: string;
begin
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select ORG,MAPREFNO,SCALE from mapsrc ' +
                     'where REFNO = ' + REFNO;
      Open;
      s := '';
      if not EOF then
        begin
          if not FieldByName('ORG').IsNull
            then org_s := FieldByName('ORG').Value
            else org_s := '';
          if FieldByName('MAPREFNO').IsNull
            then if FieldByName('SCALE').IsNull
                   then s := org_s
                   else s := org_s + ', ' + dmQuery.GQ_SCALE  + ' ' + IntToStr(FieldByName('SCALE').Value)
            else if FieldByName('SCALE').IsNull
                   then s := org_s + ', ' + FieldByName('MAPREFNO').Value
                   else s := org_s + ', ' + FieldByName('MAPREFNO').Value + ', ' + dmQuery.GQ_SCALE + ' 1:' +
                             IntToStr(FieldByName('SCALE').Value);
        end;
      Close;
    end;
  Result := CleanString(s);
end;

function TfmGenerateHTML320.SRCTP_NP(REFNO: string): string;
var
  s: string;
begin
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select ISSUEDATE,STARTPAGE,NEWSNAME from newsrc ' +
                     'where REFNO = ' + REFNO;
      Open;
      s := '';
      if not EOF then
        begin
          if not FieldByName('NEWSNAME').IsNull
            then s := FieldByName('NEWSNAME').Value
            else s := '';
          if not FieldByName('ISSUEDATE').IsNull then
            s := s + ', ' + FieldByName('ISSUEDATE').Value + ' ' + dmQuery.GQ_ISSUE;
          if not FieldByName('STARTPAGE').IsNull
            then s := s + ', p. ' + FieldByName('STARTPAGE').Value;
        end;
      Close;
    end;
  Result := CleanString(s);
end;

function TfmGenerateHTML320.SRCTP_P(REFNO: string): string;
var
  s: string;
begin
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select JOURNAL,VOLUME,STARTPAGE,ENDPAGE from papsrc ' +
                     'where REFNO = ' + REFNO;
      Open;
      s := '';
      if not EOF then
        begin
          if not FieldByName('JOURNAL').IsNull
            then s := FieldByName('JOURNAL').Value
            else s := '';
          if not FieldByName('VOLUME').IsNull then
            s := s + ', ' + dmQuery.GQ_VOLUME + ' ' + FieldByName('VOLUME').Value;
          if not FieldByName('STARTPAGE').IsNull
            then s := s + ', p. ' + FieldByName('STARTPAGE').Value;
          if not FieldByName('ENDPAGE').IsNull
            then s := s + ' -  ' + FieldByName('ENDPAGE').Value;
        end;
      Close;
    end;
  Result := CleanString(s);
end;

function TfmGenerateHTML320.SRCTP_R(REFNO: string): string;
var
  cit1_s: string;
  cit2_s: string;
  s: string;
begin
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select SUBTITLE,PUBLISHER,SOCIETY,PUBCODE,NUMPAGES,NUMMAPS,NUMDISKS ' +
                     'from repsrc ' +
                     'where REFNO = ' + REFNO;
      Open;
      s := '';
      if not EOF then
        begin
          if FieldByName('PUBLISHER').IsNull and FieldByName('SOCIETY').IsNull
            then cit1_s := ''
            else if FieldByName('PUBLISHER').IsNull
                   then cit1_s := FieldByName('SOCIETY').Value
                   else if FieldByName('SOCIETY').IsNull
                          then cit1_s := FieldByName('PUBLISHER').Value
                          else cit1_s := FieldByName('SOCIETY').Value + ', ' +
                                         FieldByName('PUBLISHER').Value;
          if not FieldByName('NUMPAGES').IsNull
            then cit2_s := IntToStr(FieldByName('NUMPAGES').Value) + ' p.'
            else cit2_s := '';
          if not FieldByName('NUMMAPS').IsNull then
            cit2_s := cit2_s + ', ' + IntToStr(FieldByName('NUMMAPS').Value) + ' ' + dmQuery.GQ_MAPS;
          if not FieldByName('NUMDISKS').IsNull then
            cit2_s := cit2_s + ', ' + IntToStr(FieldByName('NUMDISKS').Value) + ' ' + dmQuery.GQ_DISKS;
          if cit2_s <> ''
            then cit2_s := cit2_s + '.'
//            else cit2_s := 'no contents entered.';
            else cit2_s := '.';
          if FieldByName('SUBTITLE').IsNull
            then s := ''
            else s := FieldByName('SUBTITLE').Value;
          if cit1_s <> '' then
            if s <> ''
              then s := s + ', ' + cit1_s
              else s := cit1_s;
          if not FieldByName('PUBCODE').IsNull then
            if s <> ''
              then s := s + ', ' + dmQuery.GQ_PUBLICATIONCODE + ' ' + FieldByName('PUBCODE').Value
              else s := dmQuery.GQ_PUBLICATIONCODE + ' ' + FieldByName('PUBCODE').Value;
          if s <> ''
            then s := s + ', ' + cit2_s
            else s := cit2_s;
        end;
      Close;
    end;
  Result := CleanString(s);
end;

function TfmGenerateHTML320.SRCTP_SA(REFNO: string): string;
var
  cit1_s: string;
  cit2_s: string;
  cit3_s: string;
  authors_s: string;
  s: string;
  sv_s: string;
begin
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select symsrc.CHAPTER,symsrc.SECTN,refmain.TITLE,symsrc.SYMPREFNO,' +
                     'symsrc.STARTPAGE,symsrc.ENDPAGE ' +
                     'from (symsrc inner join svolsrc on svolsrc.REFNO = symsrc.SYMPREFNO) ' +
                     'inner join refmain on refmain.REFNO = svolsrc.REFNO ' +
                     'where symsrc.REFNO = ' + REFNO;
      Open;
      s := '';
      cit1_s := '';
      cit2_s := '';
      cit3_s := '';
      sv_s := '';
      if not EOF then
        begin
          if FieldByName('CHAPTER').IsNull
            then if FieldByName('SECTN').IsNull
                   then cit1_s := ''
                   else cit1_s := dmQuery.GQ_SECTION + ' ' + FieldByName('SECTN').Value
            else if FieldByName('SECTN').IsNull
                   then cit1_s := FieldByName('CHAPTER').Value
                   else cit1_s := FieldByName('CHAPTER').Value +
                                  ', ' + dmQuery.GQ_SECTION + ' ' + FieldByName('SECTN').Value;
          if FieldByName('TITLE').IsNull
            then cit2_s := dmQuery.GQ_SYMPOSIUMVOLUME
            else cit2_s := '<i>' + dmQuery.GQ_IN + '</i> ' + FieldByName('TITLE').Value;
          if FieldByName('SYMPREFNO').IsNull
            then authors_s := ''
            else
              begin
                authors_s := dmQuery.GQ_EDITEDBY + ' ' +
                             GetAuthors(IntToStr(FieldByName('SYMPREFNO').Value));
                sv_s := SRCTP_SV(IntToStr(FieldByName('SYMPREFNO').Value));
              end;
          if authors_s <> '' then
            cit2_s := cit2_s + ', ' + authors_s;
          if FieldByName('STARTPAGE').IsNull
            then cit3_s := ''
            else cit3_s := 'p. ' + FieldByName('STARTPAGE').Value;
          if not FieldByName('ENDPAGE').IsNull
            then cit3_s := cit3_s + ' - ' + FieldByName('ENDPAGE').Value;
        end;
      Close;
    end;
  s := cit1_s;
  if cit2_s <> '' then
    s := s + ', ' + cit2_s;
  if sv_s <> '' then
    begin
      if sv_s[Length(sv_s)] = '.' then
        Delete(sv_s,Length(sv_s),1);
      s := s + ', ' + sv_s;
    end;
  if cit3_s <> '' then
    s := s + ', ' + cit3_s;
  Result := CleanString(s);
end;

function TfmGenerateHTML320.SRCTP_SV(REFNO: string): string;
var
  cit1_s: string;
  cit2_s: string;
  s: string;
begin
  with dmGlobalC.FindAuthors do
    begin
      Close;
      CommandText := 'select SUBTITLE,PUBLISHER,SOCIETY,PUBCODE,NUMPAGES,NUMMAPS,NUMDISKS ' +
                     'from svolsrc ' +
                     'where REFNO = ' + REFNO;
      Open;
      s := '';
      if not EOF then
        begin
          if FieldByName('PUBLISHER').IsNull and FieldByName('SOCIETY').IsNull
            then cit1_s := ''
            else if FieldByName('PUBLISHER').IsNull
                   then cit1_s := FieldByName('SOCIETY').Value
                   else if FieldByName('SOCIETY').IsNull
                          then cit1_s := FieldByName('PUBLISHER').Value
                          else cit1_s := FieldByName('SOCIETY').Value + ', ' +
                                         FieldByName('PUBLISHER').Value;
          if not FieldByName('NUMPAGES').IsNull
            then cit2_s := IntToStr(FieldByName('NUMPAGES').Value) + ' p.'
            else cit2_s := '';
          if not FieldByName('NUMMAPS').IsNull then
            cit2_s := cit2_s + ', ' + IntToStr(FieldByName('NUMMAPS').Value) + ' ' + dmQuery.GQ_MAPS;
          if not FieldByName('NUMDISKS').IsNull then
            cit2_s := cit2_s + ', ' + IntToStr(FieldByName('NUMDISKS').Value) + ' ' + dmQuery.GQ_DISKS;
          if  cit2_s <> ''
            then cit2_s := cit2_s + '.'
//            else cit2_s := 'no contents entered.';
            else cit2_s := '.';
          if FieldByName('SUBTITLE').IsNull
            then s := ''
            else s := FieldByName('SUBTITLE').Value;
          if cit1_s <> '' then
            if s <> ''
              then s := s + ', ' + cit1_s
              else s := cit1_s;
          if not FieldByName('PUBCODE').IsNull then
            if s <> ''
              then s := s + ', ' + FieldByName('PUBCODE').Value
              else s := FieldByName('PUBCODE').Value;
          if s <> ''
            then s := s + ', ' + cit2_s
            else s := cit2_s;
        end;
      Close;
    end;
  Result := CleanString(s);
end;

function TfmGenerateHTML320.SRCTP_V(REFNO: string): string;
var
  cit1_s: string;
  cit2_s: string;
  s: string;
begin
  with dmGlobalC.FindStuff do
    begin
      Close;
      CommandText := 'select PUBLISHER,SOCIETY,NUMPAGES,NUMMAPS,NUMDISKS from volsrc ' +
                     'where REFNO = ' + REFNO;
      Open;
      s := '';
      cit1_s := '';
      cit2_s := '';
      if not EOF then
        begin
          if FieldByName('PUBLISHER').IsNull and FieldByName('SOCIETY').IsNull
            then cit1_s := ''
            else if FieldByName('PUBLISHER').IsNull
                   then cit1_s := FieldByName('SOCIETY').Value
                   else if FieldByName('SOCIETY').IsNull
                          then cit1_s := FieldByName('PUBLISHER').Value
                          else cit1_s := FieldByName('SOCIETY').Value + ', ' +
                                         FieldByName('PUBLISHER').Value;
          if not FieldByName('NUMPAGES').IsNull
            then cit2_s := IntToStr(FieldByName('NUMPAGES').Value) + ' p.'
            else cit2_s := '';
          if not FieldByName('NUMMAPS').IsNull then
            cit2_s := cit2_s + ', ' + IntToStr(FieldByName('NUMMAPS').Value) + ' ' + dmQuery.GQ_MAPS;
          if not FieldByName('NUMDISKS').IsNull then
            cit2_s := cit2_s + ', ' + IntToStr(FieldByName('NUMDISKS').Value) + ' ' + dmQuery.GQ_DISKS;
        end;
      Close;
    end;
  if cit2_s <> ''
    then cit2_s := cit2_s
//    else cit2_s := 'no contents entered.';
    else cit2_s := '.';
  if cit1_s <> ''
    then s := cit1_s + ', ' + cit2_s
    else s := cit2_s;
  Result := CleanString(s);
end;

procedure TfmGenerateHTML320.FormCreate(Sender: TObject);
begin
  Self.Caption := genhtml320_fmGenerateHTML320;
  buGenerate.Caption := genhtml319_buGenerate;
  buReset.Caption := genhtml319_buReset;
  buMainScreen.Caption := genhtml319_buMainScreen;
  tsFullHTML.Caption := genhtml319_tsFullHTML;
  laFullHTMLTitle.Caption := genhtml319_laFullHTMLTitle;
  laFullHTMLRoot.Caption := genhtml319_laFullHTMLRoot;
  laFullHTMLNewDir.Caption := genhtml319_laFullHTMLNewDir;
  ckbFullHTMLLinkedPages.Caption := genhtml319_ckbFullHTMLLinkedPages;
  ckbTableBorders.Caption := genhtml319_ckbTableBorders;
  ckbDisclaimer.Caption := genhtml320_ckbDisclaimer;      ;
  laFullHeading.Caption := genhtml320_laHeading;
  edFullHeading.Text := genhtml319_MAINHEADING;
  laFullSubHeading.Caption := genhtml320_laSubHeading;
  edFullSubHeading.Text := genhtml319_Organization;
  laDescription.Caption := genhtml319_laDescription;
  tsTOCOnly.Caption := genhtml319_tsTOCOnly;
  laTOCOnlyTitle.Caption := genhtml319_laTOCOnlyTitle;
  laTOCOnlyURL.Caption := genhtml319_laTOCOnlyURL;
  laTOCOnlyDestinationPath.Caption := genhtml319_laTOCOnlyDestinationPath;
  laTOCOnlyFilename.Caption := genhtml319_laTOCOnlyFilename;
  laTOCOnlyHeading.Caption := genhtml320_laHeading;
  edTOCOnlyHeading.Text := genhtml319_MAINHEADING;
  laTOCOnlySubHeading.Caption := genhtml320_laSubHeading;
  edTOCOnlySubHeading.Text := genhtml319_Organization;
  laTOCOnlyDescription.Caption := genhtml319_laTOCOnlyDescription;
  HTMLPage := TStringList.Create;
  allDepnos := TStringList.Create;
  allDepLocation := TStringList.Create;
  allDepnames := TStringList.Create;
  allMinenos := TStringList.Create;
  deFullHTMLRoot.Text := ExtractFilePath(ParamStr(0));
end;

procedure TfmGenerateHTML320.buResetClick(Sender: TObject);
begin
  if MessageDlg(genhtml319_AreYouSure,mtConfirmation,[mbYes,mbNo],0) = mrYes then
    Initialize;
end;

procedure TfmGenerateHTML320.buGenerateClick(Sender: TObject);
var
  tmpCursor: TCursor;
begin
  if ckbTableBorders.Checked
    then Border := '"1"'
    else Border := '"0"';
  if pcHTMLOutput.ActivePageIndex = 0
    then
      begin
        FullHTMLOutput := True;
        if not GetPageSpecificationsOK(edFullHTMLTitle.Text,deFullHTMLRoot.Text,
               edFullHTMLNewDir.Text,edFullHeading.Text,
               edFullSubHeading.Text,meFullHTMLDescription.Lines) then
          Exit;
      end
    else
      begin
        FullHTMLOutput := False;
        if not GetPageSpecificationsOK(edTOCOnlyTitle.Text,deTOCOnlyURL.Text,
               deTOCOnlyDestinationPath.Text,edTOCOnlyHeading.Text,
               edTOCOnlySubHeading.Text,meTOCOnlyDescription.Lines) then
          Exit;
      end;
  GenerateCSS;
  tmpCursor := Screen.Cursor;
  Screen.Cursor := crSQLWait;
  if FullHTMLOutput
    then
      begin
        GenerateIndexPage(meFullHTMLDescription);
        GenerateDetailPages;
      end
    else GenerateIndexPage(meTOCOnlyDescription);
  Screen.Cursor := tmpCursor;
  if MessageDlg(genhtml319_OutputGeneratedSuccessfully,mtConfirmation,[mbYes,mbNo],0) = mrYes then
    if FullHTMLOutput
      then ShellExecute(Handle,'open',PChar(HTMLPath + 'index.html'),nil,PChar(HTMLPath),0)
      else ShellExecute(Handle,'open',PChar(DestinationPath +
                        edTOCOnlyFilename.Text + '.html'),nil,PChar(DestinationPath),0);
end;

procedure TfmGenerateHTML320.FormDestroy(Sender: TObject);
begin
  HTMLPage.Free;
  allMinenos.Free;
end;

procedure TfmGenerateHTML320.FormShow(Sender: TObject);
begin
  allDepnos.Clear;
  allDepLocation.Clear;
  allDepnames.Clear;
  allMinenos.Clear;
  pcHTMLOutput.ActivePageIndex := 0;
  if dburl = ''
    then edFullHTMLTitle.SetFocus
    else
      if MessageDlg(genhtml319_CompleteSetOfPagesAvailable,mtConfirmation,[mbYes,mbNo],0) = mrYes
        then
          begin
            deTOCOnlyURL.Text := dburl;
            pcHTMLOutput.ActivePage := tsTOCOnly;
            edTOCOnlyTitle.SetFocus;
          end
        else
          if MessageDlg(genhtml319_GenerationWarning,mtWarning,[mbYes,mbNo],0) = mrYes
            then
              begin
                deTOCOnlyURL.Text := '';
                edFullHTMLTitle.SetFocus;
              end
            else
              begin
                deTOCOnlyURL.Text := dburl;
                pcHTMLOutput.ActivePage := tsTOCOnly;
                edTOCOnlyTitle.SetFocus;
              end;
end;

end.
