unit joindepth;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfmJoinDepth = class(TForm)
    paBottom: TPanel;
    buNext: TButton;
    buCancel: TButton;
    lbJoinTables: TListBox;
    paTop: TPanel;
    meJoinMessage: TMemo;
    procedure buNextClick(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure lbJoinTablesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    SelectedDepth: integer;
    procedure FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
  end;

var
  fmJoinDepth: TfmJoinDepth;

implementation

uses dbtree, selrec, cmbcond1, resources;

{$R *.DFM}

procedure TfmJoinDepth.FormPosition(const ParentTop,ParentLeft,
  ParentHeight,ParentWidth: integer);
begin
  Top := ParentTop + Trunc((ParentHeight - Height)/2);
  Left := ParentLeft + Trunc((ParentWidth - Width)/2);
end;

procedure TfmJoinDepth.buNextClick(Sender: TObject);
begin
  SelectedDepth := lbJoinTables.ItemIndex + 1;
  Close;
end;

procedure TfmJoinDepth.buCancelClick(Sender: TObject);
begin
  SelectedDepth := 1;
  Close;
end;

procedure TfmJoinDepth.lbJoinTablesClick(Sender: TObject);
begin
  buNext.Enabled := True;
end;

procedure TfmJoinDepth.FormCreate(Sender: TObject);
begin
  Self.Caption := joindepth_fmJoinDepth;
  meJoinMessage.Lines.CommaText := joindepth_meJoinMessage;
  buNext.Caption := joindepth_buNext;
  buCancel.Caption := joindepth_buCancel;
end;

end.
