unit ordtable;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfmOrdered = class(TForm)
    paTop: TPanel;
    buNext: TButton;
    buCancel: TButton;
    gbMaxRank: TGroupBox;
    rbOne: TRadioButton;
    rbTwo: TRadioButton;
    rbThree: TRadioButton;
    rbAll: TRadioButton;
    laOrdered: TLabel;
    procedure FormShow(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure buNextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    MaxRankValue: longint;
    procedure FormPosition(const ParentTop, ParentLeft, ParentHeight,
      ParentWidth: integer);
  end;

var
  fmOrdered: TfmOrdered;

const
  MaxValue = 9999;

implementation

uses resources;

{$R *.DFM}

procedure TfmOrdered.FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
begin
  Top := ParentTop + Trunc((ParentHeight - Height)/2);
  Left := ParentLeft + Trunc((ParentWidth - Width)/2);
end;

procedure TfmOrdered.FormShow(Sender: TObject);
begin
  MaxRankValue := MaxValue;
  rbAll.Checked := True;
end;

procedure TfmOrdered.buCancelClick(Sender: TObject);
begin
  MaxRankValue := MaxValue;
  Close;
end;

procedure TfmOrdered.buNextClick(Sender: TObject);
begin
  if rbOne.Checked then
    MaxRankValue := 1
  else if rbTwo.Checked then
    MaxRankValue := 2
  else if rbThree.Checked then
    MaxRankValue := 3
  else MaxRankValue := MaxValue;
  Close;
end;

procedure TfmOrdered.FormCreate(Sender: TObject);
begin
  Self.Caption := ordtable_fmOrdered;
  laOrdered.Caption := ordtable_laOrdered;
  gbMaxRank.Caption := ordtable_gbMaxRank;
  rbOne.Caption := ordtable_rbOne;
  rbTwo.Caption := ordtable_rbTwo;
  rbThree.Caption := ordtable_rbThree;
  rbAll.Caption := ordtable_rbAll;
  buNext.Caption := ordtable_buNext;
  buCancel.Caption := ordtable_buCancel;
end;

end.
