unit selage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, ExtCtrls, Grids, DBGrids;

type
  TfmSelectAge = class(TForm)
    paTop: TPanel;
    buNext: TButton;
    buCancel: TButton;
    gbFindValues: TGroupBox;
    edStartAge: TEdit;
    edEndAge: TEdit;
    laStartAge: TLabel;
    laEndAge: TLabel;
    gbCountryHost: TGroupBox;
    gbOverlap: TGroupBox;
    rbSelectAny: TRadioButton;
    rbSelectOne: TRadioButton;
    cbCTRYHOST: TComboBox;
    dnAGECOMBO: TDBNavigator;
    dbgAGECOMBO: TDBGrid;
    rbWithin: TRadioButton;
    rbOverHang: TRadioButton;
    buStartAge: TButton;
    buEndAge: TButton;
    procedure buCancelClick(Sender: TObject);
    procedure buNextClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure buStartAgeClick(Sender: TObject);
    procedure buEndAgeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    AgeString: string;
    procedure FormPosition(const ParentTop, ParentLeft, ParentHeight,
      ParentWidth: integer);
  end;

var
  fmSelectAge: TfmSelectAge;

implementation

uses dmglob1, dmquery1, resources;

{$R *.DFM}

procedure TfmSelectAge.FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
begin
  Top := ParentTop + Trunc((ParentHeight - Height)/2);
  Left := ParentLeft + Trunc((ParentWidth - Width)/2);
end;

procedure TfmSelectAge.buCancelClick(Sender: TObject);
begin
  AgeString := '';
  Close;
end;

procedure TfmSelectAge.buNextClick(Sender: TObject);
var
  StartAge : double;
  EndAge : double;
begin
  try
    StartAge := StrToFloat(edStartAge.Text);
  except
    on EConvertError do
      begin
        MessageDlg(selage_StartAgeNotValid,mtWarning,[mbOK],0);
        Exit;
      end;
  end;
  try
    EndAge := StrToFloat(edEndAge.Text);
  except
    on EConvertError do
      begin
        MessageDlg(selage_EndAgeNotValid,mtWarning,[mbOK],0);
        Exit;
      end;
  end;
  if (StartAge - EndAge) <= 0.0 then
    begin
      MessageDlg(selage_StartAgeMustBeLargerEndAge,mtWarning,[mbOK],0);
      Exit;
    end;
  if rbSelectOne.Checked then
    if cbCTRYHOST.ItemIndex >= 0 then
      AgeString := AgeString + '(CTRYHOST = ''' + cbCTRYHOST.Items[cbCTRYHOST.ItemIndex] + ''') and ';
  if rbWithin.Checked
    then AgeString := AgeString +
                     '((STARTMA >= ' + edEndAge.Text + ') and (STARTMA <= ' + edStartAge.Text +
                     ') and (ENDMA >= ' + edEndAge.Text + ') and (ENDMA <= ' + edStartAge.Text + '))'
    else AgeString := AgeString + 'not ' +
                     '((STARTMA <= ' + edEndAge.Text + ') or (ENDMA >= ' + edStartAge.Text + '))';
  Close;
end;

procedure TfmSelectAge.FormShow(Sender: TObject);
begin
  AgeString := '';
//  dmGlobal.FindBySQL.Open;
  dbgAGECOMBO.DataSource := dmQuery.dsAgetsma;
  dmQuery.cdsAgetsma.Open;
  dbgAGECOMBO.Columns[0].Width := 250;
  rbSelectAny.Checked := True;
  rbWithin.Checked := True;
  edStartAge.Text := '';
  edEndAge.Text := '';
end;

procedure TfmSelectAge.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//  dmGlobal.FindBySQL.Close;
  dmQuery.cdsAgetsma.Close;
end;

procedure TfmSelectAge.buStartAgeClick(Sender: TObject);
begin
//  edStartAge.Text := dmGlobal.FindBySQL.FieldByName('STARTMA').Value;
  edStartAge.Text := dmQuery.cdsAgetsma.FieldByName('STARTMA').Value;
end;

procedure TfmSelectAge.buEndAgeClick(Sender: TObject);
begin
//  edEndAge.Text := dmGlobal.FindBySQL.FieldByName('ENDMA').Value;
  edEndAge.Text := dmQuery.cdsAgetsma.FieldByName('ENDMA').Value;
end;

procedure TfmSelectAge.FormCreate(Sender: TObject);
begin
  Self.Caption := selage_fmSelectAge;
  gbCountryHost.Caption := selage_gbCountryHost;
  rbSelectAny.Caption := selage_rbSelectAny;
  rbSelectOne.Caption := selage_rbSelectOne;
  gbOverlap.Caption := selage_gbOverlap;
  rbWithin.Caption := selage_rbWithin;
  rbOverHang.Caption := selage_rbOverhang;
  gbFindValues.Caption := selage_gbFindValues;
  laStartAge.Caption := selage_laStartAge;
  laEndAge.Caption := selage_laEndAge;
  buStartAge.Caption := selage_buStartAge;
  buEndAge.Caption := selage_buEndAge;
  buNext.Caption := selage_buNext;
  buCancel.Caption := selage_buCancel;
end;

end.
