unit selnull;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfmSelectNull = class(TForm)
    paTop: TPanel;
    buNext: TButton;
    buCancel: TButton;
    gbFindValues: TGroupBox;
    rbIsNull: TRadioButton;
    rbIsNotNull: TRadioButton;
    procedure FormShow(Sender: TObject);
    procedure buNextClick(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    TextString: string;
    procedure FormPosition(const ParentTop, ParentLeft, ParentHeight,
      ParentWidth: integer);
  end;

var
  fmSelectNull: TfmSelectNull;

implementation

uses mastform, resources;

{$R *.DFM}

procedure TfmSelectNull.FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
begin
  Top := ParentTop + Trunc((ParentHeight - Height)/2);
  Left := ParentLeft + Trunc((ParentWidth - Width)/2);
end;

procedure TfmSelectNull.FormShow(Sender: TObject);
begin
  rbIsNull.Checked := False;
  rbIsNotNull.Checked := False;
  TextString := '';
end;

procedure TfmSelectNull.buNextClick(Sender: TObject);
begin
  if rbIsNull.Checked
    then TextString := 'IS NULL'
    else if rbIsNotNull.Checked
           then TextString := 'IS NOT NULL';
  Close;
end;

procedure TfmSelectNull.buCancelClick(Sender: TObject);
begin
  TextString := '';
  Close;
end;

procedure TfmSelectNull.FormCreate(Sender: TObject);
begin
  Self.Caption := selnull_fmSelectNull;
  gbFindValues.Caption := selnull_gbFindValues;
  rbIsNull.Caption := selnull_rbIsNull;
  rbIsNotNull.Caption := selnull_rbIsNotNull;
  buNext.Caption := selnull_buNext;
  buCancel.Caption := selnull_buCancel;
end;

end.
