unit selnum;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Mask, DBCtrls;

type
  TfmSelectNumeric = class(TForm)
    paTop: TPanel;
    buNext: TButton;
    buCancel: TButton;
    gbLOHIValues: TGroupBox;
    laLOVALUE: TLabel;
    laHIVALUE: TLabel;
    dbeLOVALUE: TDBEdit;
    dbeHIVALUE: TDBEdit;
    gbFindValues: TGroupBox;
    cbOperator: TComboBox;
    laAND: TLabel;
    edValue: TEdit;
    edHiValue: TEdit;
    procedure FormShow(Sender: TObject);
    procedure cbOperatorChange(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure buNextClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    NumericString: string;
    procedure FormPosition(const ParentTop, ParentLeft, ParentHeight,
      ParentWidth: integer);
  end;

var
  fmSelectNumeric: TfmSelectNumeric;

implementation

uses dmglob1, resources;

{$R *.DFM}

procedure TfmSelectNumeric.FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
begin
  Top := ParentTop + Trunc((ParentHeight - Height)/2);
  Left := ParentLeft + Trunc((ParentWidth - Width)/2);
end;

procedure TfmSelectNumeric.FormShow(Sender: TObject);
begin
  cbOperator.ItemIndex := 2;
  cbOperator.SetFocus;
  edValue.Text := '';
  laAND.Visible := False;
  edHiValue.Visible := False;
  edHiValue.Text := '';
  NumericString := '';
  dmGlobalC.FindBySQL.Open;
  dbeLOVALUE.DataField := 'LOVALUE';
  dbeHIVALUE.DataField := 'HIVALUE';
  buNext.Enabled := (dbeLOVALUE.Text <> '');
end;

procedure TfmSelectNumeric.cbOperatorChange(Sender: TObject);
begin
  laAND.Visible := cbOperator.ItemIndex = 6;
  edHiValue.Visible := cbOperator.ItemIndex = 6;
end;

procedure TfmSelectNumeric.buCancelClick(Sender: TObject);
begin
  NumericString := '';
  Close;
end;

procedure TfmSelectNumeric.buNextClick(Sender: TObject);
var
  temp_lo: string;
  temp_hi: string;
begin
  try
    StrToFloat(edValue.Text);
  except
    on EConvertError do
      begin
        MessageDlg(selnum_TestValueNotValidNumber,mtWarning,[mbOK],0);
        Exit;
      end;
  end;
  if cbOperator.ItemIndex = 6 then
    begin
      try
        StrToFloat(edHiValue.Text);
      except
        on EConvertError do
          begin
            MessageDlg(selnum_SecondTestValueNotValidNumber,mtWarning,[mbOK],0);
            Exit;
          end;
      end;
      if StrToFloat(edHiValue.Text) > StrToFloat(edValue.Text)
        then
          begin
            temp_lo := edValue.Text;
            temp_hi := edHiValue.Text;
          end
        else
          begin
            temp_lo := edHiValue.Text;
            temp_hi := edValue.Text;
          end;
    end;
  if cbOperator.ItemIndex < 6
    then NumericString := cbOperator.Items[cbOperator.ItemIndex] + ' ' + edValue.Text
    else NumericString := cbOperator.Items[cbOperator.ItemIndex] + ' ' + temp_lo + ' AND ' + temp_hi;
  Close;
end;

procedure TfmSelectNumeric.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  dmGlobalC.FindBySQL.Close;
  dbeLOVALUE.DataField := '';
  dbeHIVALUE.DataField := '';
end;

procedure TfmSelectNumeric.FormCreate(Sender: TObject);
begin
  Self.Caption := selnum_fmSelectNumeric;
  gbLOHIValues.Caption := selnum_gbLOHIValues;
  laLOVALUE.Caption := selnum_laLOVALUE;
  laHIVALUE.Caption := selnum_laHIVALUE;
  gbFindValues.Caption := selnum_gbFindValues;
  buNext.Caption := selnum_buNext;
  buCancel.Caption := selnum_buCancel;
end;

end.
