unit selstring;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfmSelectString = class(TForm)
    paTop: TPanel;
    buNext: TButton;
    buCancel: TButton;
    gbFindValues: TGroupBox;
    edValue: TEdit;
    procedure FormShow(Sender: TObject);
    procedure buNextClick(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    TextString: string;
    procedure FormPosition(const ParentTop, ParentLeft, ParentHeight,
      ParentWidth: integer);
  end;

var
  fmSelectString: TfmSelectString;

implementation

uses mastform, resources;

{$R *.DFM}

procedure TfmSelectString.FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
begin
  Top := ParentTop + Trunc((ParentHeight - Height)/2);
  Left := ParentLeft + Trunc((ParentWidth - Width)/2);
end;

procedure TfmSelectString.FormShow(Sender: TObject);
begin
  edValue.Text := '';
  gbFindValues.Hint := Format(selstring_UseAsWildCard,[WildCard]);
  edValue.SetFocus;
  TextString := '';
end;

procedure TfmSelectString.buNextClick(Sender: TObject);
begin
  if edValue.Text <> '' then
    TextString := 'LIKE ''' + edValue.Text + '''';
  Close;
end;

procedure TfmSelectString.buCancelClick(Sender: TObject);
begin
  TextString := '';
  Close;
end;

procedure TfmSelectString.FormCreate(Sender: TObject);
begin
  Self.Caption := selstring_fmSelectString;
  gbFindValues.Caption := selstring_gbFindValues;
  buNext.Caption := selstring_buNext;
  buCancel.Caption := selstring_buCancel;
end;

end.
