unit dmglob1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Variants, DBXpress, FMTBcd, SqlExpr, DBClient, Provider,
  MConnect, SConnect;

type
  TdmGlobalC = class(TDataModule)
    dsFindBySQL: TDataSource;
    FindBySQL: TClientDataSet;
    FindStuff: TClientDataSet;
    FindSubRes: TClientDataSet;
    FindRef: TClientDataSet;
    FindAuthors: TClientDataSet;
    FindSub: TClientDataSet;
    SocketConnection1: TSocketConnection;
    procedure DataModuleDestroy(Sender: TObject);
  private
  public
    procedure DBNewPath(dbno: integer;username: string);
    function IdentifyUser: boolean;
    function IsTrue(v: Variant): boolean;
    procedure ResetDatabase;
  end;

var
  dmGlobalC: TdmGlobalC;

implementation

uses mastform, ident, resources;

{$R *.DFM}

procedure TdmGlobalC.DBNewPath(dbno: integer;username: string);
begin
  SocketConnection1.AppServer.DBNewPath(dbno,username);
end;

function TdmGlobalC.IdentifyUser: boolean;
var
  f: TfmIdentification;

  procedure PrepareQuery;
  var
    tmpCursor: TCursor;
  begin
    tmpCursor := Screen.Cursor;
    Screen.Cursor := crSQLWait;
    try
      with dmGlobalC do
        begin
          SocketConnection1.Open;
          FindbySQL.CommandText := 'select s.dbtitle_e,s.dbno,s.dburl ' +
                                   'from selectdb s inner join db_users d ' +
                                   'on s.dbno = d.dbno ' +
                                   'inner join dbusers u ' +
                                   'on d.username=u.username ' +
                                   'where (u.username = ''' + fmMaster.UserName + ''') ' +
                                   '  and (u.userpw = ''' + fmMaster.UserPassword + ''') ' +
                                   'order by s.dbno';
          FindBySQL.Open;
          if FindBySQL.Eof then
            begin
              result := False;
              MessageDlg(dmglob1_InvalidUsernamePassword,mtError,[mbOK],0);
              FindBySQL.Close;
              SocketConnection1.Close;
              Exit;
            end;
        end;
    finally
      Screen.Cursor := tmpCursor;
    end;
  end;

begin
  result := True;
  if not fmMaster.AltKeyDown
    then
      begin
        fmMaster.UserName := 'guest';
        fmMaster.UserPassword := 'password';
        PrepareQuery;
      end
    else
      begin
        fmMaster.AltKeyDown := False;
        f := TfmIdentification.Create(Self);
        try
          if f.ShowModal = mrOK
            then
              begin
                fmMaster.UserName := AnsiLowerCase(f.edUserName.Text);
                fmMaster.UserPassword := f.edPassword.Text;
                PrepareQuery;
              end
            else
              begin
                result := False;
                MessageDlg(dmglob1_CannotUseWithoutUsernamePassword,mtWarning,[mbOK],0);
                dmGlobalC.FindBySQL.Close;
                dmGlobalC.SocketConnection1.Close;
                Exit;
              end;
        finally
          f.Free;
        end;
      end;
end;

function TdmGlobalC.IsTrue(v: Variant): boolean;
begin
  if (fmMaster.AliasDriver <> 'MSACCESS') or (fmMaster.DBVersion = '3.22')
    then Result := v = 'T'
    else Result := v;
end;

procedure TdmGlobalC.ResetDatabase;
begin
  SocketConnection1.AppServer.ResetDatabase;
  SocketConnection1.Close;
end;

procedure TdmGlobalC.DataModuleDestroy(Sender: TObject);
begin
  SocketConnection1.Close;
end;

end.
