unit dmglob_s;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, GQueryS_DBX_TLB, StdVcl, DBXpress, FMTBcd, Provider, DB,
  SqlExpr;

type
  TdmGlobal_S = class(TRemoteDataModule, IdmGlobal_S)
    DatabaseIB: TSQLConnection;
    dtsFindSubRes: TSQLDataSet;
    dtsFindSub: TSQLDataSet;
    dtsFindStuff: TSQLDataSet;
    dtsFindBySQL: TSQLDataSet;
    dtsFindRef: TSQLDataSet;
    dtsFindAuthors: TSQLDataSet;
    dspFindBySQL: TDataSetProvider;
    dspFindStuff: TDataSetProvider;
    dspFindSubRes: TDataSetProvider;
    dspFindRef: TDataSetProvider;
    dspFindAuthors: TDataSetProvider;
    dspFindSub: TDataSetProvider;
    dtsSelectDBPath: TSQLDataSet;
    DatabasePG: TSQLConnection;
    procedure RemoteDataModuleCreate(Sender: TObject);
    procedure RemoteDataModuleDestroy(Sender: TObject);
  private
    Idno: integer;
    Log_in: string;
    procedure ResetInterbase;
    procedure ResetPostgreSQL;
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;
    procedure DBNewPath(dbpath: Integer; username: OleVariant); safecall;
    procedure ResetDatabase; safecall;
  public
end;

implementation

uses mastform_s;

{$R *.DFM}

class procedure TdmGlobal_S.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

procedure TdmGlobal_S.RemoteDataModuleCreate(Sender: TObject);
begin
  PostMessage(fmMaster.Handle, UM_CONNECT, 1, 0);
  ResetInterBase;
//  DatabaseIB.Params.Values['Database'] := '132.156.88.146:/home/interbase/ib_dbs/gqueryserver.gdb';
  DatabaseIB.Params.Values['Database'] := fmMaster.ServerDBPath;
  DatabaseIB.Params.Values['User_name'] := 'GQUERY';
  DatabaseIB.Params.Values['Password'] := 'wmgdp';
end;

procedure TdmGlobal_S.RemoteDataModuleDestroy(Sender: TObject);
begin
  PostMessage(fmMaster.Handle, UM_CONNECT, -1, 0);
  DatabasePG.Close;
  DatabaseIB.Close;
  ResetInterBase;
  with dtsSelectDBPath do
    begin
      CommandText := 'LOG_END';
      ParamByName('IDNO').AsInteger := Idno;
      ParamByName('LOG_OUT').AsString := DateTimeToStr(Now);
      ExecSQL;
    end;
end;

procedure TdmGlobal_S.DBNewPath(dbpath: Integer; username: OleVariant);
var
  dbno: integer;
  s: string;
begin
  fmMaster.Panel1.Caption := '--> ' + IntToStr(dbpath);
  dbno := dbpath;
  with dtsSelectDBPath do
    begin
      fmMaster.Panel1.Caption := 'Setting CommandText';
      CommandText := 'SP_DBPATH';
      fmMaster.Panel1.Caption := 'Setting ParamDBNO';
      ParamByName('DBNO').AsInteger := dbno;
      fmMaster.Panel1.Caption := 'Get DBPATH';
      ExecSQL;
      fmMaster.Panel1.Caption := 'Got DBPATH';
      s := ParamByName('DBPATH').AsString;
      Log_in := DateTimeToStr(Now);
      CommandText := 'LOG_START';
      ParamByName('USERNAME').AsString := username;
      ParamByName('DBNO').AsInteger := dbno;
      ParamByName('LOG_IN').AsString := Log_in;
      fmMaster.Panel1.Caption := 'Get NEWID';
      ExecSQL;
      fmMaster.Panel1.Caption := 'Got NEWID';
      Idno := ParamByName('NEWID').AsInteger;
    end;
  if AnsiUpperCase(Copy(s,1,7)) = '132.156'
    then
      begin
        ResetInterBase;
        DatabaseIB.Params.Values['Database'] := s;
        fmMaster.Panel1.Caption := 'at IB: ' + IntToStr(dbpath);
      end
    else if AnsiUpperCase(Copy(s,1,2)) = 'IB'
      then
        begin
          ResetInterBase;
          DatabaseIB.Params.Values['Database'] := Copy(s,3,Length(s));
          fmMaster.Panel1.Caption := 'at IB: ' + IntToStr(dbpath);
        end
      else
        begin
          ResetPostgreSQL;
          DatabasePG.Params.Values['Database'] := Copy(s,3,Length(s));
          fmMaster.Panel1.Caption := 'at PG: ' + IntToStr(dbpath);
        end;
end;

procedure TdmGlobal_S.ResetDatabase;
begin
  ResetInterBase;
//  DatabaseIB.Params.Values['Database'] := '132.156.88.146:/home/interbase/ib_dbs/gqueryserver.gdb';
  DatabaseIB.Params.Values['Database'] := fmMaster.ServerDBPath;
end;

procedure TdmGlobal_S.ResetInterBase;
begin
  fmMaster.Panel1.Caption := '';
  DatabaseIB.Close;
  DatabasePG.Close;
  dtsFindAuthors.SQLConnection := DatabaseIB;
  dtsFindBySQL.SQLConnection := DatabaseIB;
  dtsFindRef.SQLConnection := DatabaseIB;
  dtsFindStuff.SQLConnection := DatabaseIB;
  dtsFindSub.SQLConnection := DatabaseIB;
  dtsFindSubRes.SQLConnection := DatabaseIB;
  with DatabaseIB do
    begin
      Params.Values['DriverName'] := 'Interbase';
      Params.Values['BlobSize'] := '-1';
      Params.Values['CommitRetain'] := 'False';
      Params.Values['ErrorResourceFile'] := '';
      Params.Values['LocaleCode'] := '0000';
      Params.Values['Password'] := 'wmgdp';
      Params.Values['RoleName'] := 'users';
      Params.Values['ServerCharSet'] := '';
      Params.Values['SQLDialect'] := '3';
      Params.Values['Interbase TransIsolation'] := 'ReadCommited';
      Params.Values['User_Name'] := 'GQUERY';
      Params.Values['WaitOnLocks'] := 'True';
      Params.Values['Database'] := fmMaster.ServerDBPath;
    end;
end;

procedure TdmGlobal_S.ResetPostgreSQL;
begin
  DatabaseIB.Close;
  DatabasePG.Close;
  dtsFindAuthors.SQLConnection := DatabasePG;
  dtsFindBySQL.SQLConnection := DatabasePG;
  dtsFindRef.SQLConnection := DatabasePG;
  dtsFindStuff.SQLConnection := DatabasePG;
  dtsFindSub.SQLConnection := DatabasePG;
  dtsFindSubRes.SQLConnection := DatabasePG;
  with DatabasePG do
    begin
      Params.Values['DriverName'] := 'PostgreSQL';
      Params.Values['User_Name'] := 'laramee';
      Params.Values['Password'] := 'aquoling';
      Params.Values['TransIsolation'] := '=ReadCommited';
      Params.Values['ServerCharSet'] := '/latin2';
    end;
end;

initialization
  TComponentFactory.Create(ComServer, TdmGlobal_S,
    Class_dmGlobal_S, ciMultiInstance, tmApartment);
end.
