unit ident;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfmIdentification = class(TForm)
    Panel1: TPanel;
    buCancel: TButton;
    buOK: TButton;
    Panel2: TPanel;
    rbPublic: TRadioButton;
    rbPrivate: TRadioButton;
    laUserName: TLabel;
    edUserName: TEdit;
    laPassword: TLabel;
    edPassword: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure rbPublicClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure FlipControls;
  public
  end;

var
  fmIdentification: TfmIdentification;

implementation

uses resources;

{$R *.dfm}

procedure TfmIdentification.FlipControls;
begin
  if rbPublic.Checked
    then
      begin
        laUserName.Enabled := False;
        laPassword.Enabled := False;
        edUserName.Enabled := False;
        edUserName.Color := clScrollBar;
        edPassword.Enabled := False;
        edPassword.Color := clScrollBar;
      end
    else
      begin
        laUserName.Enabled := True;
        laPassword.Enabled := True;
        edUserName.Enabled := True;
        edUserName.Color := clWindow;
        edPassword.Enabled := True;
        edPassword.Color := clWindow;
      end;
end;

procedure TfmIdentification.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if rbPublic.Checked then
    begin
      edUserName.Text := 'guest';
      edPassword.Text := 'password';
    end;
end;

procedure TfmIdentification.FormShow(Sender: TObject);
begin
  buOK.SetFocus;
  rbPublic.Checked := True;
  FlipControls;
end;

procedure TfmIdentification.rbPublicClick(Sender: TObject);
begin
  FlipControls;
end;

procedure TfmIdentification.FormCreate(Sender: TObject);
begin
  Self.Caption := ident_fmIdentification;
  rbPublic.Caption := ident_rbPublic;
  rbPrivate.Caption := ident_rbPrivate;
  laUserName.Caption := ident_laUserName;
  laPassword.Caption := ident_laPassword;
  buOK.Caption := ident_buOK;
  buCancel.Caption := ident_buCancel;
end;

end.
