unit seldb;  // DBX version

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, DBTables;

type
  TfmSelectDB = class(TForm)
    lbAlias: TListBox;
    buSelect: TButton;
    buAbort: TButton;
    procedure buSelectClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure FormPosition(const ParentTop, ParentLeft, ParentHeight,
      ParentWidth: integer);
  end;

var
  fmSelectDB: TfmSelectDB;

implementation

uses dmglob1, mastform, resources;

{$R *.DFM}

procedure TfmSelectDB.FormPosition(const ParentTop,ParentLeft,ParentHeight,ParentWidth: integer);
begin
  Top := ParentTop + Trunc((ParentHeight - Height)/2);
  Left := ParentLeft + Trunc((ParentWidth - Width)/2);
end;

procedure TfmSelectDB.buSelectClick(Sender: TObject);
var
  dbno: integer;
begin
  with dmGlobalC do
    begin
      FindBySQL.Locate('dbtitle_e',lbAlias.Items[lbAlias.ItemIndex],[]);
      dbno := FindBySQL.FieldByName('dbno').AsInteger;
      if FindBySQL.FieldByName('dburl').IsNull
        then dburl := ''
        else dburl := FindBySQL.FieldByName('dburl').AsString;
      FindBySQL.Close;
      dmGlobalC.DBNewPath(dbno,fmMaster.UserName);
    end; // with
  fmMaster.AliasDriver := 'DBX';
  Close;
end;

procedure TfmSelectDB.FormShow(Sender: TObject);
begin
  lbAlias.Clear;
  with dmGlobalC.FindBySQL do
    begin
      First;
      while not Eof do
        begin
          lbAlias.Items.Add(FieldByName('dbtitle_e').AsString);
          Next;
        end;
    end;
  lbAlias.ItemIndex := 0;
end;

procedure TfmSelectDB.FormCreate(Sender: TObject);
begin
  Self.Caption := seldb_fmSelectDB;
  buSelect.Caption := seldb_buSelect;
  buAbort.Caption := seldb_buAbort;
end;

end.
