unit ctrl_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, GShellADO_TLB;

type
  TfmMaster = class(TForm)
    Panel1: TPanel;
    buConnect: TButton;
    buDisconnect: TButton;
    Panel2: TPanel;
    edLatitude: TEdit;
    edLongitude: TEdit;
    buAddRecord: TButton;
    Panel3: TPanel;
    edDEPNO1: TEdit;
    buGotoDEPNO: TButton;
    Panel4: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edDEPNO2: TEdit;
    buDeleteRecord: TButton;
    Panel5: TPanel;
    buShowInfo: TButton;
    Label5: TLabel;
    edInfoDEPNO: TEdit;
    Label6: TLabel;
    edInfoLatitude: TEdit;
    Label7: TLabel;
    edInfoLongitude: TEdit;
    Panel6: TPanel;
    Label8: TLabel;
    edDEPNO_LL: TEdit;
    Label9: TLabel;
    edGetSetLat: TEdit;
    Label10: TLabel;
    edGetSetLong: TEdit;
    buClear_LL: TButton;
    buGetLatLong: TButton;
    buUpdateLatLong: TButton;
    Panel7: TPanel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    edDEPNO_XY: TEdit;
    edDigitX: TEdit;
    edDigitY: TEdit;
    buClear_XY: TButton;
    buGetDigitized: TButton;
    buUpdateDigitized: TButton;
    Label14: TLabel;
    edDigitEPSG: TEdit;
    Panel8: TPanel;
    Label15: TLabel;
    edDeleteDigitized: TEdit;
    buDeleteDigitized: TButton;
    Panel9: TPanel;
    Label16: TLabel;
    edGetCLDepno: TEdit;
    Label17: TLabel;
    edGetCLCompstage: TEdit;
    buGetCL: TButton;
    Label18: TLabel;
    edGetCLProglevel: TEdit;
    procedure buConnectClick(Sender: TObject);
    procedure buDisconnectClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure buAddRecordClick(Sender: TObject);
    procedure buGotoDEPNOClick(Sender: TObject);
    procedure buDeleteRecordClick(Sender: TObject);
    procedure buShowInfoClick(Sender: TObject);
    procedure buClear_LLClick(Sender: TObject);
    procedure buGetLatLongClick(Sender: TObject);
    procedure buUpdateLatLongClick(Sender: TObject);
    procedure buClear_XYClick(Sender: TObject);
    procedure buGetDigitizedClick(Sender: TObject);
    procedure buUpdateDigitizedClick(Sender: TObject);
    procedure buDeleteDigitizedClick(Sender: TObject);
  private
    { Private declarations }
    FIntF: IDPServer;
    procedure EnableControls(b: boolean);
  public
    { Public declarations }
  end;

var
  fmMaster: TfmMaster;

implementation

uses ComObj;

{$R *.dfm}

procedure TfmMaster.EnableControls(b: boolean);
begin
  buAddRecord.Enabled := b;
  buDeleteRecord.Enabled := b;
  buDisconnect.Enabled := b;
  buGotoDEPNO.Enabled := b;
  buShowInfo.Enabled := b;
  edDEPNO1.Enabled := b;
  edDEPNO2.Enabled := b;
  edLatitude.Enabled := b;
  edLongitude.Enabled := b;
end;

procedure TfmMaster.buConnectClick(Sender: TObject);
begin
  FIntF := CoDPServer.Create;
  EnableControls(True);
end;

procedure TfmMaster.buDisconnectClick(Sender: TObject);
begin
  FIntF := nil;
  EnableControls(False);
end;

procedure TfmMaster.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FIntF <> nil then
    FIntF := nil;
end;

procedure TfmMaster.FormCreate(Sender: TObject);
begin
  EnableControls(False);
end;

procedure TfmMaster.buAddRecordClick(Sender: TObject);
var
  Latitude: double;
  Longitude: double;
  NewDEPNO: longint;
begin
  try
    Latitude := StrToFloat(edLatitude.Text);
    Longitude := StrToFloat(edLongitude.Text);
    NewDEPNO := FIntF.AddDPRecord(Latitude,Longitude);
    ShowMessage('New DEPNO: ' + IntToStr(NewDEPNO));
  except
    on EConvertError do
      ShowMessage('Latitude and Longitude' + chr(10) +
                  'must be floating numbers!');
  end;
end;

procedure TfmMaster.buGotoDEPNOClick(Sender: TObject);
var
  DEPNO: longint;
begin
  try
    DEPNO := StrToInt(edDEPNO1.Text);
    FIntF.LocateDPRecord(DEPNO);
  except
    on EConvertError do
      ShowMessage('DEPNO must be a positive integer!');
  end;
end;

procedure TfmMaster.buDeleteRecordClick(Sender: TObject);
var
  DEPNO: longint;
begin
  try
    DEPNO := StrToInt(edDEPNO2.Text);
    FIntF.DeleteDPRecord(DEPNO);
  except
    on EConvertError do
      ShowMessage('DEPNO must be a positive integer!');
  end;
end;

procedure TfmMaster.buShowInfoClick(Sender: TObject);
begin
  edInfoDEPNO.Text := IntToStr(FIntF.DEPNO);
  edInfoLatitude.Text := FloatToStrF(FIntF.Latitude,ffFixed,15,6);
  edInfoLongitude.Text := FloatToStrF(FIntF.Longitude,ffFixed,15,6);
end;

procedure TfmMaster.buClear_LLClick(Sender: TObject);
begin
  edDEPNO_LL.Clear;
  edGetSetLat.Clear;
  edGetSetLong.Clear;
end;

procedure TfmMaster.buGetLatLongClick(Sender: TObject);
var
  DEPNO: longint;
  Latitude,Longitude: double;
begin
  try
    DEPNO := StrToInt(edDEPNO_LL.Text);
    FIntF.GetDPLatLong(DEPNO,Latitude,Longitude);
    edGetSetLat.Text := FloatToStr(Latitude);
    edGetSetLong.Text := FloatToStr(Longitude);
  except
    on EConvertError do
      ShowMessage('DEPNO must be a positive integer!');
  end;
end;

procedure TfmMaster.buUpdateLatLongClick(Sender: TObject);
var
  DEPNO: longint;
  Latitude,Longitude: double;
begin
  try
    DEPNO := StrToInt(edDEPNO_LL.Text);
    Latitude := StrToFloat(edGetSetLat.Text);
    Longitude := StrToFloat(edGetSetLong.Text);
    FIntF.UpdateDPLatLong(DEPNO,Latitude,Longitude);
  except
    on EConvertError do
      ShowMessage('DEPNO must be a positive integer' + chr(10) +
                  'Latitude and longitude must be numbers!');
  end;
end;

procedure TfmMaster.buClear_XYClick(Sender: TObject);
begin
  edDEPNO_XY.Clear;
  edDigitX.Clear;
  edDigitY.Clear;
  edDigitEPSG.Clear;
end;

procedure TfmMaster.buGetDigitizedClick(Sender: TObject);
var
  DEPNO: longint;
  DigitX,DigitY: double;
  DigitEPSG: longint;
begin
  try
    DEPNO := StrToInt(edDEPNO_XY.Text);
    FIntF.GetDPDigitizedRecord(DEPNO,DigitX,DigitY,DigitEPSG);
    edDigitX.Text := FloatToStrF(DigitX,ffFixed,15,6);
    edDigitY.Text := FloatToStrF(DigitY,ffFixed,15,6);
    edDigitEPSG.Text := IntToStr(DigitEPSG);
    fmMaster.Update;
  except
    on EConvertError do
      ShowMessage('DEPNO must be a positive integer!');
  end;
end;

procedure TfmMaster.buUpdateDigitizedClick(Sender: TObject);
var
  DEPNO: longint;
  DigitX,DigitY: double;
  DigitEPSG: longint;
begin
  try
    DEPNO := StrToInt(edDEPNO_XY.Text);
    DigitX := StrToFloat(edDigitX.Text);
    DigitY := StrToFloat(edDigitY.Text);
    DigitEPSG := StrToInt(edDigitEPSG.Text);
    FIntF.UpdateDPDigitizedRecord(DEPNO,DigitX,DigitY,DigitEPSG);
  except
    on EConvertError do
      ShowMessage('DEPNO must be a positive integer' + chr(10) +
                  'Digit_X and Digit_Y must be numbers' + chr(10) +
                  'EPSG must be an integer!');
  end;

end;

procedure TfmMaster.buDeleteDigitizedClick(Sender: TObject);
var
  DEPNO: longint;
begin
  try
    DEPNO := StrToInt(edDeleteDigitized.Text);
    FIntF.DeleteDPDigitizedRecord(DEPNO);
  except
    on EConvertError do
      ShowMessage('DEPNO must be a positive integer!');
  end;

end;

end.
