unit customiz;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TfmCustomize = class(TForm)
    paTop: TPanel;
    buCancel: TButton;
    pcCustomize: TPageControl;
    tsDeposits: TTabSheet;
    tsDepositGroups: TTabSheet;
    laCompleteSet: TLabel;
    lbDpCompleteSet: TListBox;
    buDpAddAll: TButton;
    buDpAdd: TButton;
    buDpClear: TButton;
    laCustomSet: TLabel;
    lbDpCustomSet: TListBox;
    Label1: TLabel;
    lbDgCompleteSet: TListBox;
    buDgAddAll: TButton;
    buDgAdd: TButton;
    buDgClear: TButton;
    Label2: TLabel;
    lbDgCustomSet: TListBox;
    buSave: TButton;
    sbDpUp: TSpeedButton;
    sbDpDown: TSpeedButton;
    sbDgUp: TSpeedButton;
    sbDgDown: TSpeedButton;
    buDpRemove: TButton;
    buDgRemove: TButton;
    procedure FormActivate(Sender: TObject);
    procedure buDpAddClick(Sender: TObject);
    procedure buDpClearClick(Sender: TObject);
    procedure buDpAddAllClick(Sender: TObject);
    procedure buDgAddAllClick(Sender: TObject);
    procedure buDgAddClick(Sender: TObject);
    procedure buDgClearClick(Sender: TObject);
    procedure buSaveClick(Sender: TObject);
    procedure buDpRemoveClick(Sender: TObject);
    procedure buDgRemoveClick(Sender: TObject);
    procedure sbDpUpClick(Sender: TObject);
    procedure sbDpDownClick(Sender: TObject);
    procedure sbDgUpClick(Sender: TObject);
    procedure sbDgDownClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    function OkToMove(var lb: TListBox; var n: integer): boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmCustomize: TfmCustomize;

implementation

uses mastform, resources;

{$R *.DFM}

var
  d : string;

function TfmCustomize.OkToMove(var lb: TListBox;var n: integer): boolean;
var
  i : integer;
  c : integer;
begin
  Result := False;
  n := -1;
  if lb.Items.Count < 2 then
    Exit;
  c := 0;
  for i := 0 to lb.Items.Count - 1 do
    if lb.Selected[i] then
      begin
        n := i;
        inc(c);
      end;
  if c <> 1 then
    Exit;
  Result := True;
end;

procedure TfmCustomize.FormActivate(Sender: TObject);
var
  i : integer;
begin
  GetDir(0,d);
  lbDpCustomSet.Clear;
  lbDpCustomSet.Items.AddStrings(DpSpecs);
  lbDgCustomSet.Clear;
  lbDgCustomSet.Items.AddStrings(DgSpecs);
  lbDpCompleteSet.Clear;
  for i := 0 to DpStd.Count - 1 do
    if lbDpCustomSet.Items.IndexOf(DpStd.Strings[i]) < 0 then
      lbDpCompleteSet.Items.Add(DpStd.Strings[i]);
  lbDgCompleteSet.Clear;
  for i := 0 to DgStd.Count - 1 do
    if lbDgCustomSet.Items.IndexOf(DgStd.Strings[i]) < 0 then
      lbDgCompleteSet.Items.Add(DgStd.Strings[i]);
end;

procedure TfmCustomize.buDpAddClick(Sender: TObject);
var
  i : integer;
begin
  with lbDpCompleteSet do
    begin
      for i := 0 to Items.Count-1 do
        if Selected[i] then
          if lbDpCustomSet.Items.IndexOf(Items[i]) < 0 then
            lbDpCustomSet.Items.Add(Items[i]);
      for i := Items.Count-1 downto 0 do
        if Selected[i] then
          lbDpCompleteSet.Items.Delete(i);
    end;
end;

procedure TfmCustomize.buDpClearClick(Sender: TObject);
begin
  lbDpCustomSet.Clear;
  lbDpCompleteSet.Items.Clear;
  lbDpCompleteSet.Items.AddStrings(DpStd);
end;

procedure TfmCustomize.buDpAddAllClick(Sender: TObject);
var
  i : integer;
begin
  with lbDpCompleteSet do
    begin
      for i := 0 to Items.Count-1 do
        if lbDpCustomSet.Items.IndexOf(Items[i]) < 0 then
          lbDpCustomSet.Items.Add(Items[i]);
      Clear;
    end;
end;

procedure TfmCustomize.buDgAddAllClick(Sender: TObject);
var
  i : integer;
begin
  with lbDgCompleteSet do
    begin
      for i := 0 to Items.Count-1 do
        if lbDgCustomSet.Items.IndexOf(Items[i]) < 0 then
          lbDgCustomSet.Items.Add(Items[i]);
      Clear;
    end;
end;

procedure TfmCustomize.buDgAddClick(Sender: TObject);
var
  i : integer;
begin
  with lbDgCompleteSet do
    begin
      for i := 0 to Items.Count-1 do
        if Selected[i] then
          if lbDgCustomSet.Items.IndexOf(Items[i]) < 0 then
            lbDgCustomSet.Items.Add(Items[i]);
      for i := Items.Count-1 downto 0 do
        if Selected[i] then
          lbDgCompleteSet.Items.Delete(i);
    end;
end;

procedure TfmCustomize.buDgClearClick(Sender: TObject);
begin
  lbDgCustomSet.Clear;
  lbDgCompleteSet.Items.Clear;
  lbDgCompleteSet.Items.AddStrings(DgStd);
end;

procedure TfmCustomize.buSaveClick(Sender: TObject);
var
  sts : TStringList; //TStrings;
  i   : integer;
begin
  sts := TStringList.Create;
  try
    sts.Add('[Deposits Module]');
    DpSpecs.Clear;
    for i := 0 to lbDpCustomSet.Items.Count-1 do
      begin
        sts.Add(lbDpCustomSet.Items[i]);
        DpSpecs.Add(lbDpCustomSet.Items[i]);
      end;
    sts.Add('[Deposit Groups Module]');
    DgSpecs.Clear;
    for i := 0 to lbDgCustomSet.Items.Count-1 do
      begin
        sts.Add(lbDgCustomSet.Items[i]);
        DgSpecs.Add(lbDgCustomSet.Items[i]);
      end;
    sts.SaveToFile(d + '\GShell.' + AnsiLowerCase(UserInitials));
  finally
    sts.Free;
  end;
end;

procedure TfmCustomize.buDpRemoveClick(Sender: TObject);
var
  i : integer;
begin
  with lbDpCustomSet do
    begin
      for i := 0 to Items.Count-1 do
        if Selected[i] then
          if lbDpCompleteSet.Items.IndexOf(Items[i]) < 0 then
            lbDpCompleteSet.Items.Add(Items[i]);
      for i := Items.Count-1 downto 0 do
        if Selected[i] then
          lbDpCustomSet.Items.Delete(i);
    end;
end;

procedure TfmCustomize.buDgRemoveClick(Sender: TObject);
var
  i : integer;
begin
  with lbDgCustomSet do
    begin
      for i := 0 to Items.Count-1 do
        if Selected[i] then
          if lbDgCompleteSet.Items.IndexOf(Items[i]) < 0 then
            lbDgCompleteSet.Items.Add(Items[i]);
      for i := Items.Count-1 downto 0 do
        if Selected[i] then
          lbDgCustomSet.Items.Delete(i);
    end;
end;

procedure TfmCustomize.sbDpUpClick(Sender: TObject);
var
  n: integer;
begin
  if lbDpCustomSet.Selected[0] then
    Exit;
  if OkToMove(lbDpCustomSet,n) then
    begin
      lbDpCustomSet.Items.Move(n,n - 1);
      lbDpCustomSet.Selected[n - 1] := True;
    end;
end;

procedure TfmCustomize.sbDpDownClick(Sender: TObject);
var
  n: integer;
begin
  if lbDpCustomSet.Selected[lbDpCustomSet.Items.Count - 1] then
    Exit;
  if OkToMove(lbDpCustomSet,n) then
    begin
      lbDpCustomSet.Items.Move(n,n + 1);
      lbDpCustomSet.Selected[n + 1] := True;
    end;
end;

procedure TfmCustomize.sbDgUpClick(Sender: TObject);
var
  n: integer;
begin
  if lbDgCustomSet.Selected[0] then
    Exit;
  if OkToMove(lbDgCustomSet,n) then
    begin
      lbDgCustomSet.Items.Move(n,n - 1);
      lbDgCustomSet.Selected[n - 1] := True;
    end;
end;

procedure TfmCustomize.sbDgDownClick(Sender: TObject);
var
  n: integer;
begin
  if lbDgCustomSet.Selected[lbDgCustomSet.Items.Count - 1] then
    Exit;
  if OkToMove(lbDgCustomSet,n) then
    begin
      lbDgCustomSet.Items.Move(n,n + 1);
      lbDgCustomSet.Selected[n + 1] := True;
    end;
end;

procedure TfmCustomize.FormCreate(Sender: TObject);
begin
  Self.Caption := customiz_fmCustomize;
  buSave.Caption := customiz_buSave;
  buCancel.Caption := customiz_buCancel;
  tsDeposits.Caption := customiz_tsDeposits;
  laCompleteSet.Caption := customiz_laCompleteSet;
  laCustomSet.Caption := customiz_laCustomSet;
  buDpAddAll.Caption := customiz_buDpAddAll;
  buDpAdd.Caption := customiz_buDpAdd;
  buDpRemove.Caption := customiz_buDpRemove;
  buDpClear.Caption := customiz_buDpClear;
  tsDepositGroups.Caption := customiz_tsDepositGroups;
  Label1.Caption := customiz_Label1;
  Label2.Caption := customiz_Label2;
  buDgAddAll.Caption := customiz_buDgAddAll;
  buDgAdd.Caption := customiz_buDgAdd;
  buDgRemove.Caption := customiz_buDgRemove;
  buDgClear.Caption := customiz_buDgClear;
end;

end.
