unit dpqueries;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, StdCtrls, DBCtrls, ExtCtrls, DB, ADODB;

type
  TfmDPQueries = class(TForm)
    Panel1: TPanel;
    buClose: TButton;
    DBNavigator1: TDBNavigator;
    ComboBox1: TComboBox;
    DBGrid1: TDBGrid;
    ADODataSet1: TADODataSet;
    DataSource1: TDataSource;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure buCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmDPQueries: TfmDPQueries;
  dpqDEPNO: longint;

implementation

uses dmglob1, resources;

{$R *.dfm}

procedure TfmDPQueries.FormShow(Sender: TObject);
begin
  dpqDEPNO := 0;
end;

procedure TfmDPQueries.FormCreate(Sender: TObject);
var
  ql: TStringList;
  i: integer;
begin
  Self.Caption := dpqueries_fmDPQueries;
  buClose.Caption := dpqueries_buClose;
  ql := TStringList.Create;
  try
    dmGlobal.Database1.GetTableNames(ql);
    ComboBox1.Clear;
    for i := 0 to ql.Count - 1 do
      if AnsiUpperCase(Copy(ql.Strings[i],1,2)) = 'Q_' then
        ComboBox1.Items.Add(ql.Strings[i]);
  finally
    ql.Free;
  end;
end;

procedure TfmDPQueries.ComboBox1Select(Sender: TObject);
begin
  with ADODataSet1 do
    begin
      Close;
      CommandText := ComboBox1.Text;
      Open;
    end;
end;

procedure TfmDPQueries.DBGrid1DblClick(Sender: TObject);
var
  flds: TStringList;
begin
  flds := TStringList.Create;
  try
    dmGlobal.Database1.GetFieldNames(ADODataSet1.CommandText,flds);
    if flds.IndexOf('DEPNO') >= 0
      then
        begin
          dpqDEPNO := ADODataSet1.FieldByName('DEPNO').AsInteger;
          if dpqDEPNO > 0 then
            dmGlobal.dpgeol.Locate('DEPNO',dpqDEPNO,[]);
        end
      else
        begin
          dpqDEPNO := 0;
          MessageDlg(dpqueries_MissingDEPNO,mtWarning,[mbOK],0);
        end;
  finally
    flds.Free;
  end;
end;

procedure TfmDPQueries.buCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfmDPQueries.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ADODataSet1.Close;
end;

end.
