unit lookups;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DBCtrls, Grids, DBGrids;

type
  TfmLookupTables = class(TForm)
    dbgLookupTable: TDBGrid;
    dnLookupTable: TDBNavigator;
    paTop: TPanel;
    paClose: TPanel;
    buClose: TButton;
    paFiller: TPanel;
    dnLookup: TDBNavigator;
    dbgLookup: TDBGrid;
    edLookupTable: TEdit;
    laReadOnly: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure buCloseClick(Sender: TObject);
    procedure dbgLookupDblClick(Sender: TObject);
    procedure dnLookupClick(Sender: TObject; Button: TNavigateBtn);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure ShowLookupTable;
  public
    { Public declarations }
  end;

var
  fmLookupTables: TfmLookupTables;

implementation

uses mastform, dmglob1, resources;

{$R *.DFM}

procedure TfmLookupTables.ShowLookupTable;
var
  SelectedName : string;
begin
  with dmGlobal do
    begin
      SelectedName:= lookup.FieldByName('TABLENAME').Value;
      fmLookupTables.edLookupTable.Text := SelectedName;
      if lookup.FieldByName('READONLY').Value
        then
          begin
            fmLookupTables.laReadOnly.Visible := True;
            fmLookupTables.dbgLookupTable.ReadOnly := True;
            fmLookupTables.dnLookupTable.VisibleButtons := [nbFirst,nbPrior,nbNext,nbLast];
            fmLookupTables.dnLookupTable.Width := 96;
          end
        else
          begin
            fmLookupTables.laReadOnly.Visible := False;
            fmLookupTables.dbgLookupTable.ReadOnly := False;
            fmLookupTables.dnLookupTable.VisibleButtons := [nbFirst,nbPrior,nbNext,nbLast,nbInsert,nbDelete,nbEdit,nbPost,nbCancel];
            fmLookupTables.dnLookupTable.Width := 216;
          end;
      LookupTable.Active := False;
      LookupTable.TableName := SelectedName;
      LookupTable.Active := True;
    end;
end;

procedure TfmLookupTables.FormActivate(Sender: TObject);
begin
  with dmGlobal do
    begin
      Database1.Connected := True;
      lookup.Active := True;
      ShowLookupTable;
      buClose.SetFocus;
    end;
end;

procedure TfmLookupTables.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  with dmGlobal do
    begin
      lookup.Active := False;
      LookupTable.Active := False;
      Database1.Connected := False;
      fmMaster.miLookupTables.Enabled := True;
      fmMaster.sbLookupTables.Enabled := True;
    end;
end;

procedure TfmLookupTables.buCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfmLookupTables.dbgLookupDblClick(Sender: TObject);
begin
  ShowLookupTable;
end;

procedure TfmLookupTables.dnLookupClick(Sender: TObject;
  Button: TNavigateBtn);
begin
  ShowLookupTable;
end;

procedure TfmLookupTables.FormShow(Sender: TObject);
var
  h: TStringList;
begin
  h := TStringList.Create;
  try
    h.CommaText := DBNavigator_Hints;
    dnLookup.Hints := h;
    dnLookupTable.Hints := h;
  finally
    h.Free;
  end;
end;

procedure TfmLookupTables.FormCreate(Sender: TObject);
begin
  Self.Caption := lookups_fmLookupTables;
  buClose.Caption := lookups_buClose;
  laReadOnly.Caption := lookups_laReadOnly;
end;

end.
