unit selbysql;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Grids, DBGrids, StdCtrls, ExtCtrls;

type
  TfmSelectBySQL = class(TForm)
    paTop: TPanel;
    paSelect: TPanel;
    buSelect: TButton;
    paCancel: TPanel;
    buCancel: TButton;
    paFiller: TPanel;
    paGrid: TPanel;
    Rolodex: TTabControl;
    DBGrid1: TDBGrid;
    procedure DBGrid1DblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure buSelectClick(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RolodexMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure SetSelectedValues;
  public
    { Public declarations }
  end;

var
  fmSelectBySQL  : TfmSelectBySQL;
  SelectedNumber : longint;
  SelectedString : string;

implementation

uses dmglob1, resources;

{$R *.DFM}

procedure TfmSelectBySQL.SetSelectedValues;
var
  i: integer;
begin
  if dgMultiSelect in DBGrid1.Options
    then
      begin
        SelectedString := '';
        if DBGrid1.SelectedRows.Count > 0 then
          with DBGrid1.DataSource.DataSet do
            for i:=0 to DBGrid1.SelectedRows.Count-1 do
            begin
              Bookmark := DBGrid1.SelectedRows.Items[i];
              if i > 0 then
                SelectedString := SelectedString + ',';
              SelectedString := SelectedString + '''' + Fields[0].AsString + '''';
            end;
      end
    else
      begin
        SelectedString := dmGlobal.FindBySQL.Fields[0].Value;
        try
          SelectedNumber := dmGlobal.FindBySQL.Fields[0].Value;
        except
          on EVariantError do
            SelectedNumber := 0;
        end;
      end;
end;

procedure TfmSelectBySQL.FormActivate(Sender: TObject);
begin
  SelectedNumber := 0;
  SelectedString := '';
  dmGlobal.FindBySQL.Active := True;
  buSelect.Enabled := dmGlobal.FindBySQL.RecordCount > 0;
  if buSelect.Enabled
    then
      begin
        DBGrid1.Enabled := True;
        Rolodex.Enabled := True;
        Rolodex.TabIndex := 0;
      end
    else
      begin
        DBGrid1.Enabled := False;
        Rolodex.Enabled := False;
      end;
  buCancel.SetFocus;
end;

procedure TfmSelectBySQL.DBGrid1DblClick(Sender: TObject);
begin
  SetSelectedValues;
  Close;
end;

procedure TfmSelectBySQL.buSelectClick(Sender: TObject);
begin
  SetSelectedValues;
  Close;
end;

procedure TfmSelectBySQL.buCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfmSelectBySQL.FormClose(Sender: TObject;var Action: TCloseAction);
begin
  dmGlobal.FindBySQL.Active := False;
end;

procedure TfmSelectBySQL.RolodexMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  FirstLetter : Char;
  FirstRec,LastRec,MidRec : longint;
begin
  with dmGlobal.FindBySQL do
    begin
      FirstLetter := chr(65 + Rolodex.TabIndex);
      FirstRec := 1;
      LastRec := RecordCount;
      DisableControls;
      while LastRec > FirstRec do
        begin
          First;
          MidRec := (FirstRec + LastRec) div 2;
          MoveBy(MidRec-1);
          if AnsiUpperCase(Fields[2].Value) > FirstLetter
            then LastRec := Midrec
            else FirstRec := Midrec + 1;
        end;
      if AnsiUpperCase(Fields[2].Value) < FirstLetter then Next;
      EnableControls;
    end;
end;

procedure TfmSelectBySQL.FormCreate(Sender: TObject);
begin
  Self.Caption := selbysql_fmSelectBySQL;
  buSelect.Caption := selbysql_buSelect;
  buCancel.Caption := selbysql_buCancel;
end;

end.
