unit seldb;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, DBTables;

type
  TfmSelectDB = class(TForm)
    lbAlias: TListBox;
    buSelect: TButton;
    buAbort: TButton;
    OpenDialog1: TOpenDialog;
    procedure buSelectClick(Sender: TObject);
    procedure buAbortClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmSelectDB: TfmSelectDB;

implementation

uses dmglob1, mastform, resources;

{$R *.DFM}

procedure TfmSelectDB.buSelectClick(Sender: TObject);
begin
  with dmGlobal.Database1 do
    begin
      Connected := False;
      ConnectionString := 'File Name=' + lbAlias.Items[lbAlias.ItemIndex];
      if AnsiUpperCase(Copy(lbAlias.Items[lbAlias.ItemIndex],1,6)) = 'GLOBAL'
        then DatabaseUDL := DatabaseUDL + '\' + lbAlias.Items[lbAlias.ItemIndex]
        else DatabaseUDL := OpenDialog1.FileName;
      Connected := True;
    end; // with
  Close;
end;

procedure TfmSelectDB.buAbortClick(Sender: TObject);
begin
  dmGlobal.Database1.ConnectionString := '';
  Close;
end;

procedure TfmSelectDB.FormShow(Sender: TObject);
var
  d  : string;
  sr : TSearchRec;
begin
  GetDir(0,d);
  DatabaseUDL := d;
  if FindFirst(d + '\*.udl',faAnyFile,sr) = 0 then
    begin
      if AnsiLowerCase(copy(sr.Name,1,6)) = 'global' then
        lbAlias.Items.Add(sr.Name);
      while FindNext(sr) = 0 do
        if AnsiLowerCase(copy(sr.Name,1,6)) = 'global' then
          lbAlias.Items.Add(sr.Name);
      FindClose(sr);
    end;
  lbAlias.ItemIndex := 0;
  if lbAlias.Items.Count = 0 then
    begin
      with dmGlobal.Database1 do
        begin
          Connected := False;
          if OpenDialog1.Execute
            then
              begin
                lbAlias.Items.Add(OpenDialog1.FileName);
                lbAlias.ItemIndex := lbAlias.Items.IndexOf(OpenDialog1.FileName);
              end
            else
              begin
                ShowMessage(seldb_NoDatabaseSelected);
                Application.Terminate;
              end;
        end; // with
    end;
end;

procedure TfmSelectDB.FormCreate(Sender: TObject);
begin
  Self.Caption := seldb_fmSelectDB;
  buSelect.Caption := seldb_buSelect;
  buAbort.Caption := seldb_buAbort;
end;

end.
