unit seljourn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Grids, DBGrids, StdCtrls, ExtCtrls, DB;

type
  TfmSelectJournal = class(TForm)
    paTop: TPanel;
    paCancel: TPanel;
    buCancel: TButton;
    paSelect: TPanel;
    buSelect: TButton;
    paInsertNew: TPanel;
    buInsertNew: TButton;
    paFiller: TPanel;
    paGrid: TPanel;
    Rolodex: TTabControl;
    DBGrid1: TDBGrid;
    edStringSearch: TEdit;
    buStringSearch: TButton;
    buStringSearchNext: TButton;
    procedure DBGrid1DblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure buSelectClick(Sender: TObject);
    procedure buInsertNewClick(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RolodexMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure buStringSearchClick(Sender: TObject);
    procedure buStringSearchNextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure SetSelectedValues;
    procedure StringSearch(ff : boolean);
  public
    { Public declarations }
  end;

var
  fmSelectJournal: TfmSelectJournal;
  SelectedJournal : string;
  SelectedISSN    : string;

implementation

uses dmglob1, resources;

{$R *.DFM}

procedure TfmSelectJournal.SetSelectedValues;
begin
  with dmGlobal.journal do
    begin
      SelectedJournal := FieldByName('JOURNAL').Value;
      if not FieldByName('ISSN').IsNull
        then SelectedISSN := FieldByName('ISSN').Value
        else SelectedISSN := '';
    end;
end;

procedure TfmSelectJournal.StringSearch(ff : boolean);
var
  book_m  : TBookmarkStr;
  got_it  : boolean;
  sstring : string;
begin
  got_it := False;
  sstring := AnsiUpperCase(edStringSearch.Text);
  with dmGlobal.journal do
    begin
      book_m := Bookmark;
      if ff
        then First
        else Next;
      while not (EOF or got_it) do
        begin
          got_it := AnsiPos(sstring,AnsiUpperCase(FieldByName('JOURNAL').Value)) > 0;
          if not got_it then Next;
        end;
      if not got_it then
        begin
          Bookmark := book_m;
          ShowMessage(seljourn_StringNotFound);
        end;
    end;
end;

procedure TfmSelectJournal.FormActivate(Sender: TObject);
begin
  SelectedJournal := '';
  SelectedISSN := '';
  DBGrid1.ReadOnly := True;
  edStringSearch.Text := '';
  dmGlobal.journal.Active := True;
  Rolodex.TabIndex := 0;
  buCancel.SetFocus;
end;

procedure TfmSelectJournal.DBGrid1DblClick(Sender: TObject);
begin
  with dmGlobal.journal do
    begin
      if State in [dsEdit,dsInsert]
        then Post;
    end;
  SetSelectedValues;
  Close;
end;

procedure TfmSelectJournal.buSelectClick(Sender: TObject);
begin
  with dmGlobal.journal do
    begin
      if State in [dsEdit,dsInsert]
        then Post; 
    end;
  SetSelectedValues;
  Close;
end;

procedure TfmSelectJournal.buInsertNewClick(Sender: TObject);
begin
  dmGlobal.journal.Insert;
  DBGrid1.ReadOnly := False;
  DBGrid1.SetFocus;
end;

procedure TfmSelectJournal.buCancelClick(Sender: TObject);
begin
  with dmGlobal.journal do
    if State in [dsEdit,dsInsert] then
      if MessageDlg(seljourn_KeepChanges,mtConfirmation,[mbYes,mbNo],0) = mrYes
        then Post
        else Cancel;
  Close;
end;

procedure TfmSelectJournal.FormClose(Sender: TObject;var Action: TCloseAction);
begin
  dmGlobal.journal.Active := False;
end;

procedure TfmSelectJournal.RolodexMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  dmGlobal.journal.Locate('JOURNAL',chr(65 + Rolodex.TabIndex),[loPartialKey]);
end;

procedure TfmSelectJournal.buStringSearchClick(Sender: TObject);
begin
  StringSearch(True);
end;

procedure TfmSelectJournal.buStringSearchNextClick(Sender: TObject);
begin
  StringSearch(False);
end;

procedure TfmSelectJournal.FormCreate(Sender: TObject);
begin
  Self.Caption := seljourn_fmSelectJournal;
  buSelect.Caption := seljourn_buSelect;
  buInsertNew.Caption := seljourn_buInsertNew;
  buStringSearch.Caption := seljourn_buStringSearch;
  buStringSearchNext.Caption := seljourn_buStringSearchNext;
  buCancel.Caption := seljourn_buCancel;
end;

end.
