unit selnews;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Grids, DBGrids, StdCtrls, ExtCtrls, DB;

type
  TfmSelectNewsname = class(TForm)
    paTop: TPanel;
    paSelect: TPanel;
    buSelect: TButton;
    paInsertNew: TPanel;
    buInsertNew: TButton;
    paCancel: TPanel;
    buCancel: TButton;
    paFiller: TPanel;
    paGrid: TPanel;
    Rolodex: TTabControl;
    DBGrid1: TDBGrid;
    procedure DBGrid1DblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure buSelectClick(Sender: TObject);
    procedure buInsertNewClick(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RolodexMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure SetSelectedValues;
  public
    { Public declarations }
  end;

var
  fmSelectNewsname: TfmSelectNewsname;
  SelectedNewsname : string;

implementation

uses dmglob1, resources;

{$R *.DFM}

procedure TfmSelectNewsname.SetSelectedValues;
begin
  SelectedNewsname := dmGlobal.newsname.FieldByName('NEWSNAME').Value;
end;

procedure TfmSelectNewsname.FormActivate(Sender: TObject);
begin
  SelectedNewsname := '';
  DBGrid1.ReadOnly := True;
  dmGlobal.newsname.Active := True;
  Rolodex.TabIndex := 0;
  buCancel.SetFocus;
end;

procedure TfmSelectNewsname.DBGrid1DblClick(Sender: TObject);
begin
  with dmGlobal.newsname do
    begin
      if State in [dsEdit,dsInsert]
        then Post;
    end;
  SetSelectedValues;
  Close;
end;

procedure TfmSelectNewsname.buSelectClick(Sender: TObject);
begin
  with dmGlobal.newsname do
    begin
      if State in [dsEdit,dsInsert]
        then Post;
    end;
  SetSelectedValues;
  Close;
end;

procedure TfmSelectNewsname.buInsertNewClick(Sender: TObject);
begin
  dmGlobal.newsname.Insert;
  DBGrid1.ReadOnly := False;
  DBGrid1.SetFocus;
end;

procedure TfmSelectNewsname.buCancelClick(Sender: TObject);
begin
  with dmGlobal.newsname do
    if State in [dsEdit,dsInsert] then
      if MessageDlg(selnews_KeepChanges,mtConfirmation,[mbYes,mbNo],0) = mrYes
        then Post
        else Cancel;
  Close;
end;

procedure TfmSelectNewsname.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  dmGlobal.newsname.Active := False;
end;

procedure TfmSelectNewsname.RolodexMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  dmGlobal.newsname.Locate('NEWSNAME',chr(65 + Rolodex.TabIndex),[loPartialKey]);
end;

procedure TfmSelectNewsname.FormCreate(Sender: TObject);
begin
  Self.Caption := selnews_fmSelectNewsname;
  buSelect.Caption := selnews_buSelect;
  buInsertNew.Caption := selnews_buInsertNew;
  buCancel.Caption := selnews_buCancel;
end;

end.
