unit selsvol;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Grids, DBGrids, StdCtrls, ExtCtrls, DB;

type
  TfmSelectSvol = class(TForm)
    paTop: TPanel;
    paSelect: TPanel;
    buSelect: TButton;
    paCancel: TPanel;
    buCancel: TButton;
    paFiller: TPanel;
    paGrid: TPanel;
    Rolodex: TTabControl;
    DBGrid1: TDBGrid;
    edStringSearch: TEdit;
    buStringSearch: TButton;
    buStringSearchNext: TButton;
    procedure DBGrid1DblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure buSelectClick(Sender: TObject);
    procedure buCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RolodexMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure buStringSearchClick(Sender: TObject);
    procedure buStringSearchNextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure SetSelectedValues;
    procedure StringSearch(ff : boolean);
  public
    { Public declarations }
  end;

var
  fmSelectSvol: TfmSelectSvol;
  SelectedSvol : longint;

implementation

uses dmglob1, resources;

{$R *.DFM}

procedure TfmSelectSvol.SetSelectedValues;
begin
  SelectedSvol := dmGlobal.FindSvol.FieldByName('SVOLREFNO').Value;
end;

procedure TfmSelectSvol.StringSearch(ff : boolean);
var
  book_m  : TBookmarkStr;
  got_it  : boolean;
  sstring : string;
begin
  got_it := False;
  sstring := AnsiUpperCase(edStringSearch.Text);
  with dmGlobal.FindSvol do
    begin
      book_m := Bookmark;
      if ff
        then First
        else Next;
      while not (EOF or got_it) do
        begin
          got_it := AnsiPos(sstring,AnsiUpperCase(Fields[2].Value)) > 0;
          if not got_it then Next;
        end;
      if not got_it then
        begin
          Bookmark := book_m;
          ShowMessage(selsvol_StringNotFound);
        end;
    end;
end;

procedure TfmSelectSvol.FormActivate(Sender: TObject);
begin
  SelectedSvol := 0;
  dmGlobal.FindSvol.Active := True;
  Rolodex.TabIndex := 0;
  edStringSearch.Text := '';
  buCancel.SetFocus;
end;

procedure TfmSelectSvol.DBGrid1DblClick(Sender: TObject);
begin
  SetSelectedValues;
  Close;
end;

procedure TfmSelectSvol.buSelectClick(Sender: TObject);
begin
  SetSelectedValues;
  Close;
end;

procedure TfmSelectSvol.buCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfmSelectSvol.FormClose(Sender: TObject;var Action: TCloseAction);
begin
  dmGlobal.FindSvol.Active := False;
end;

procedure TfmSelectSvol.RolodexMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  FirstLetter : Char;
  FirstRec,LastRec,MidRec : longint;
begin
  with dmGlobal.FindSvol do
    begin
      FirstLetter := chr(65 + Rolodex.TabIndex);
      FirstRec := 1;
      LastRec := RecordCount;
      DisableControls;
      while LastRec > FirstRec do
        begin
          First;
          MidRec := (FirstRec + LastRec) div 2;
          MoveBy(MidRec-1);
          if AnsiUpperCase(FieldByName('TITLE').Value) > FirstLetter
            then LastRec := Midrec
            else FirstRec := Midrec + 1;
        end;
      if AnsiUpperCase(FieldByName('TITLE').Value) < FirstLetter then Next;
      EnableControls;
    end;
end;

procedure TfmSelectSvol.buStringSearchClick(Sender: TObject);
begin
  StringSearch(True);
end;

procedure TfmSelectSvol.buStringSearchNextClick(Sender: TObject);
begin
  StringSearch(False);
end;

procedure TfmSelectSvol.FormCreate(Sender: TObject);
begin
  Self.Caption := selsvol_fmSelectSvol;
  buSelect.Caption := selsvol_buSelect;
  buStringSearch.Caption := selsvol_buStringSearch;
  buStringSearchNext.Caption := selsvol_buStringSearchNext;
  buCancel.Caption := selsvol_buCancel;
end;

end.
